#include "galahad_blas.h"

#ifdef INTEGER_64
#ifdef GALAHAD_LAPACK
#define IEEECK GALAHAD_IEEECK_64
#define ILAENV GALAHAD_ILAENV_64
#define ILAENV2 GALAHAD_ILAENV2_64
#define IPARMQ GALAHAD_IPARMQ_64
#else
#ifdef NO_UNDERSCORE_INTEGER_64
#define IEEECK IEEECK64
#define ILAENV ILAENV64
#define ILAENV2 ILAENV264
#define IPARMQ IPARMQ64
#elif DOUBLE_UNDERSCORE_INTEGER_64
#define IEEECK IEEECK__64
#define ILAENV ILAENV__64
#define ILAENV2 ILAENV2__64
#define IPARMQ IPARMQ__64
#elif NO_SYMBOL_INTEGER_64
#else
#define IEEECK IEEECK_64
#define ILAENV ILAENV_64
#define ILAENV2 ILAENV2_64
#define IPARMQ IPARMQ_64
#endif
#endif
#else
#ifdef GALAHAD_LAPACK
#define IEEECK GALAHAD_IEEECK
#define ILAENV GALAHAD_ILAENV
#define ILAENV2 GALAHAD_ILAENV2
#define IPARMQ GALAHAD_IPARMQ
#endif
#endif

#ifdef REAL_32
#ifdef INTEGER_64

#ifdef GALAHAD_LAPACK
#define DBDSQR     GALAHAD_SBDSQR_64
#define DCOMBS     GALAHAD_SCOMBS_64
#define DCOMBSSQ   GALAHAD_SCOMBSSQ_64
#define DGEBD2     GALAHAD_SGEBD2_64
#define DGEBRD     GALAHAD_SGEBRD_64
#define DGEHD2     GALAHAD_SGEHD2_64
#define DGEHRD     GALAHAD_SGEHRD_64
#define DGELQ2     GALAHAD_SGELQ2_64
#define DGELQF     GALAHAD_SGELQF_64
#define DGELS      GALAHAD_SGELS_64
#define DGELSD     GALAHAD_SGELSD_64
#define DGELSS     GALAHAD_SGELSS_64
#define DGELSY     GALAHAD_SGELSY_64
#define DGEQP3     GALAHAD_SGEQP3_64
#define DGEQR2     GALAHAD_SGEQR2_64
#define DGEQRF     GALAHAD_SGEQRF_64
#define DGESV      GALAHAD_SGESV_64
#define DGESVD     GALAHAD_SGESVD_64
#define DGETF2     GALAHAD_SGETF2_64
#define DGETRF     GALAHAD_SGETRF_64
#define DGETRF2    GALAHAD_SGETRF2_64
#define DGETRS     GALAHAD_SGETRS_64
#define DHSEQR     GALAHAD_SHSEQR_64
#define DISNAN     GALAHAD_SISNAN_64
#define DLABAD     GALAHAD_SLABAD_64
#define DLABRD     GALAHAD_SLABRD_64
#define DLACPY     GALAHAD_SLACPY_64
#define DLAE2      GALAHAD_SLAE2_64
#define DLAED6     GALAHAD_SLAED6_64
#define DLAEV2     GALAHAD_SLAEV2_64
#define DLAEXC     GALAHAD_SLAEXC_64
#define DLAHQR     GALAHAD_SLAHQR_64
#define DLAHR2     GALAHAD_SLAHR2_64
#define DLAIC1     GALAHAD_SLAIC1_64
#define DLAISN     GALAHAD_SLAISN_64
#define DLAISNAN   GALAHAD_SLAISNAN_64
#define DLALS0     GALAHAD_SLALS0_64
#define DLALSA     GALAHAD_SLALSA_64
#define DLALSD     GALAHAD_SLALSD_64
#define DLAMC3     GALAHAD_SLAMC3_64
#define DLAMCH     GALAHAD_SLAMCH_64
#define DLAMRG     GALAHAD_SLAMRG_64
#define DLANGE     GALAHAD_SLANGE_64
#define DLANST     GALAHAD_SLANST_64
#define DLANSY     GALAHAD_SLANSY_64
#define DLANV2     GALAHAD_SLANV2_64
#define DLAPY2     GALAHAD_SLAPY2_64
#define DLAQP2     GALAHAD_SLAQP2_64
#define DLAQPS     GALAHAD_SLAQPS_64
#define DLAQR0     GALAHAD_SLAQR0_64
#define DLAQR1     GALAHAD_SLAQR1_64
#define DLAQR2     GALAHAD_SLAQR2_64
#define DLAQR3     GALAHAD_SLAQR3_64
#define DLAQR4     GALAHAD_SLAQR4_64
#define DLAQR5     GALAHAD_SLAQR5_64
#define DLARF      GALAHAD_SLARF_64
#define DLARFB     GALAHAD_SLARFB_64
#define DLARFG     GALAHAD_SLARFG_64
#define DLARFT     GALAHAD_SLARFT_64
#define DLARFX     GALAHAD_SLARFX_64
#define DLARTG     GALAHAD_SLARTG_64
#define DLARZ      GALAHAD_SLARZ_64
#define DLARZB     GALAHAD_SLARZB_64
#define DLARZT     GALAHAD_SLARZT_64
#define DLAS2      GALAHAD_SLAS2_64
#define DLASCL     GALAHAD_SLASCL_64
#define DLASD4     GALAHAD_SLASD4_64
#define DLASD5     GALAHAD_SLASD5_64
#define DLASD6     GALAHAD_SLASD6_64
#define DLASD7     GALAHAD_SLASD7_64
#define DLASD8     GALAHAD_SLASD8_64
#define DLASDA     GALAHAD_SLASDA_64
#define DLASDQ     GALAHAD_SLASDQ_64
#define DLASDT     GALAHAD_SLASDT_64
#define DLASET     GALAHAD_SLASET_64
#define DLASQ1     GALAHAD_SLASQ1_64
#define DLASQ2     GALAHAD_SLASQ2_64
#define DLASQ3     GALAHAD_SLASQ3_64
#define DLASQ4     GALAHAD_SLASQ4_64
#define DLASQ5     GALAHAD_SLASQ5_64
#define DLASQ6     GALAHAD_SLASQ6_64
#define DLASR      GALAHAD_SLASR_64
#define DLASRT     GALAHAD_SLASRT_64
#define DLASSQ     GALAHAD_SLASSQ_64
#define DLASV2     GALAHAD_SLASV2_64
#define DLASWP     GALAHAD_SLASWP_64
#define DLASY2     GALAHAD_SLASY2_64
#define DLASYF     GALAHAD_SLASYF_64
#define DLATRD     GALAHAD_SLATRD_64
#define DLATRZ     GALAHAD_SLATRZ_64
#define DORG2L     GALAHAD_SORG2L_64
#define DORG2R     GALAHAD_SORG2R_64
#define DORGBR     GALAHAD_SORGBR_64
#define DORGL2     GALAHAD_SORGL2_64
#define DORGLQ     GALAHAD_SORGLQ_64
#define DORGQL     GALAHAD_SORGQL_64
#define DORGQR     GALAHAD_SORGQR_64
#define DORGTR     GALAHAD_SORGTR_64
#define DORM2R     GALAHAD_SORM2R_64
#define DORMBR     GALAHAD_SORMBR_64
#define DORMHR     GALAHAD_SORMHR_64
#define DORML2     GALAHAD_SORML2_64
#define DORMLQ     GALAHAD_SORMLQ_64
#define DORMQR     GALAHAD_SORMQR_64
#define DORMR3     GALAHAD_SORMR3_64
#define DORMRZ     GALAHAD_SORMRZ_64
#define DPBTF2     GALAHAD_SPBTF2_64
#define DPBTRF     GALAHAD_SPBTRF_64
#define DPBTRS     GALAHAD_SPBTRS_64
#define DPOTF2     GALAHAD_SPOTF2_64
#define DPOTRF     GALAHAD_SPOTRF_64
#define DPOTRF2    GALAHAD_SPOTRF2_64
#define DPOTRS     GALAHAD_SPOTRS_64
#define DPTTRF     GALAHAD_SPTTRF_64
#define DPTTRS     GALAHAD_SPTTRS_64
#define DPTTS2     GALAHAD_SPTTS2_64
#define DRSCL      GALAHAD_SRSCL_64
#define DSTEQR     GALAHAD_SSTEQR_64
#define DSTERF     GALAHAD_SSTERF_64
#define DSYEV      GALAHAD_SSYEV_64
#define DSYGS2     GALAHAD_SSYGS2_64
#define DSYGST     GALAHAD_SSYGST_64
#define DSYGV      GALAHAD_SSYGV_64
#define DSYTD2     GALAHAD_SSYTD2_64
#define DSYTF2     GALAHAD_SSYTF2_64
#define DSYTRD     GALAHAD_SSYTRD_64
#define DSYTRF     GALAHAD_SSYTRF_64
#define DSYTRS     GALAHAD_SSYTRS_64
#define DTREXC     GALAHAD_STREXC_64
#define DTRTRS     GALAHAD_STRTRS_64
#define DTZRZF     GALAHAD_STZRZF_64
#define ILADLC     GALAHAD_ILASLC_64
#define ILADLR     GALAHAD_ILASLR_64
#else
#ifdef NO_UNDERSCORE_INTEGER_64
#define DBDSQR     SBDSQR64
#define DCOMBS     SCOMBS64
#define DCOMBSSQ   SCOMBSSQ64
#define DGEBD2     SGEBD264
#define DGEBRD     SGEBRD64
#define DGEHD2     SGEHD264
#define DGEHRD     SGEHRD64
#define DGELQ2     SGELQ264
#define DGELQF     SGELQF64
#define DGELS      SGELS64
#define DGELSD     SGELSD64
#define DGELSS     SGELSS64
#define DGELSY     SGELSY64
#define DGEQP3     SGEQP364
#define DGEQR2     SGEQR264
#define DGEQRF     SGEQRF64
#define DGESV      SGESV64
#define DGESVD     SGESVD64
#define DGETF2     SGETF264
#define DGETRF     SGETRF64
#define DGETRF2    SGETRF264
#define DGETRS     SGETRS64
#define DHSEQR     SHSEQR64
#define DISNAN     SISNAN64
#define DLABAD     SLABAD64
#define DLABRD     SLABRD64
#define DLACPY     SLACPY64
#define DLAE2      SLAE264
#define DLAED6     SLAED664
#define DLAEV2     SLAEV264
#define DLAEXC     SLAEXC64
#define DLAHQR     SLAHQR64
#define DLAHR2     SLAHR264
#define DLAIC1     SLAIC164
#define DLAISN     SLAISN64
#define DLAISNAN   SLAISNAN64
#define DLALS0     SLALS064
#define DLALSA     SLALSA64
#define DLALSD     SLALSD64
#define DLAMC3     SLAMC364
#define DLAMCH     SLAMCH64
#define DLAMRG     SLAMRG64
#define DLANGE     SLANGE64
#define DLANST     SLANST64
#define DLANSY     SLANSY64
#define DLANV2     SLANV264
#define DLAPY2     SLAPY264
#define DLAQP2     SLAQP264
#define DLAQPS     SLAQPS64
#define DLAQR0     SLAQR064
#define DLAQR1     SLAQR164
#define DLAQR2     SLAQR264
#define DLAQR3     SLAQR364
#define DLAQR4     SLAQR464
#define DLAQR5     SLAQR564
#define DLARF      SLARF64
#define DLARFB     SLARFB64
#define DLARFG     SLARFG64
#define DLARFT     SLARFT64
#define DLARFX     SLARFX64
#define DLARTG     SLARTG64
#define DLARZ      SLARZ64
#define DLARZB     SLARZB64
#define DLARZT     SLARZT64
#define DLAS2      SLAS264
#define DLASCL     SLASCL64
#define DLASD4     SLASD464
#define DLASD5     SLASD564
#define DLASD6     SLASD664
#define DLASD7     SLASD764
#define DLASD8     SLASD864
#define DLASDA     SLASDA64
#define DLASDQ     SLASDQ64
#define DLASDT     SLASDT64
#define DLASET     SLASET64
#define DLASQ1     SLASQ164
#define DLASQ2     SLASQ264
#define DLASQ3     SLASQ364
#define DLASQ4     SLASQ464
#define DLASQ5     SLASQ564
#define DLASQ6     SLASQ664
#define DLASR      SLASR64
#define DLASRT     SLASRT64
#define DLASSQ     SLASSQ64
#define DLASV2     SLASV264
#define DLASWP     SLASWP64
#define DLASY2     SLASY264
#define DLASYF     SLASYF64
#define DLATRD     SLATRD64
#define DLATRZ     SLATRZ64
#define DORG2L     SORG2L64
#define DORG2R     SORG2R64
#define DORGBR     SORGBR64
#define DORGL2     SORGL264
#define DORGLQ     SORGLQ64
#define DORGQL     SORGQL64
#define DORGQR     SORGQR64
#define DORGTR     SORGTR64
#define DORM2R     SORM2R64
#define DORMBR     SORMBR64
#define DORMHR     SORMHR64
#define DORML2     SORML264
#define DORMLQ     SORMLQ64
#define DORMQR     SORMQR64
#define DORMR3     SORMR364
#define DORMRZ     SORMRZ64
#define DPBTF2     SPBTF264
#define DPBTRF     SPBTRF64
#define DPBTRS     SPBTRS64
#define DPOTF2     SPOTF264
#define DPOTRF     SPOTRF64
#define DPOTRF2    SPOTRF264
#define DPOTRS     SPOTRS64
#define DPTTRF     SPTTRF64
#define DPTTRS     SPTTRS64
#define DPTTS2     SPTTS264
#define DRSCL      SRSCL64
#define DSTEQR     SSTEQR64
#define DSTERF     SSTERF64
#define DSYEV      SSYEV64
#define DSYGS2     SSYGS264
#define DSYGST     SSYGST64
#define DSYGV      SSYGV64
#define DSYTD2     SSYTD264
#define DSYTF2     SSYTF264
#define DSYTRD     SSYTRD64
#define DSYTRF     SSYTRF64
#define DSYTRS     SSYTRS64
#define DTREXC     STREXC64
#define DTRTRS     STRTRS64
#define DTZRZF     STZRZF64
#define ILADLC     ILASLC64
#define ILADLR     ILASLR64
#elif DOUBLE_UNDERSCORE_INTEGER_64
#define DBDSQR     SBDSQR__64
#define DCOMBS     SCOMBS__64
#define DCOMBSSQ   SCOMBSSQ__64
#define DGEBD2     SGEBD2__64
#define DGEBRD     SGEBRD__64
#define DGEHD2     SGEHD2__64
#define DGEHRD     SGEHRD__64
#define DGELQ2     SGELQ2__64
#define DGELQF     SGELQF__64
#define DGELS      SGELS__64
#define DGELSD     SGELSD__64
#define DGELSS     SGELSS__64
#define DGELSY     SGELSY__64
#define DGEQP3     SGEQP3__64
#define DGEQR2     SGEQR2__64
#define DGEQRF     SGEQRF__64
#define DGESV      SGESV__64
#define DGESVD     SGESVD__64
#define DGETF2     SGETF2__64
#define DGETRF     SGETRF__64
#define DGETRF2    SGETRF2__64
#define DGETRS     SGETRS__64
#define DHSEQR     SHSEQR__64
#define DISNAN     SISNAN__64
#define DLABAD     SLABAD__64
#define DLABRD     SLABRD__64
#define DLACPY     SLACPY__64
#define DLAE2      SLAE2__64
#define DLAED6     SLAED6__64
#define DLAEV2     SLAEV2__64
#define DLAEXC     SLAEXC__64
#define DLAHQR     SLAHQR__64
#define DLAHR2     SLAHR2__64
#define DLAIC1     SLAIC1__64
#define DLAISN     SLAISN__64
#define DLAISNAN   SLAISNAN__64
#define DLALS0     SLALS0__64
#define DLALSA     SLALSA__64
#define DLALSD     SLALSD__64
#define DLAMC3     SLAMC3__64
#define DLAMCH     SLAMCH__64
#define DLAMRG     SLAMRG__64
#define DLANGE     SLANGE__64
#define DLANST     SLANST__64
#define DLANSY     SLANSY__64
#define DLANV2     SLANV2__64
#define DLAPY2     SLAPY2__64
#define DLAQP2     SLAQP2__64
#define DLAQPS     SLAQPS__64
#define DLAQR0     SLAQR0__64
#define DLAQR1     SLAQR1__64
#define DLAQR2     SLAQR2__64
#define DLAQR3     SLAQR3__64
#define DLAQR4     SLAQR4__64
#define DLAQR5     SLAQR5__64
#define DLARF      SLARF__64
#define DLARFB     SLARFB__64
#define DLARFG     SLARFG__64
#define DLARFT     SLARFT__64
#define DLARFX     SLARFX__64
#define DLARTG     SLARTG__64
#define DLARZ      SLARZ__64
#define DLARZB     SLARZB__64
#define DLARZT     SLARZT__64
#define DLAS2      SLAS2__64
#define DLASCL     SLASCL__64
#define DLASD4     SLASD4__64
#define DLASD5     SLASD5__64
#define DLASD6     SLASD6__64
#define DLASD7     SLASD7__64
#define DLASD8     SLASD8__64
#define DLASDA     SLASDA__64
#define DLASDQ     SLASDQ__64
#define DLASDT     SLASDT__64
#define DLASET     SLASET__64
#define DLASQ1     SLASQ1__64
#define DLASQ2     SLASQ2__64
#define DLASQ3     SLASQ3__64
#define DLASQ4     SLASQ4__64
#define DLASQ5     SLASQ5__64
#define DLASQ6     SLASQ6__64
#define DLASR      SLASR__64
#define DLASRT     SLASRT__64
#define DLASSQ     SLASSQ__64
#define DLASV2     SLASV2__64
#define DLASWP     SLASWP__64
#define DLASY2     SLASY2__64
#define DLASYF     SLASYF__64
#define DLATRD     SLATRD__64
#define DLATRZ     SLATRZ__64
#define DORG2L     SORG2L__64
#define DORG2R     SORG2R__64
#define DORGBR     SORGBR__64
#define DORGL2     SORGL2__64
#define DORGLQ     SORGLQ__64
#define DORGQL     SORGQL__64
#define DORGQR     SORGQR__64
#define DORGTR     SORGTR__64
#define DORM2R     SORM2R__64
#define DORMBR     SORMBR__64
#define DORMHR     SORMHR__64
#define DORML2     SORML2__64
#define DORMLQ     SORMLQ__64
#define DORMQR     SORMQR__64
#define DORMR3     SORMR3__64
#define DORMRZ     SORMRZ__64
#define DPBTF2     SPBTF2__64
#define DPBTRF     SPBTRF__64
#define DPBTRS     SPBTRS__64
#define DPOTF2     SPOTF2__64
#define DPOTRF     SPOTRF__64
#define DPOTRF2    SPOTRF2__64
#define DPOTRS     SPOTRS__64
#define DPTTRF     SPTTRF__64
#define DPTTRS     SPTTRS__64
#define DPTTS2     SPTTS2__64
#define DRSCL      SRSCL__64
#define DSTEQR     SSTEQR__64
#define DSTERF     SSTERF__64
#define DSYEV      SSYEV__64
#define DSYGS2     SSYGS2__64
#define DSYGST     SSYGST__64
#define DSYGV      SSYGV__64
#define DSYTD2     SSYTD2__64
#define DSYTF2     SSYTF2__64
#define DSYTRD     SSYTRD__64
#define DSYTRF     SSYTRF__64
#define DSYTRS     SSYTRS__64
#define DTREXC     STREXC__64
#define DTRTRS     STRTRS__64
#define DTZRZF     STZRZF__64
#define ILADLC     ILASLC__64
#define ILADLR     ILASLR__64
#elif NO_SYMBOL_INTEGER_64
#define DBDSQR     SBDSQR
#define DCOMBS     SCOMBS
#define DCOMBSSQ   SCOMBSSQ
#define DGEBD2     SGEBD2
#define DGEBRD     SGEBRD
#define DGEHD2     SGEHD2
#define DGEHRD     SGEHRD
#define DGELQ2     SGELQ2
#define DGELQF     SGELQF
#define DGELS      SGELS
#define DGELSD     SGELSD
#define DGELSS     SGELSS
#define DGELSY     SGELSY
#define DGEQP3     SGEQP3
#define DGEQR2     SGEQR2
#define DGEQRF     SGEQRF
#define DGESV      SGESV
#define DGESVD     SGESVD
#define DGETF2     SGETF2
#define DGETRF     SGETRF
#define DGETRF2    SGETRF2
#define DGETRS     SGETRS
#define DHSEQR     SHSEQR
#define DISNAN     SISNAN
#define DLABAD     SLABAD
#define DLABRD     SLABRD
#define DLACPY     SLACPY
#define DLAE2      SLAE2
#define DLAED6     SLAED6
#define DLAEV2     SLAEV2
#define DLAEXC     SLAEXC
#define DLAHQR     SLAHQR
#define DLAHR2     SLAHR2
#define DLAIC1     SLAIC1
#define DLAISN     SLAISN
#define DLAISNAN   SLAISNAN
#define DLALS0     SLALS0
#define DLALSA     SLALSA
#define DLALSD     SLALSD
#define DLAMC3     SLAMC3
#define DLAMCH     SLAMCH
#define DLAMRG     SLAMRG
#define DLANGE     SLANGE
#define DLANST     SLANST
#define DLANSY     SLANSY
#define DLANV2     SLANV2
#define DLAPY2     SLAPY2
#define DLAQP2     SLAQP2
#define DLAQPS     SLAQPS
#define DLAQR0     SLAQR0
#define DLAQR1     SLAQR1
#define DLAQR2     SLAQR2
#define DLAQR3     SLAQR3
#define DLAQR4     SLAQR4
#define DLAQR5     SLAQR5
#define DLARF      SLARF
#define DLARFB     SLARFB
#define DLARFG     SLARFG
#define DLARFT     SLARFT
#define DLARFX     SLARFX
#define DLARTG     SLARTG
#define DLARZ      SLARZ
#define DLARZB     SLARZB
#define DLARZT     SLARZT
#define DLAS2      SLAS2
#define DLASCL     SLASCL
#define DLASD4     SLASD4
#define DLASD5     SLASD5
#define DLASD6     SLASD6
#define DLASD7     SLASD7
#define DLASD8     SLASD8
#define DLASDA     SLASDA
#define DLASDQ     SLASDQ
#define DLASDT     SLASDT
#define DLASET     SLASET
#define DLASQ1     SLASQ1
#define DLASQ2     SLASQ2
#define DLASQ3     SLASQ3
#define DLASQ4     SLASQ4
#define DLASQ5     SLASQ5
#define DLASQ6     SLASQ6
#define DLASR      SLASR
#define DLASRT     SLASRT
#define DLASSQ     SLASSQ
#define DLASV2     SLASV2
#define DLASWP     SLASWP
#define DLASY2     SLASY2
#define DLASYF     SLASYF
#define DLATRD     SLATRD
#define DLATRZ     SLATRZ
#define DORG2L     SORG2L
#define DORG2R     SORG2R
#define DORGBR     SORGBR
#define DORGL2     SORGL2
#define DORGLQ     SORGLQ
#define DORGQL     SORGQL
#define DORGQR     SORGQR
#define DORGTR     SORGTR
#define DORM2R     SORM2R
#define DORMBR     SORMBR
#define DORMHR     SORMHR
#define DORML2     SORML2
#define DORMLQ     SORMLQ
#define DORMQR     SORMQR
#define DORMR3     SORMR3
#define DORMRZ     SORMRZ
#define DPBTF2     SPBTF2
#define DPBTRF     SPBTRF
#define DPBTRS     SPBTRS
#define DPOTF2     SPOTF2
#define DPOTRF     SPOTRF
#define DPOTRF2    SPOTRF2
#define DPOTRS     SPOTRS
#define DPTTRF     SPTTRF
#define DPTTRS     SPTTRS
#define DPTTS2     SPTTS2
#define DRSCL      SRSCL
#define DSTEQR     SSTEQR
#define DSTERF     SSTERF
#define DSYEV      SSYEV
#define DSYGS2     SSYGS2
#define DSYGST     SSYGST
#define DSYGV      SSYGV
#define DSYTD2     SSYTD2
#define DSYTF2     SSYTF2
#define DSYTRD     SSYTRD
#define DSYTRF     SSYTRF
#define DSYTRS     SSYTRS
#define DTREXC     STREXC
#define DTRTRS     STRTRS
#define DTZRZF     STZRZF
#define ILADLC     ILASLC
#define ILADLR     ILASLR
#else
#define DBDSQR     SBDSQR_64
#define DCOMBS     SCOMBS_64
#define DCOMBSSQ   SCOMBSSQ_64
#define DGEBD2     SGEBD2_64
#define DGEBRD     SGEBRD_64
#define DGEHD2     SGEHD2_64
#define DGEHRD     SGEHRD_64
#define DGELQ2     SGELQ2_64
#define DGELQF     SGELQF_64
#define DGELS      SGELS_64
#define DGELSD     SGELSD_64
#define DGELSS     SGELSS_64
#define DGELSY     SGELSY_64
#define DGEQP3     SGEQP3_64
#define DGEQR2     SGEQR2_64
#define DGEQRF     SGEQRF_64
#define DGESV      SGESV_64
#define DGESVD     SGESVD_64
#define DGETF2     SGETF2_64
#define DGETRF     SGETRF_64
#define DGETRF2    SGETRF2_64
#define DGETRS     SGETRS_64
#define DHSEQR     SHSEQR_64
#define DISNAN     SISNAN_64
#define DLABAD     SLABAD_64
#define DLABRD     SLABRD_64
#define DLACPY     SLACPY_64
#define DLAE2      SLAE2_64
#define DLAED6     SLAED6_64
#define DLAEV2     SLAEV2_64
#define DLAEXC     SLAEXC_64
#define DLAHQR     SLAHQR_64
#define DLAHR2     SLAHR2_64
#define DLAIC1     SLAIC1_64
#define DLAISN     SLAISN_64
#define DLAISNAN   SLAISNAN_64
#define DLALS0     SLALS0_64
#define DLALSA     SLALSA_64
#define DLALSD     SLALSD_64
#define DLAMC3     SLAMC3_64
#define DLAMCH     SLAMCH_64
#define DLAMRG     SLAMRG_64
#define DLANGE     SLANGE_64
#define DLANST     SLANST_64
#define DLANSY     SLANSY_64
#define DLANV2     SLANV2_64
#define DLAPY2     SLAPY2_64
#define DLAQP2     SLAQP2_64
#define DLAQPS     SLAQPS_64
#define DLAQR0     SLAQR0_64
#define DLAQR1     SLAQR1_64
#define DLAQR2     SLAQR2_64
#define DLAQR3     SLAQR3_64
#define DLAQR4     SLAQR4_64
#define DLAQR5     SLAQR5_64
#define DLARF      SLARF_64
#define DLARFB     SLARFB_64
#define DLARFG     SLARFG_64
#define DLARFT     SLARFT_64
#define DLARFX     SLARFX_64
#define DLARTG     SLARTG_64
#define DLARZ      SLARZ_64
#define DLARZB     SLARZB_64
#define DLARZT     SLARZT_64
#define DLAS2      SLAS2_64
#define DLASCL     SLASCL_64
#define DLASD4     SLASD4_64
#define DLASD5     SLASD5_64
#define DLASD6     SLASD6_64
#define DLASD7     SLASD7_64
#define DLASD8     SLASD8_64
#define DLASDA     SLASDA_64
#define DLASDQ     SLASDQ_64
#define DLASDT     SLASDT_64
#define DLASET     SLASET_64
#define DLASQ1     SLASQ1_64
#define DLASQ2     SLASQ2_64
#define DLASQ3     SLASQ3_64
#define DLASQ4     SLASQ4_64
#define DLASQ5     SLASQ5_64
#define DLASQ6     SLASQ6_64
#define DLASR      SLASR_64
#define DLASRT     SLASRT_64
#define DLASSQ     SLASSQ_64
#define DLASV2     SLASV2_64
#define DLASWP     SLASWP_64
#define DLASY2     SLASY2_64
#define DLASYF     SLASYF_64
#define DLATRD     SLATRD_64
#define DLATRZ     SLATRZ_64
#define DORG2L     SORG2L_64
#define DORG2R     SORG2R_64
#define DORGBR     SORGBR_64
#define DORGL2     SORGL2_64
#define DORGLQ     SORGLQ_64
#define DORGQL     SORGQL_64
#define DORGQR     SORGQR_64
#define DORGTR     SORGTR_64
#define DORM2R     SORM2R_64
#define DORMBR     SORMBR_64
#define DORMHR     SORMHR_64
#define DORML2     SORML2_64
#define DORMLQ     SORMLQ_64
#define DORMQR     SORMQR_64
#define DORMR3     SORMR3_64
#define DORMRZ     SORMRZ_64
#define DPBTF2     SPBTF2_64
#define DPBTRF     SPBTRF_64
#define DPBTRS     SPBTRS_64
#define DPOTF2     SPOTF2_64
#define DPOTRF     SPOTRF_64
#define DPOTRF2    SPOTRF2_64
#define DPOTRS     SPOTRS_64
#define DPTTRF     SPTTRF_64
#define DPTTRS     SPTTRS_64
#define DPTTS2     SPTTS2_64
#define DRSCL      SRSCL_64
#define DSTEQR     SSTEQR_64
#define DSTERF     SSTERF_64
#define DSYEV      SSYEV_64
#define DSYGS2     SSYGS2_64
#define DSYGST     SSYGST_64
#define DSYGV      SSYGV_64
#define DSYTD2     SSYTD2_64
#define DSYTF2     SSYTF2_64
#define DSYTRD     SSYTRD_64
#define DSYTRF     SSYTRF_64
#define DSYTRS     SSYTRS_64
#define DTREXC     STREXC_64
#define DTRTRS     STRTRS_64
#define DTZRZF     STZRZF_64
#define ILADLC     ILASLC_64
#define ILADLR     ILASLR_64
#endif
#endif

#else
#ifdef GALAHAD_LAPACK
#define DBDSQR     GALAHAD_SBDSQR
#define DCOMBS     GALAHAD_SCOMBS
#define DCOMBSSQ   GALAHAD_SCOMBSSQ
#define DGEBD2     GALAHAD_SGEBD2
#define DGEBRD     GALAHAD_SGEBRD
#define DGEHD2     GALAHAD_SGEHD2
#define DGEHRD     GALAHAD_SGEHRD
#define DGELQ2     GALAHAD_SGELQ2
#define DGELQF     GALAHAD_SGELQF
#define DGELS      GALAHAD_SGELS
#define DGELSD     GALAHAD_SGELSD
#define DGELSS     GALAHAD_SGELSS
#define DGELSY     GALAHAD_SGELSY
#define DGEQP3     GALAHAD_SGEQP3
#define DGEQR2     GALAHAD_SGEQR2
#define DGEQRF     GALAHAD_SGEQRF
#define DGESV      GALAHAD_SGESV
#define DGESVD     GALAHAD_SGESVD
#define DGETF2     GALAHAD_SGETF2
#define DGETRF     GALAHAD_SGETRF
#define DGETRF2    GALAHAD_SGETRF2
#define DGETRS     GALAHAD_SGETRS
#define DHSEQR     GALAHAD_SHSEQR
#define DISNAN     GALAHAD_SISNAN
#define DLABAD     GALAHAD_SLABAD
#define DLABRD     GALAHAD_SLABRD
#define DLACPY     GALAHAD_SLACPY
#define DLAE2      GALAHAD_SLAE2
#define DLAED6     GALAHAD_SLAED6
#define DLAEV2     GALAHAD_SLAEV2
#define DLAEXC     GALAHAD_SLAEXC
#define DLAHQR     GALAHAD_SLAHQR
#define DLAHR2     GALAHAD_SLAHR2
#define DLAIC1     GALAHAD_SLAIC1
#define DLAISN     GALAHAD_SLAISN
#define DLAISNAN   GALAHAD_SLAISNAN
#define DLALS0     GALAHAD_SLALS0
#define DLALSA     GALAHAD_SLALSA
#define DLALSD     GALAHAD_SLALSD
#define DLAMC3     GALAHAD_SLAMC3
#define DLAMCH     GALAHAD_SLAMCH
#define DLAMRG     GALAHAD_SLAMRG
#define DLANGE     GALAHAD_SLANGE
#define DLANST     GALAHAD_SLANST
#define DLANSY     GALAHAD_SLANSY
#define DLANV2     GALAHAD_SLANV2
#define DLAPY2     GALAHAD_SLAPY2
#define DLAQP2     GALAHAD_SLAQP2
#define DLAQPS     GALAHAD_SLAQPS
#define DLAQR0     GALAHAD_SLAQR0
#define DLAQR1     GALAHAD_SLAQR1
#define DLAQR2     GALAHAD_SLAQR2
#define DLAQR3     GALAHAD_SLAQR3
#define DLAQR4     GALAHAD_SLAQR4
#define DLAQR5     GALAHAD_SLAQR5
#define DLARF      GALAHAD_SLARF
#define DLARFB     GALAHAD_SLARFB
#define DLARFG     GALAHAD_SLARFG
#define DLARFT     GALAHAD_SLARFT
#define DLARFX     GALAHAD_SLARFX
#define DLARTG     GALAHAD_SLARTG
#define DLARZ      GALAHAD_SLARZ
#define DLARZB     GALAHAD_SLARZB
#define DLARZT     GALAHAD_SLARZT
#define DLAS2      GALAHAD_SLAS2
#define DLASCL     GALAHAD_SLASCL
#define DLASD4     GALAHAD_SLASD4
#define DLASD5     GALAHAD_SLASD5
#define DLASD6     GALAHAD_SLASD6
#define DLASD7     GALAHAD_SLASD7
#define DLASD8     GALAHAD_SLASD8
#define DLASDA     GALAHAD_SLASDA
#define DLASDQ     GALAHAD_SLASDQ
#define DLASDT     GALAHAD_SLASDT
#define DLASET     GALAHAD_SLASET
#define DLASQ1     GALAHAD_SLASQ1
#define DLASQ2     GALAHAD_SLASQ2
#define DLASQ3     GALAHAD_SLASQ3
#define DLASQ4     GALAHAD_SLASQ4
#define DLASQ5     GALAHAD_SLASQ5
#define DLASQ6     GALAHAD_SLASQ6
#define DLASR      GALAHAD_SLASR
#define DLASRT     GALAHAD_SLASRT
#define DLASSQ     GALAHAD_SLASSQ
#define DLASV2     GALAHAD_SLASV2
#define DLASWP     GALAHAD_SLASWP
#define DLASY2     GALAHAD_SLASY2
#define DLASYF     GALAHAD_SLASYF
#define DLATRD     GALAHAD_SLATRD
#define DLATRZ     GALAHAD_SLATRZ
#define DORG2L     GALAHAD_SORG2L
#define DORG2R     GALAHAD_SORG2R
#define DORGBR     GALAHAD_SORGBR
#define DORGL2     GALAHAD_SORGL2
#define DORGLQ     GALAHAD_SORGLQ
#define DORGQL     GALAHAD_SORGQL
#define DORGQR     GALAHAD_SORGQR
#define DORGTR     GALAHAD_SORGTR
#define DORM2R     GALAHAD_SORM2R
#define DORMBR     GALAHAD_SORMBR
#define DORMHR     GALAHAD_SORMHR
#define DORML2     GALAHAD_SORML2
#define DORMLQ     GALAHAD_SORMLQ
#define DORMQR     GALAHAD_SORMQR
#define DORMR3     GALAHAD_SORMR3
#define DORMRZ     GALAHAD_SORMRZ
#define DPBTF2     GALAHAD_SPBTF2
#define DPBTRF     GALAHAD_SPBTRF
#define DPBTRS     GALAHAD_SPBTRS
#define DPOTF2     GALAHAD_SPOTF2
#define DPOTRF     GALAHAD_SPOTRF
#define DPOTRF2    GALAHAD_SPOTRF2
#define DPOTRS     GALAHAD_SPOTRS
#define DPTTRF     GALAHAD_SPTTRF
#define DPTTRS     GALAHAD_SPTTRS
#define DPTTS2     GALAHAD_SPTTS2
#define DRSCL      GALAHAD_SRSCL
#define DSTEQR     GALAHAD_SSTEQR
#define DSTERF     GALAHAD_SSTERF
#define DSYEV      GALAHAD_SSYEV
#define DSYGS2     GALAHAD_SSYGS2
#define DSYGST     GALAHAD_SSYGST
#define DSYGV      GALAHAD_SSYGV
#define DSYTD2     GALAHAD_SSYTD2
#define DSYTF2     GALAHAD_SSYTF2
#define DSYTRD     GALAHAD_SSYTRD
#define DSYTRF     GALAHAD_SSYTRF
#define DSYTRS     GALAHAD_SSYTRS
#define DTREXC     GALAHAD_STREXC
#define DTRTRS     GALAHAD_STRTRS
#define DTZRZF     GALAHAD_STZRZF
#define ILADLC     GALAHAD_ILASLC
#define ILADLR     GALAHAD_ILASLR
#else
#define DBDSQR     SBDSQR
#define DCOMBS     SCOMBS
#define DCOMBSSQ   SCOMBSSQ
#define DGEBD2     SGEBD2
#define DGEBRD     SGEBRD
#define DGEHD2     SGEHD2
#define DGEHRD     SGEHRD
#define DGELQ2     SGELQ2
#define DGELQF     SGELQF
#define DGELS      SGELS
#define DGELSD     SGELSD
#define DGELSS     SGELSS
#define DGELSY     SGELSY
#define DGEQP3     SGEQP3
#define DGEQR2     SGEQR2
#define DGEQRF     SGEQRF
#define DGESV      SGESV
#define DGESVD     SGESVD
#define DGETF2     SGETF2
#define DGETRF     SGETRF
#define DGETRF2    SGETRF2
#define DGETRS     SGETRS
#define DHSEQR     SHSEQR
#define DISNAN     SISNAN
#define DLABAD     SLABAD
#define DLABRD     SLABRD
#define DLACPY     SLACPY
#define DLAE2      SLAE2
#define DLAED6     SLAED6
#define DLAEV2     SLAEV2
#define DLAEXC     SLAEXC
#define DLAHQR     SLAHQR
#define DLAHR2     SLAHR2
#define DLAIC1     SLAIC1
#define DLAISN     SLAISN
#define DLAISNAN   SLAISNAN
#define DLALS0     SLALS0
#define DLALSA     SLALSA
#define DLALSD     SLALSD
#define DLAMC3     SLAMC3
#define DLAMCH     SLAMCH
#define DLAMRG     SLAMRG
#define DLANGE     SLANGE
#define DLANST     SLANST
#define DLANSY     SLANSY
#define DLANV2     SLANV2
#define DLAPY2     SLAPY2
#define DLAQP2     SLAQP2
#define DLAQPS     SLAQPS
#define DLAQR0     SLAQR0
#define DLAQR1     SLAQR1
#define DLAQR2     SLAQR2
#define DLAQR3     SLAQR3
#define DLAQR4     SLAQR4
#define DLAQR5     SLAQR5
#define DLARF      SLARF
#define DLARFB     SLARFB
#define DLARFG     SLARFG
#define DLARFT     SLARFT
#define DLARFX     SLARFX
#define DLARTG     SLARTG
#define DLARZ      SLARZ
#define DLARZB     SLARZB
#define DLARZT     SLARZT
#define DLAS2      SLAS2
#define DLASCL     SLASCL
#define DLASD4     SLASD4
#define DLASD5     SLASD5
#define DLASD6     SLASD6
#define DLASD7     SLASD7
#define DLASD8     SLASD8
#define DLASDA     SLASDA
#define DLASDQ     SLASDQ
#define DLASDT     SLASDT
#define DLASET     SLASET
#define DLASQ1     SLASQ1
#define DLASQ2     SLASQ2
#define DLASQ3     SLASQ3
#define DLASQ4     SLASQ4
#define DLASQ5     SLASQ5
#define DLASQ6     SLASQ6
#define DLASR      SLASR
#define DLASRT     SLASRT
#define DLASSQ     SLASSQ
#define DLASV2     SLASV2
#define DLASWP     SLASWP
#define DLASY2     SLASY2
#define DLASYF     SLASYF
#define DLATRD     SLATRD
#define DLATRZ     SLATRZ
#define DORG2L     SORG2L
#define DORG2R     SORG2R
#define DORGBR     SORGBR
#define DORGL2     SORGL2
#define DORGLQ     SORGLQ
#define DORGQL     SORGQL
#define DORGQR     SORGQR
#define DORGTR     SORGTR
#define DORM2R     SORM2R
#define DORMBR     SORMBR
#define DORMHR     SORMHR
#define DORML2     SORML2
#define DORMLQ     SORMLQ
#define DORMQR     SORMQR
#define DORMR3     SORMR3
#define DORMRZ     SORMRZ
#define DPBTF2     SPBTF2
#define DPBTRF     SPBTRF
#define DPBTRS     SPBTRS
#define DPOTF2     SPOTF2
#define DPOTRF     SPOTRF
#define DPOTRF2    SPOTRF2
#define DPOTRS     SPOTRS
#define DPTTRF     SPTTRF
#define DPTTRS     SPTTRS
#define DPTTS2     SPTTS2
#define DRSCL      SRSCL
#define DSTEQR     SSTEQR
#define DSTERF     SSTERF
#define DSYEV      SSYEV
#define DSYGS2     SSYGS2
#define DSYGST     SSYGST
#define DSYGV      SSYGV
#define DSYTD2     SSYTD2
#define DSYTF2     SSYTF2
#define DSYTRD     SSYTRD
#define DSYTRF     SSYTRF
#define DSYTRS     SSYTRS
#define DTREXC     STREXC
#define DTRTRS     STRTRS
#define DTZRZF     STZRZF
#define ILADLC     ILASLC
#define ILADLR     ILASLR
#endif
#endif

#elif REAL_128

#ifdef INTEGER_64
#ifdef GALAHAD_LAPACK
#define DBDSQR     GALAHAD_QBDSQR_64
#define DCOMBS     GALAHAD_QCOMBS_64
#define DCOMBSSQ   GALAHAD_QCOMBSSQ_64
#define DGEBD2     GALAHAD_QGEBD2_64
#define DGEBRD     GALAHAD_QGEBRD_64
#define DGEHD2     GALAHAD_QGEHD2_64
#define DGEHRD     GALAHAD_QGEHRD_64
#define DGELQ2     GALAHAD_QGELQ2_64
#define DGELQF     GALAHAD_QGELQF_64
#define DGELS      GALAHAD_QGELS_64
#define DGELSD     GALAHAD_QGELSD_64
#define DGELSS     GALAHAD_QGELSS_64
#define DGELSY     GALAHAD_QGELSY_64
#define DGEQP3     GALAHAD_QGEQP3_64
#define DGEQR2     GALAHAD_QGEQR2_64
#define DGEQRF     GALAHAD_QGEQRF_64
#define DGESV      GALAHAD_QGESV_64
#define DGESVD     GALAHAD_QGESVD_64
#define DGETF2     GALAHAD_QGETF2_64
#define DGETRF     GALAHAD_QGETRF_64
#define DGETRF2    GALAHAD_QGETRF2_64
#define DGETRS     GALAHAD_QGETRS_64
#define DHSEQR     GALAHAD_QHSEQR_64
#define DISNAN     GALAHAD_QISNAN_64
#define DLABAD     GALAHAD_QLABAD_64
#define DLABRD     GALAHAD_QLABRD_64
#define DLACPY     GALAHAD_QLACPY_64
#define DLAE2      GALAHAD_QLAE2_64
#define DLAED6     GALAHAD_QLAED6_64
#define DLAEV2     GALAHAD_QLAEV2_64
#define DLAEXC     GALAHAD_QLAEXC_64
#define DLAHQR     GALAHAD_QLAHQR_64
#define DLAHR2     GALAHAD_QLAHR2_64
#define DLAIC1     GALAHAD_QLAIC1_64
#define DLAISN     GALAHAD_QLAISN_64
#define DLAISNAN   GALAHAD_QLAISNAN_64
#define DLALS0     GALAHAD_QLALS0_64
#define DLALSA     GALAHAD_QLALSA_64
#define DLALSD     GALAHAD_QLALSD_64
#define DLAMC3     GALAHAD_QLAMC3_64
#define DLAMCH     GALAHAD_QLAMCH_64
#define DLAMRG     GALAHAD_QLAMRG_64
#define DLANGE     GALAHAD_QLANGE_64
#define DLANST     GALAHAD_QLANST_64
#define DLANSY     GALAHAD_QLANSY_64
#define DLANV2     GALAHAD_QLANV2_64
#define DLAPY2     GALAHAD_QLAPY2_64
#define DLAQP2     GALAHAD_QLAQP2_64
#define DLAQPS     GALAHAD_QLAQPS_64
#define DLAQR0     GALAHAD_QLAQR0_64
#define DLAQR1     GALAHAD_QLAQR1_64
#define DLAQR2     GALAHAD_QLAQR2_64
#define DLAQR3     GALAHAD_QLAQR3_64
#define DLAQR4     GALAHAD_QLAQR4_64
#define DLAQR5     GALAHAD_QLAQR5_64
#define DLARF      GALAHAD_QLARF_64
#define DLARFB     GALAHAD_QLARFB_64
#define DLARFG     GALAHAD_QLARFG_64
#define DLARFT     GALAHAD_QLARFT_64
#define DLARFX     GALAHAD_QLARFX_64
#define DLARTG     GALAHAD_QLARTG_64
#define DLARZ      GALAHAD_QLARZ_64
#define DLARZB     GALAHAD_QLARZB_64
#define DLARZT     GALAHAD_QLARZT_64
#define DLAS2      GALAHAD_QLAS2_64
#define DLASCL     GALAHAD_QLASCL_64
#define DLASD4     GALAHAD_QLASD4_64
#define DLASD5     GALAHAD_QLASD5_64
#define DLASD6     GALAHAD_QLASD6_64
#define DLASD7     GALAHAD_QLASD7_64
#define DLASD8     GALAHAD_QLASD8_64
#define DLASDA     GALAHAD_QLASDA_64
#define DLASDQ     GALAHAD_QLASDQ_64
#define DLASDT     GALAHAD_QLASDT_64
#define DLASET     GALAHAD_QLASET_64
#define DLASQ1     GALAHAD_QLASQ1_64
#define DLASQ2     GALAHAD_QLASQ2_64
#define DLASQ3     GALAHAD_QLASQ3_64
#define DLASQ4     GALAHAD_QLASQ4_64
#define DLASQ5     GALAHAD_QLASQ5_64
#define DLASQ6     GALAHAD_QLASQ6_64
#define DLASR      GALAHAD_QLASR_64
#define DLASRT     GALAHAD_QLASRT_64
#define DLASSQ     GALAHAD_QLASSQ_64
#define DLASV2     GALAHAD_QLASV2_64
#define DLASWP     GALAHAD_QLASWP_64
#define DLASY2     GALAHAD_QLASY2_64
#define DLASYF     GALAHAD_QLASYF_64
#define DLATRD     GALAHAD_QLATRD_64
#define DLATRZ     GALAHAD_QLATRZ_64
#define DORG2L     GALAHAD_QORG2L_64
#define DORG2R     GALAHAD_QORG2R_64
#define DORGBR     GALAHAD_QORGBR_64
#define DORGL2     GALAHAD_QORGL2_64
#define DORGLQ     GALAHAD_QORGLQ_64
#define DORGQL     GALAHAD_QORGQL_64
#define DORGQR     GALAHAD_QORGQR_64
#define DORGTR     GALAHAD_QORGTR_64
#define DORM2R     GALAHAD_QORM2R_64
#define DORMBR     GALAHAD_QORMBR_64
#define DORMHR     GALAHAD_QORMHR_64
#define DORML2     GALAHAD_QORML2_64
#define DORMLQ     GALAHAD_QORMLQ_64
#define DORMQR     GALAHAD_QORMQR_64
#define DORMR3     GALAHAD_QORMR3_64
#define DORMRZ     GALAHAD_QORMRZ_64
#define DPBTF2     GALAHAD_QPBTF2_64
#define DPBTRF     GALAHAD_QPBTRF_64
#define DPBTRS     GALAHAD_QPBTRS_64
#define DPOTF2     GALAHAD_QPOTF2_64
#define DPOTRF     GALAHAD_QPOTRF_64
#define DPOTRF2    GALAHAD_QPOTRF2_64
#define DPOTRS     GALAHAD_QPOTRS_64
#define DPTTRF     GALAHAD_QPTTRF_64
#define DPTTRS     GALAHAD_QPTTRS_64
#define DPTTS2     GALAHAD_QPTTS2_64
#define DRSCL      GALAHAD_QRSCL_64
#define DSTEQR     GALAHAD_QSTEQR_64
#define DSTERF     GALAHAD_QSTERF_64
#define DSYEV      GALAHAD_QSYEV_64
#define DSYGS2     GALAHAD_QSYGS2_64
#define DSYGST     GALAHAD_QSYGST_64
#define DSYGV      GALAHAD_QSYGV_64
#define DSYTD2     GALAHAD_QSYTD2_64
#define DSYTF2     GALAHAD_QSYTF2_64
#define DSYTRD     GALAHAD_QSYTRD_64
#define DSYTRF     GALAHAD_QSYTRF_64
#define DSYTRS     GALAHAD_QSYTRS_64
#define DTREXC     GALAHAD_QTREXC_64
#define DTRTRS     GALAHAD_QTRTRS_64
#define DTZRZF     GALAHAD_QTZRZF_64
#define ILADLC     GALAHAD_ILAQLC_64
#define ILADLR     GALAHAD_ILAQLR_64
#else
#ifdef NO_UNDERSCORE_INTEGER_64
#define DBDSQR     QBDSQR64
#define DCOMBS     QCOMBS64
#define DCOMBSSQ   QCOMBSSQ64
#define DGEBD2     QGEBD264
#define DGEBRD     QGEBRD64
#define DGEHD2     QGEHD264
#define DGEHRD     QGEHRD64
#define DGELQ2     QGELQ264
#define DGELQF     QGELQF64
#define DGELS      QGELS64
#define DGELSD     QGELSD64
#define DGELSS     QGELSS64
#define DGELSY     QGELSY64
#define DGEQP3     QGEQP364
#define DGEQR2     QGEQR264
#define DGEQRF     QGEQRF64
#define DGESV      QGESV64
#define DGESVD     QGESVD64
#define DGETF2     QGETF264
#define DGETRF     QGETRF64
#define DGETRF2    QGETRF264
#define DGETRS     QGETRS64
#define DHSEQR     QHSEQR64
#define DISNAN     QISNAN64
#define DLABAD     QLABAD64
#define DLABRD     QLABRD64
#define DLACPY     QLACPY64
#define DLAE2      QLAE264
#define DLAED6     QLAED664
#define DLAEV2     QLAEV264
#define DLAEXC     QLAEXC64
#define DLAHQR     QLAHQR64
#define DLAHR2     QLAHR264
#define DLAIC1     QLAIC164
#define DLAISN     QLAISN64
#define DLAISNAN   QLAISNAN64
#define DLALS0     QLALS064
#define DLALSA     QLALSA64
#define DLALSD     QLALSD64
#define DLAMC3     QLAMC364
#define DLAMCH     QLAMCH64
#define DLAMRG     QLAMRG64
#define DLANGE     QLANGE64
#define DLANST     QLANST64
#define DLANSY     QLANSY64
#define DLANV2     QLANV264
#define DLAPY2     QLAPY264
#define DLAQP2     QLAQP264
#define DLAQPS     QLAQPS64
#define DLAQR0     QLAQR064
#define DLAQR1     QLAQR164
#define DLAQR2     QLAQR264
#define DLAQR3     QLAQR364
#define DLAQR4     QLAQR464
#define DLAQR5     QLAQR564
#define DLARF      QLARF64
#define DLARFB     QLARFB64
#define DLARFG     QLARFG64
#define DLARFT     QLARFT64
#define DLARFX     QLARFX64
#define DLARTG     QLARTG64
#define DLARZ      QLARZ64
#define DLARZB     QLARZB64
#define DLARZT     QLARZT64
#define DLAS2      QLAS264
#define DLASCL     QLASCL64
#define DLASD4     QLASD464
#define DLASD5     QLASD564
#define DLASD6     QLASD664
#define DLASD7     QLASD764
#define DLASD8     QLASD864
#define DLASDA     QLASDA64
#define DLASDQ     QLASDQ64
#define DLASDT     QLASDT64
#define DLASET     QLASET64
#define DLASQ1     QLASQ164
#define DLASQ2     QLASQ264
#define DLASQ3     QLASQ364
#define DLASQ4     QLASQ464
#define DLASQ5     QLASQ564
#define DLASQ6     QLASQ664
#define DLASR      QLASR64
#define DLASRT     QLASRT64
#define DLASSQ     QLASSQ64
#define DLASV2     QLASV264
#define DLASWP     QLASWP64
#define DLASY2     QLASY264
#define DLASYF     QLASYF64
#define DLATRD     QLATRD64
#define DLATRZ     QLATRZ64
#define DORG2L     QORG2L64
#define DORG2R     QORG2R64
#define DORGBR     QORGBR64
#define DORGL2     QORGL264
#define DORGLQ     QORGLQ64
#define DORGQL     QORGQL64
#define DORGQR     QORGQR64
#define DORGTR     QORGTR64
#define DORM2R     QORM2R64
#define DORMBR     QORMBR64
#define DORMHR     QORMHR64
#define DORML2     QORML264
#define DORMLQ     QORMLQ64
#define DORMQR     QORMQR64
#define DORMR3     QORMR364
#define DORMRZ     QORMRZ64
#define DPBTF2     QPBTF264
#define DPBTRF     QPBTRF64
#define DPBTRS     QPBTRS64
#define DPOTF2     QPOTF264
#define DPOTRF     QPOTRF64
#define DPOTRF2    QPOTRF264
#define DPOTRS     QPOTRS64
#define DPTTRF     QPTTRF64
#define DPTTRS     QPTTRS64
#define DPTTS2     QPTTS264
#define DRSCL      QRSCL64
#define DSTEQR     QSTEQR64
#define DSTERF     QSTERF64
#define DSYEV      QSYEV64
#define DSYGS2     QSYGS264
#define DSYGST     QSYGST64
#define DSYGV      QSYGV64
#define DSYTD2     QSYTD264
#define DSYTF2     QSYTF264
#define DSYTRD     QSYTRD64
#define DSYTRF     QSYTRF64
#define DSYTRS     QSYTRS64
#define DTREXC     QTREXC64
#define DTRTRS     QTRTRS64
#define DTZRZF     QTZRZF64
#define ILADLC     ILAQLC64
#define ILADLR     ILAQLR64
#elif DOUBLE_UNDERSCORE_INTEGER_64
#define DBDSQR     QBDSQR__64
#define DCOMBS     QCOMBS__64
#define DCOMBSSQ   QCOMBSSQ__64
#define DGEBD2     QGEBD2__64
#define DGEBRD     QGEBRD__64
#define DGEHD2     QGEHD2__64
#define DGEHRD     QGEHRD__64
#define DGELQ2     QGELQ2__64
#define DGELQF     QGELQF__64
#define DGELS      QGELS__64
#define DGELSD     QGELSD__64
#define DGELSS     QGELSS__64
#define DGELSY     QGELSY__64
#define DGEQP3     QGEQP3__64
#define DGEQR2     QGEQR2__64
#define DGEQRF     QGEQRF__64
#define DGESV      QGESV__64
#define DGESVD     QGESVD__64
#define DGETF2     QGETF2__64
#define DGETRF     QGETRF__64
#define DGETRF2    QGETRF2__64
#define DGETRS     QGETRS__64
#define DHSEQR     QHSEQR__64
#define DISNAN     QISNAN__64
#define DLABAD     QLABAD__64
#define DLABRD     QLABRD__64
#define DLACPY     QLACPY__64
#define DLAE2      QLAE2__64
#define DLAED6     QLAED6__64
#define DLAEV2     QLAEV2__64
#define DLAEXC     QLAEXC__64
#define DLAHQR     QLAHQR__64
#define DLAHR2     QLAHR2__64
#define DLAIC1     QLAIC1__64
#define DLAISN     QLAISN__64
#define DLAISNAN   QLAISNAN__64
#define DLALS0     QLALS0__64
#define DLALSA     QLALSA__64
#define DLALSD     QLALSD__64
#define DLAMC3     QLAMC3__64
#define DLAMCH     QLAMCH__64
#define DLAMRG     QLAMRG__64
#define DLANGE     QLANGE__64
#define DLANST     QLANST__64
#define DLANSY     QLANSY__64
#define DLANV2     QLANV2__64
#define DLAPY2     QLAPY2__64
#define DLAQP2     QLAQP2__64
#define DLAQPS     QLAQPS__64
#define DLAQR0     QLAQR0__64
#define DLAQR1     QLAQR1__64
#define DLAQR2     QLAQR2__64
#define DLAQR3     QLAQR3__64
#define DLAQR4     QLAQR4__64
#define DLAQR5     QLAQR5__64
#define DLARF      QLARF__64
#define DLARFB     QLARFB__64
#define DLARFG     QLARFG__64
#define DLARFT     QLARFT__64
#define DLARFX     QLARFX__64
#define DLARTG     QLARTG__64
#define DLARZ      QLARZ__64
#define DLARZB     QLARZB__64
#define DLARZT     QLARZT__64
#define DLAS2      QLAS2__64
#define DLASCL     QLASCL__64
#define DLASD4     QLASD4__64
#define DLASD5     QLASD5__64
#define DLASD6     QLASD6__64
#define DLASD7     QLASD7__64
#define DLASD8     QLASD8__64
#define DLASDA     QLASDA__64
#define DLASDQ     QLASDQ__64
#define DLASDT     QLASDT__64
#define DLASET     QLASET__64
#define DLASQ1     QLASQ1__64
#define DLASQ2     QLASQ2__64
#define DLASQ3     QLASQ3__64
#define DLASQ4     QLASQ4__64
#define DLASQ5     QLASQ5__64
#define DLASQ6     QLASQ6__64
#define DLASR      QLASR__64
#define DLASRT     QLASRT__64
#define DLASSQ     QLASSQ__64
#define DLASV2     QLASV2__64
#define DLASWP     QLASWP__64
#define DLASY2     QLASY2__64
#define DLASYF     QLASYF__64
#define DLATRD     QLATRD__64
#define DLATRZ     QLATRZ__64
#define DORG2L     QORG2L__64
#define DORG2R     QORG2R__64
#define DORGBR     QORGBR__64
#define DORGL2     QORGL2__64
#define DORGLQ     QORGLQ__64
#define DORGQL     QORGQL__64
#define DORGQR     QORGQR__64
#define DORGTR     QORGTR__64
#define DORM2R     QORM2R__64
#define DORMBR     QORMBR__64
#define DORMHR     QORMHR__64
#define DORML2     QORML2__64
#define DORMLQ     QORMLQ__64
#define DORMQR     QORMQR__64
#define DORMR3     QORMR3__64
#define DORMRZ     QORMRZ__64
#define DPBTF2     QPBTF2__64
#define DPBTRF     QPBTRF__64
#define DPBTRS     QPBTRS__64
#define DPOTF2     QPOTF2__64
#define DPOTRF     QPOTRF__64
#define DPOTRF2    QPOTRF2__64
#define DPOTRS     QPOTRS__64
#define DPTTRF     QPTTRF__64
#define DPTTRS     QPTTRS__64
#define DPTTS2     QPTTS2__64
#define DRSCL      QRSCL__64
#define DSTEQR     QSTEQR__64
#define DSTERF     QSTERF__64
#define DSYEV      QSYEV__64
#define DSYGS2     QSYGS2__64
#define DSYGST     QSYGST__64
#define DSYGV      QSYGV__64
#define DSYTD2     QSYTD2__64
#define DSYTF2     QSYTF2__64
#define DSYTRD     QSYTRD__64
#define DSYTRF     QSYTRF__64
#define DSYTRS     QSYTRS__64
#define DTREXC     QTREXC__64
#define DTRTRS     QTRTRS__64
#define DTZRZF     QTZRZF__64
#define ILADLC     ILAQLC__64
#define ILADLR     ILAQLR__64
#elif NO_SYMBOL_INTEGER_64
#define DBDSQR     QBDSQR
#define DCOMBS     QCOMBS
#define DCOMBSSQ   QCOMBSSQ
#define DGEBD2     QGEBD2
#define DGEBRD     QGEBRD
#define DGEHD2     QGEHD2
#define DGEHRD     QGEHRD
#define DGELQ2     QGELQ2
#define DGELQF     QGELQF
#define DGELS      QGELS
#define DGELSD     QGELSD
#define DGELSS     QGELSS
#define DGELSY     QGELSY
#define DGEQP3     QGEQP3
#define DGEQR2     QGEQR2
#define DGEQRF     QGEQRF
#define DGESV      QGESV
#define DGESVD     QGESVD
#define DGETF2     QGETF2
#define DGETRF     QGETRF
#define DGETRF2    QGETRF2
#define DGETRS     QGETRS
#define DHSEQR     QHSEQR
#define DISNAN     QISNAN
#define DLABAD     QLABAD
#define DLABRD     QLABRD
#define DLACPY     QLACPY
#define DLAE2      QLAE2
#define DLAED6     QLAED6
#define DLAEV2     QLAEV2
#define DLAEXC     QLAEXC
#define DLAHQR     QLAHQR
#define DLAHR2     QLAHR2
#define DLAIC1     QLAIC1
#define DLAISN     QLAISN
#define DLAISNAN   QLAISNAN
#define DLALS0     QLALS0
#define DLALSA     QLALSA
#define DLALSD     QLALSD
#define DLAMC3     QLAMC3
#define DLAMCH     QLAMCH
#define DLAMRG     QLAMRG
#define DLANGE     QLANGE
#define DLANST     QLANST
#define DLANSY     QLANSY
#define DLANV2     QLANV2
#define DLAPY2     QLAPY2
#define DLAQP2     QLAQP2
#define DLAQPS     QLAQPS
#define DLAQR0     QLAQR0
#define DLAQR1     QLAQR1
#define DLAQR2     QLAQR2
#define DLAQR3     QLAQR3
#define DLAQR4     QLAQR4
#define DLAQR5     QLAQR5
#define DLARF      QLARF
#define DLARFB     QLARFB
#define DLARFG     QLARFG
#define DLARFT     QLARFT
#define DLARFX     QLARFX
#define DLARTG     QLARTG
#define DLARZ      QLARZ
#define DLARZB     QLARZB
#define DLARZT     QLARZT
#define DLAS2      QLAS2
#define DLASCL     QLASCL
#define DLASD4     QLASD4
#define DLASD5     QLASD5
#define DLASD6     QLASD6
#define DLASD7     QLASD7
#define DLASD8     QLASD8
#define DLASDA     QLASDA
#define DLASDQ     QLASDQ
#define DLASDT     QLASDT
#define DLASET     QLASET
#define DLASQ1     QLASQ1
#define DLASQ2     QLASQ2
#define DLASQ3     QLASQ3
#define DLASQ4     QLASQ4
#define DLASQ5     QLASQ5
#define DLASQ6     QLASQ6
#define DLASR      QLASR
#define DLASRT     QLASRT
#define DLASSQ     QLASSQ
#define DLASV2     QLASV2
#define DLASWP     QLASWP
#define DLASY2     QLASY2
#define DLASYF     QLASYF
#define DLATRD     QLATRD
#define DLATRZ     QLATRZ
#define DORG2L     QORG2L
#define DORG2R     QORG2R
#define DORGBR     QORGBR
#define DORGL2     QORGL2
#define DORGLQ     QORGLQ
#define DORGQL     QORGQL
#define DORGQR     QORGQR
#define DORGTR     QORGTR
#define DORM2R     QORM2R
#define DORMBR     QORMBR
#define DORMHR     QORMHR
#define DORML2     QORML2
#define DORMLQ     QORMLQ
#define DORMQR     QORMQR
#define DORMR3     QORMR3
#define DORMRZ     QORMRZ
#define DPBTF2     QPBTF2
#define DPBTRF     QPBTRF
#define DPBTRS     QPBTRS
#define DPOTF2     QPOTF2
#define DPOTRF     QPOTRF
#define DPOTRF2    QPOTRF2
#define DPOTRS     QPOTRS
#define DPTTRF     QPTTRF
#define DPTTRS     QPTTRS
#define DPTTS2     QPTTS2
#define DRSCL      QRSCL
#define DSTEQR     QSTEQR
#define DSTERF     QSTERF
#define DSYEV      QSYEV
#define DSYGS2     QSYGS2
#define DSYGST     QSYGST
#define DSYGV      QSYGV
#define DSYTD2     QSYTD2
#define DSYTF2     QSYTF2
#define DSYTRD     QSYTRD
#define DSYTRF     QSYTRF
#define DSYTRS     QSYTRS
#define DTREXC     QTREXC
#define DTRTRS     QTRTRS
#define DTZRZF     QTZRZF
#define ILADLC     ILAQLC
#define ILADLR     ILAQLR
#else
#define DBDSQR     QBDSQR_64
#define DCOMBS     QCOMBS_64
#define DCOMBSSQ   QCOMBSSQ_64
#define DGEBD2     QGEBD2_64
#define DGEBRD     QGEBRD_64
#define DGEHD2     QGEHD2_64
#define DGEHRD     QGEHRD_64
#define DGELQ2     QGELQ2_64
#define DGELQF     QGELQF_64
#define DGELS      QGELS_64
#define DGELSD     QGELSD_64
#define DGELSS     QGELSS_64
#define DGELSY     QGELSY_64
#define DGEQP3     QGEQP3_64
#define DGEQR2     QGEQR2_64
#define DGEQRF     QGEQRF_64
#define DGESV      QGESV_64
#define DGESVD     QGESVD_64
#define DGETF2     QGETF2_64
#define DGETRF     QGETRF_64
#define DGETRF2    QGETRF2_64
#define DGETRS     QGETRS_64
#define DHSEQR     QHSEQR_64
#define DISNAN     QISNAN_64
#define DLABAD     QLABAD_64
#define DLABRD     QLABRD_64
#define DLACPY     QLACPY_64
#define DLAE2      QLAE2_64
#define DLAED6     QLAED6_64
#define DLAEV2     QLAEV2_64
#define DLAEXC     QLAEXC_64
#define DLAHQR     QLAHQR_64
#define DLAHR2     QLAHR2_64
#define DLAIC1     QLAIC1_64
#define DLAISN     QLAISN_64
#define DLAISNAN   QLAISNAN_64
#define DLALS0     QLALS0_64
#define DLALSA     QLALSA_64
#define DLALSD     QLALSD_64
#define DLAMC3     QLAMC3_64
#define DLAMCH     QLAMCH_64
#define DLAMRG     QLAMRG_64
#define DLANGE     QLANGE_64
#define DLANST     QLANST_64
#define DLANSY     QLANSY_64
#define DLANV2     QLANV2_64
#define DLAPY2     QLAPY2_64
#define DLAQP2     QLAQP2_64
#define DLAQPS     QLAQPS_64
#define DLAQR0     QLAQR0_64
#define DLAQR1     QLAQR1_64
#define DLAQR2     QLAQR2_64
#define DLAQR3     QLAQR3_64
#define DLAQR4     QLAQR4_64
#define DLAQR5     QLAQR5_64
#define DLARF      QLARF_64
#define DLARFB     QLARFB_64
#define DLARFG     QLARFG_64
#define DLARFT     QLARFT_64
#define DLARFX     QLARFX_64
#define DLARTG     QLARTG_64
#define DLARZ      QLARZ_64
#define DLARZB     QLARZB_64
#define DLARZT     QLARZT_64
#define DLAS2      QLAS2_64
#define DLASCL     QLASCL_64
#define DLASD4     QLASD4_64
#define DLASD5     QLASD5_64
#define DLASD6     QLASD6_64
#define DLASD7     QLASD7_64
#define DLASD8     QLASD8_64
#define DLASDA     QLASDA_64
#define DLASDQ     QLASDQ_64
#define DLASDT     QLASDT_64
#define DLASET     QLASET_64
#define DLASQ1     QLASQ1_64
#define DLASQ2     QLASQ2_64
#define DLASQ3     QLASQ3_64
#define DLASQ4     QLASQ4_64
#define DLASQ5     QLASQ5_64
#define DLASQ6     QLASQ6_64
#define DLASR      QLASR_64
#define DLASRT     QLASRT_64
#define DLASSQ     QLASSQ_64
#define DLASV2     QLASV2_64
#define DLASWP     QLASWP_64
#define DLASY2     QLASY2_64
#define DLASYF     QLASYF_64
#define DLATRD     QLATRD_64
#define DLATRZ     QLATRZ_64
#define DORG2L     QORG2L_64
#define DORG2R     QORG2R_64
#define DORGBR     QORGBR_64
#define DORGL2     QORGL2_64
#define DORGLQ     QORGLQ_64
#define DORGQL     QORGQL_64
#define DORGQR     QORGQR_64
#define DORGTR     QORGTR_64
#define DORM2R     QORM2R_64
#define DORMBR     QORMBR_64
#define DORMHR     QORMHR_64
#define DORML2     QORML2_64
#define DORMLQ     QORMLQ_64
#define DORMQR     QORMQR_64
#define DORMR3     QORMR3_64
#define DORMRZ     QORMRZ_64
#define DPBTF2     QPBTF2_64
#define DPBTRF     QPBTRF_64
#define DPBTRS     QPBTRS_64
#define DPOTF2     QPOTF2_64
#define DPOTRF     QPOTRF_64
#define DPOTRF2    QPOTRF2_64
#define DPOTRS     QPOTRS_64
#define DPTTRF     QPTTRF_64
#define DPTTRS     QPTTRS_64
#define DPTTS2     QPTTS2_64
#define DRSCL      QRSCL_64
#define DSTEQR     QSTEQR_64
#define DSTERF     QSTERF_64
#define DSYEV      QSYEV_64
#define DSYGS2     QSYGS2_64
#define DSYGST     QSYGST_64
#define DSYGV      QSYGV_64
#define DSYTD2     QSYTD2_64
#define DSYTF2     QSYTF2_64
#define DSYTRD     QSYTRD_64
#define DSYTRF     QSYTRF_64
#define DSYTRS     QSYTRS_64
#define DTREXC     QTREXC_64
#define DTRTRS     QTRTRS_64
#define DTZRZF     QTZRZF_64
#define ILADLC     ILAQLC_64
#define ILADLR     ILAQLR_64
#endif
#endif

#else
#ifdef GALAHAD_LAPACK
#define DBDSQR     GALAHAD_QBDSQR
#define DCOMBS     GALAHAD_QCOMBS
#define DCOMBSSQ   GALAHAD_QCOMBSSQ
#define DGEBD2     GALAHAD_QGEBD2
#define DGEBRD     GALAHAD_QGEBRD
#define DGEHD2     GALAHAD_QGEHD2
#define DGEHRD     GALAHAD_QGEHRD
#define DGELQ2     GALAHAD_QGELQ2
#define DGELQF     GALAHAD_QGELQF
#define DGELS      GALAHAD_QGELS
#define DGELSD     GALAHAD_QGELSD
#define DGELSS     GALAHAD_QGELSS
#define DGELSY     GALAHAD_QGELSY
#define DGEQP3     GALAHAD_QGEQP3
#define DGEQR2     GALAHAD_QGEQR2
#define DGEQRF     GALAHAD_QGEQRF
#define DGESV      GALAHAD_QGESV
#define DGESVD     GALAHAD_QGESVD
#define DGETF2     GALAHAD_QGETF2
#define DGETRF     GALAHAD_QGETRF
#define DGETRF2    GALAHAD_QGETRF2
#define DGETRS     GALAHAD_QGETRS
#define DHSEQR     GALAHAD_QHSEQR
#define DISNAN     GALAHAD_QISNAN
#define DLABAD     GALAHAD_QLABAD
#define DLABRD     GALAHAD_QLABRD
#define DLACPY     GALAHAD_QLACPY
#define DLAE2      GALAHAD_QLAE2
#define DLAED6     GALAHAD_QLAED6
#define DLAEV2     GALAHAD_QLAEV2
#define DLAEXC     GALAHAD_QLAEXC
#define DLAHQR     GALAHAD_QLAHQR
#define DLAHR2     GALAHAD_QLAHR2
#define DLAIC1     GALAHAD_QLAIC1
#define DLAISN     GALAHAD_QLAISN
#define DLAISNAN   GALAHAD_QLAISNAN
#define DLALS0     GALAHAD_QLALS0
#define DLALSA     GALAHAD_QLALSA
#define DLALSD     GALAHAD_QLALSD
#define DLAMC3     GALAHAD_QLAMC3
#define DLAMCH     GALAHAD_QLAMCH
#define DLAMRG     GALAHAD_QLAMRG
#define DLANGE     GALAHAD_QLANGE
#define DLANST     GALAHAD_QLANST
#define DLANSY     GALAHAD_QLANSY
#define DLANV2     GALAHAD_QLANV2
#define DLAPY2     GALAHAD_QLAPY2
#define DLAQP2     GALAHAD_QLAQP2
#define DLAQPS     GALAHAD_QLAQPS
#define DLAQR0     GALAHAD_QLAQR0
#define DLAQR1     GALAHAD_QLAQR1
#define DLAQR2     GALAHAD_QLAQR2
#define DLAQR3     GALAHAD_QLAQR3
#define DLAQR4     GALAHAD_QLAQR4
#define DLAQR5     GALAHAD_QLAQR5
#define DLARF      GALAHAD_QLARF
#define DLARFB     GALAHAD_QLARFB
#define DLARFG     GALAHAD_QLARFG
#define DLARFT     GALAHAD_QLARFT
#define DLARFX     GALAHAD_QLARFX
#define DLARTG     GALAHAD_QLARTG
#define DLARZ      GALAHAD_QLARZ
#define DLARZB     GALAHAD_QLARZB
#define DLARZT     GALAHAD_QLARZT
#define DLAS2      GALAHAD_QLAS2
#define DLASCL     GALAHAD_QLASCL
#define DLASD4     GALAHAD_QLASD4
#define DLASD5     GALAHAD_QLASD5
#define DLASD6     GALAHAD_QLASD6
#define DLASD7     GALAHAD_QLASD7
#define DLASD8     GALAHAD_QLASD8
#define DLASDA     GALAHAD_QLASDA
#define DLASDQ     GALAHAD_QLASDQ
#define DLASDT     GALAHAD_QLASDT
#define DLASET     GALAHAD_QLASET
#define DLASQ1     GALAHAD_QLASQ1
#define DLASQ2     GALAHAD_QLASQ2
#define DLASQ3     GALAHAD_QLASQ3
#define DLASQ4     GALAHAD_QLASQ4
#define DLASQ5     GALAHAD_QLASQ5
#define DLASQ6     GALAHAD_QLASQ6
#define DLASR      GALAHAD_QLASR
#define DLASRT     GALAHAD_QLASRT
#define DLASSQ     GALAHAD_QLASSQ
#define DLASV2     GALAHAD_QLASV2
#define DLASWP     GALAHAD_QLASWP
#define DLASY2     GALAHAD_QLASY2
#define DLASYF     GALAHAD_QLASYF
#define DLATRD     GALAHAD_QLATRD
#define DLATRZ     GALAHAD_QLATRZ
#define DORG2L     GALAHAD_QORG2L
#define DORG2R     GALAHAD_QORG2R
#define DORGBR     GALAHAD_QORGBR
#define DORGL2     GALAHAD_QORGL2
#define DORGLQ     GALAHAD_QORGLQ
#define DORGQL     GALAHAD_QORGQL
#define DORGQR     GALAHAD_QORGQR
#define DORGTR     GALAHAD_QORGTR
#define DORM2R     GALAHAD_QORM2R
#define DORMBR     GALAHAD_QORMBR
#define DORMHR     GALAHAD_QORMHR
#define DORML2     GALAHAD_QORML2
#define DORMLQ     GALAHAD_QORMLQ
#define DORMQR     GALAHAD_QORMQR
#define DORMR3     GALAHAD_QORMR3
#define DORMRZ     GALAHAD_QORMRZ
#define DPBTF2     GALAHAD_QPBTF2
#define DPBTRF     GALAHAD_QPBTRF
#define DPBTRS     GALAHAD_QPBTRS
#define DPOTF2     GALAHAD_QPOTF2
#define DPOTRF     GALAHAD_QPOTRF
#define DPOTRF2    GALAHAD_QPOTRF2
#define DPOTRS     GALAHAD_QPOTRS
#define DPTTRF     GALAHAD_QPTTRF
#define DPTTRS     GALAHAD_QPTTRS
#define DPTTS2     GALAHAD_QPTTS2
#define DRSCL      GALAHAD_QRSCL
#define DSTEQR     GALAHAD_QSTEQR
#define DSTERF     GALAHAD_QSTERF
#define DSYEV      GALAHAD_QSYEV
#define DSYGS2     GALAHAD_QSYGS2
#define DSYGST     GALAHAD_QSYGST
#define DSYGV      GALAHAD_QSYGV
#define DSYTD2     GALAHAD_QSYTD2
#define DSYTF2     GALAHAD_QSYTF2
#define DSYTRD     GALAHAD_QSYTRD
#define DSYTRF     GALAHAD_QSYTRF
#define DSYTRS     GALAHAD_QSYTRS
#define DTREXC     GALAHAD_QTREXC
#define DTRTRS     GALAHAD_QTRTRS
#define DTZRZF     GALAHAD_QTZRZF
#define ILADLC     GALAHAD_ILAQLC
#define ILADLR     GALAHAD_ILAQLR
#else
#define DBDSQR     QBDSQR
#define DCOMBS     QCOMBS
#define DCOMBSSQ   QCOMBSSQ
#define DGEBD2     QGEBD2
#define DGEBRD     QGEBRD
#define DGEHD2     QGEHD2
#define DGEHRD     QGEHRD
#define DGELQ2     QGELQ2
#define DGELQF     QGELQF
#define DGELS      QGELS
#define DGELSD     QGELSD
#define DGELSS     QGELSS
#define DGELSY     QGELSY
#define DGEQP3     QGEQP3
#define DGEQR2     QGEQR2
#define DGEQRF     QGEQRF
#define DGESV      QGESV
#define DGESVD     QGESVD
#define DGETF2     QGETF2
#define DGETRF     QGETRF
#define DGETRF2    QGETRF2
#define DGETRS     QGETRS
#define DHSEQR     QHSEQR
#define DISNAN     QISNAN
#define DLABAD     QLABAD
#define DLABRD     QLABRD
#define DLACPY     QLACPY
#define DLAE2      QLAE2
#define DLAED6     QLAED6
#define DLAEV2     QLAEV2
#define DLAEXC     QLAEXC
#define DLAHQR     QLAHQR
#define DLAHR2     QLAHR2
#define DLAIC1     QLAIC1
#define DLAISN     QLAISN
#define DLAISNAN   QLAISNAN
#define DLALS0     QLALS0
#define DLALSA     QLALSA
#define DLALSD     QLALSD
#define DLAMC3     QLAMC3
#define DLAMCH     QLAMCH
#define DLAMRG     QLAMRG
#define DLANGE     QLANGE
#define DLANST     QLANST
#define DLANSY     QLANSY
#define DLANV2     QLANV2
#define DLAPY2     QLAPY2
#define DLAQP2     QLAQP2
#define DLAQPS     QLAQPS
#define DLAQR0     QLAQR0
#define DLAQR1     QLAQR1
#define DLAQR2     QLAQR2
#define DLAQR3     QLAQR3
#define DLAQR4     QLAQR4
#define DLAQR5     QLAQR5
#define DLARF      QLARF
#define DLARFB     QLARFB
#define DLARFG     QLARFG
#define DLARFT     QLARFT
#define DLARFX     QLARFX
#define DLARTG     QLARTG
#define DLARZ      QLARZ
#define DLARZB     QLARZB
#define DLARZT     QLARZT
#define DLAS2      QLAS2
#define DLASCL     QLASCL
#define DLASD4     QLASD4
#define DLASD5     QLASD5
#define DLASD6     QLASD6
#define DLASD7     QLASD7
#define DLASD8     QLASD8
#define DLASDA     QLASDA
#define DLASDQ     QLASDQ
#define DLASDT     QLASDT
#define DLASET     QLASET
#define DLASQ1     QLASQ1
#define DLASQ2     QLASQ2
#define DLASQ3     QLASQ3
#define DLASQ4     QLASQ4
#define DLASQ5     QLASQ5
#define DLASQ6     QLASQ6
#define DLASR      QLASR
#define DLASRT     QLASRT
#define DLASSQ     QLASSQ
#define DLASV2     QLASV2
#define DLASWP     QLASWP
#define DLASY2     QLASY2
#define DLASYF     QLASYF
#define DLATRD     QLATRD
#define DLATRZ     QLATRZ
#define DORG2L     QORG2L
#define DORG2R     QORG2R
#define DORGBR     QORGBR
#define DORGL2     QORGL2
#define DORGLQ     QORGLQ
#define DORGQL     QORGQL
#define DORGQR     QORGQR
#define DORGTR     QORGTR
#define DORM2R     QORM2R
#define DORMBR     QORMBR
#define DORMHR     QORMHR
#define DORML2     QORML2
#define DORMLQ     QORMLQ
#define DORMQR     QORMQR
#define DORMR3     QORMR3
#define DORMRZ     QORMRZ
#define DPBTF2     QPBTF2
#define DPBTRF     QPBTRF
#define DPBTRS     QPBTRS
#define DPOTF2     QPOTF2
#define DPOTRF     QPOTRF
#define DPOTRF2    QPOTRF2
#define DPOTRS     QPOTRS
#define DPTTRF     QPTTRF
#define DPTTRS     QPTTRS
#define DPTTS2     QPTTS2
#define DRSCL      QRSCL
#define DSTEQR     QSTEQR
#define DSTERF     QSTERF
#define DSYEV      QSYEV
#define DSYGS2     QSYGS2
#define DSYGST     QSYGST
#define DSYGV      QSYGV
#define DSYTD2     QSYTD2
#define DSYTF2     QSYTF2
#define DSYTRD     QSYTRD
#define DSYTRF     QSYTRF
#define DSYTRS     QSYTRS
#define DTREXC     QTREXC
#define DTRTRS     QTRTRS
#define DTZRZF     QTZRZF
#define ILADLC     ILAQLC
#define ILADLR     ILAQLR
#endif
#endif

#else

#ifdef INTEGER_64
#ifdef GALAHAD_LAPACK
#define DBDSQR     GALAHAD_DBDSQR_64
#define DCOMBS     GALAHAD_DCOMBS_64
#define DCOMBSSQ   GALAHAD_DCOMBSSQ_64
#define DGEBD2     GALAHAD_DGEBD2_64
#define DGEBRD     GALAHAD_DGEBRD_64
#define DGEHD2     GALAHAD_DGEHD2_64
#define DGEHRD     GALAHAD_DGEHRD_64
#define DGELQ2     GALAHAD_DGELQ2_64
#define DGELQF     GALAHAD_DGELQF_64
#define DGELS      GALAHAD_DGELS_64
#define DGELSD     GALAHAD_DGELSD_64
#define DGELSS     GALAHAD_DGELSS_64
#define DGELSY     GALAHAD_DGELSY_64
#define DGEQP3     GALAHAD_DGEQP3_64
#define DGEQR2     GALAHAD_DGEQR2_64
#define DGEQRF     GALAHAD_DGEQRF_64
#define DGESV      GALAHAD_DGESV_64
#define DGESVD     GALAHAD_DGESVD_64
#define DGETF2     GALAHAD_DGETF2_64
#define DGETRF     GALAHAD_DGETRF_64
#define DGETRF2    GALAHAD_DGETRF2_64
#define DGETRS     GALAHAD_DGETRS_64
#define DHSEQR     GALAHAD_DHSEQR_64
#define DISNAN     GALAHAD_DISNAN_64
#define DLABAD     GALAHAD_DLABAD_64
#define DLABRD     GALAHAD_DLABRD_64
#define DLACPY     GALAHAD_DLACPY_64
#define DLAE2      GALAHAD_DLAE2_64
#define DLAED6     GALAHAD_DLAED6_64
#define DLAEV2     GALAHAD_DLAEV2_64
#define DLAEXC     GALAHAD_DLAEXC_64
#define DLAHQR     GALAHAD_DLAHQR_64
#define DLAHR2     GALAHAD_DLAHR2_64
#define DLAIC1     GALAHAD_DLAIC1_64
#define DLAISN     GALAHAD_DLAISN_64
#define DLAISNAN   GALAHAD_DLAISNAN_64
#define DLALS0     GALAHAD_DLALS0_64
#define DLALSA     GALAHAD_DLALSA_64
#define DLALSD     GALAHAD_DLALSD_64
#define DLAMC3     GALAHAD_DLAMC3_64
#define DLAMCH     GALAHAD_DLAMCH_64
#define DLAMRG     GALAHAD_DLAMRG_64
#define DLANGE     GALAHAD_DLANGE_64
#define DLANST     GALAHAD_DLANST_64
#define DLANSY     GALAHAD_DLANSY_64
#define DLANV2     GALAHAD_DLANV2_64
#define DLAPY2     GALAHAD_DLAPY2_64
#define DLAQP2     GALAHAD_DLAQP2_64
#define DLAQPS     GALAHAD_DLAQPS_64
#define DLAQR0     GALAHAD_DLAQR0_64
#define DLAQR1     GALAHAD_DLAQR1_64
#define DLAQR2     GALAHAD_DLAQR2_64
#define DLAQR3     GALAHAD_DLAQR3_64
#define DLAQR4     GALAHAD_DLAQR4_64
#define DLAQR5     GALAHAD_DLAQR5_64
#define DLARF      GALAHAD_DLARF_64
#define DLARFB     GALAHAD_DLARFB_64
#define DLARFG     GALAHAD_DLARFG_64
#define DLARFT     GALAHAD_DLARFT_64
#define DLARFX     GALAHAD_DLARFX_64
#define DLARTG     GALAHAD_DLARTG_64
#define DLARZ      GALAHAD_DLARZ_64
#define DLARZB     GALAHAD_DLARZB_64
#define DLARZT     GALAHAD_DLARZT_64
#define DLAS2      GALAHAD_DLAS2_64
#define DLASCL     GALAHAD_DLASCL_64
#define DLASD4     GALAHAD_DLASD4_64
#define DLASD5     GALAHAD_DLASD5_64
#define DLASD6     GALAHAD_DLASD6_64
#define DLASD7     GALAHAD_DLASD7_64
#define DLASD8     GALAHAD_DLASD8_64
#define DLASDA     GALAHAD_DLASDA_64
#define DLASDQ     GALAHAD_DLASDQ_64
#define DLASDT     GALAHAD_DLASDT_64
#define DLASET     GALAHAD_DLASET_64
#define DLASQ1     GALAHAD_DLASQ1_64
#define DLASQ2     GALAHAD_DLASQ2_64
#define DLASQ3     GALAHAD_DLASQ3_64
#define DLASQ4     GALAHAD_DLASQ4_64
#define DLASQ5     GALAHAD_DLASQ5_64
#define DLASQ6     GALAHAD_DLASQ6_64
#define DLASR      GALAHAD_DLASR_64
#define DLASRT     GALAHAD_DLASRT_64
#define DLASSQ     GALAHAD_DLASSQ_64
#define DLASV2     GALAHAD_DLASV2_64
#define DLASWP     GALAHAD_DLASWP_64
#define DLASY2     GALAHAD_DLASY2_64
#define DLASYF     GALAHAD_DLASYF_64
#define DLATRD     GALAHAD_DLATRD_64
#define DLATRZ     GALAHAD_DLATRZ_64
#define DORG2L     GALAHAD_DORG2L_64
#define DORG2R     GALAHAD_DORG2R_64
#define DORGBR     GALAHAD_DORGBR_64
#define DORGL2     GALAHAD_DORGL2_64
#define DORGLQ     GALAHAD_DORGLQ_64
#define DORGQL     GALAHAD_DORGQL_64
#define DORGQR     GALAHAD_DORGQR_64
#define DORGTR     GALAHAD_DORGTR_64
#define DORM2R     GALAHAD_DORM2R_64
#define DORMBR     GALAHAD_DORMBR_64
#define DORMHR     GALAHAD_DORMHR_64
#define DORML2     GALAHAD_DORML2_64
#define DORMLQ     GALAHAD_DORMLQ_64
#define DORMQR     GALAHAD_DORMQR_64
#define DORMR3     GALAHAD_DORMR3_64
#define DORMRZ     GALAHAD_DORMRZ_64
#define DPBTF2     GALAHAD_DPBTF2_64
#define DPBTRF     GALAHAD_DPBTRF_64
#define DPBTRS     GALAHAD_DPBTRS_64
#define DPOTF2     GALAHAD_DPOTF2_64
#define DPOTRF     GALAHAD_DPOTRF_64
#define DPOTRF2    GALAHAD_DPOTRF2_64
#define DPOTRS     GALAHAD_DPOTRS_64
#define DPTTRF     GALAHAD_DPTTRF_64
#define DPTTRS     GALAHAD_DPTTRS_64
#define DPTTS2     GALAHAD_DPTTS2_64
#define DRSCL      GALAHAD_DRSCL_64
#define DSTEQR     GALAHAD_DSTEQR_64
#define DSTERF     GALAHAD_DSTERF_64
#define DSYEV      GALAHAD_DSYEV_64
#define DSYGS2     GALAHAD_DSYGS2_64
#define DSYGST     GALAHAD_DSYGST_64
#define DSYGV      GALAHAD_DSYGV_64
#define DSYTD2     GALAHAD_DSYTD2_64
#define DSYTF2     GALAHAD_DSYTF2_64
#define DSYTRD     GALAHAD_DSYTRD_64
#define DSYTRF     GALAHAD_DSYTRF_64
#define DSYTRS     GALAHAD_DSYTRS_64
#define DTREXC     GALAHAD_DTREXC_64
#define DTRTRS     GALAHAD_DTRTRS_64
#define DTZRZF     GALAHAD_DTZRZF_64
#define ILADLC     GALAHAD_ILADLC_64
#define ILADLR     GALAHAD_ILADLR_64
#else
#ifdef NO_UNDERSCORE_INTEGER_64
#define DBDSQR     DBDSQR64
#define DCOMBS     DCOMBS64
#define DCOMBSSQ   DCOMBSSQ64
#define DGEBD2     DGEBD264
#define DGEBRD     DGEBRD64
#define DGEHD2     DGEHD264
#define DGEHRD     DGEHRD64
#define DGELQ2     DGELQ264
#define DGELQF     DGELQF64
#define DGELS      DGELS64
#define DGELSD     DGELSD64
#define DGELSS     DGELSS64
#define DGELSY     DGELSY64
#define DGEQP3     DGEQP364
#define DGEQR2     DGEQR264
#define DGEQRF     DGEQRF64
#define DGESV      DGESV64
#define DGESVD     DGESVD64
#define DGETF2     DGETF264
#define DGETRF     DGETRF64
#define DGETRF2    DGETRF264
#define DGETRS     DGETRS64
#define DHSEQR     DHSEQR64
#define DISNAN     DISNAN64
#define DLABAD     DLABAD64
#define DLABRD     DLABRD64
#define DLACPY     DLACPY64
#define DLAE2      DLAE264
#define DLAED6     DLAED664
#define DLAEV2     DLAEV264
#define DLAEXC     DLAEXC64
#define DLAHQR     DLAHQR64
#define DLAHR2     DLAHR264
#define DLAIC1     DLAIC164
#define DLAISN     DLAISN64
#define DLAISNAN   DLAISNAN64
#define DLALS0     DLALS064
#define DLALSA     DLALSA64
#define DLALSD     DLALSD64
#define DLAMC3     DLAMC364
#define DLAMCH     DLAMCH64
#define DLAMRG     DLAMRG64
#define DLANGE     DLANGE64
#define DLANST     DLANST64
#define DLANSY     DLANSY64
#define DLANV2     DLANV264
#define DLAPY2     DLAPY264
#define DLAQP2     DLAQP264
#define DLAQPS     DLAQPS64
#define DLAQR0     DLAQR064
#define DLAQR1     DLAQR164
#define DLAQR2     DLAQR264
#define DLAQR3     DLAQR364
#define DLAQR4     DLAQR464
#define DLAQR5     DLAQR564
#define DLARF      DLARF64
#define DLARFB     DLARFB64
#define DLARFG     DLARFG64
#define DLARFT     DLARFT64
#define DLARFX     DLARFX64
#define DLARTG     DLARTG64
#define DLARZ      DLARZ64
#define DLARZB     DLARZB64
#define DLARZT     DLARZT64
#define DLAS2      DLAS264
#define DLASCL     DLASCL64
#define DLASD4     DLASD464
#define DLASD5     DLASD564
#define DLASD6     DLASD664
#define DLASD7     DLASD764
#define DLASD8     DLASD864
#define DLASDA     DLASDA64
#define DLASDQ     DLASDQ64
#define DLASDT     DLASDT64
#define DLASET     DLASET64
#define DLASQ1     DLASQ164
#define DLASQ2     DLASQ264
#define DLASQ3     DLASQ364
#define DLASQ4     DLASQ464
#define DLASQ5     DLASQ564
#define DLASQ6     DLASQ664
#define DLASR      DLASR64
#define DLASRT     DLASRT64
#define DLASSQ     DLASSQ64
#define DLASV2     DLASV264
#define DLASWP     DLASWP64
#define DLASY2     DLASY264
#define DLASYF     DLASYF64
#define DLATRD     DLATRD64
#define DLATRZ     DLATRZ64
#define DORG2L     DORG2L64
#define DORG2R     DORG2R64
#define DORGBR     DORGBR64
#define DORGL2     DORGL264
#define DORGLQ     DORGLQ64
#define DORGQL     DORGQL64
#define DORGQR     DORGQR64
#define DORGTR     DORGTR64
#define DORM2R     DORM2R64
#define DORMBR     DORMBR64
#define DORMHR     DORMHR64
#define DORML2     DORML264
#define DORMLQ     DORMLQ64
#define DORMQR     DORMQR64
#define DORMR3     DORMR364
#define DORMRZ     DORMRZ64
#define DPBTF2     DPBTF264
#define DPBTRF     DPBTRF64
#define DPBTRS     DPBTRS64
#define DPOTF2     DPOTF264
#define DPOTRF     DPOTRF64
#define DPOTRF2    DPOTRF264
#define DPOTRS     DPOTRS64
#define DPTTRF     DPTTRF64
#define DPTTRS     DPTTRS64
#define DPTTS2     DPTTS264
#define DRSCL      DRSCL64
#define DSTEQR     DSTEQR64
#define DSTERF     DSTERF64
#define DSYEV      DSYEV64
#define DSYGS2     DSYGS264
#define DSYGST     DSYGST64
#define DSYGV      DSYGV64
#define DSYTD2     DSYTD264
#define DSYTF2     DSYTF264
#define DSYTRD     DSYTRD64
#define DSYTRF     DSYTRF64
#define DSYTRS     DSYTRS64
#define DTREXC     DTREXC64
#define DTRTRS     DTRTRS64
#define DTZRZF     DTZRZF64
#define ILADLC     ILADLC64
#define ILADLR     ILADLR64
#elif DOUBLE_UNDERSCORE_INTEGER_64
#define DBDSQR     DBDSQR__64
#define DCOMBS     DCOMBS__64
#define DCOMBSSQ   DCOMBSSQ__64
#define DGEBD2     DGEBD2__64
#define DGEBRD     DGEBRD__64
#define DGEHD2     DGEHD2__64
#define DGEHRD     DGEHRD__64
#define DGELQ2     DGELQ2__64
#define DGELQF     DGELQF__64
#define DGELS      DGELS__64
#define DGELSD     DGELSD__64
#define DGELSS     DGELSS__64
#define DGELSY     DGELSY__64
#define DGEQP3     DGEQP3__64
#define DGEQR2     DGEQR2__64
#define DGEQRF     DGEQRF__64
#define DGESV      DGESV__64
#define DGESVD     DGESVD__64
#define DGETF2     DGETF2__64
#define DGETRF     DGETRF__64
#define DGETRF2    DGETRF2__64
#define DGETRS     DGETRS__64
#define DHSEQR     DHSEQR__64
#define DISNAN     DISNAN__64
#define DLABAD     DLABAD__64
#define DLABRD     DLABRD__64
#define DLACPY     DLACPY__64
#define DLAE2      DLAE2__64
#define DLAED6     DLAED6__64
#define DLAEV2     DLAEV2__64
#define DLAEXC     DLAEXC__64
#define DLAHQR     DLAHQR__64
#define DLAHR2     DLAHR2__64
#define DLAIC1     DLAIC1__64
#define DLAISN     DLAISN__64
#define DLAISNAN   DLAISNAN__64
#define DLALS0     DLALS0__64
#define DLALSA     DLALSA__64
#define DLALSD     DLALSD__64
#define DLAMC3     DLAMC3__64
#define DLAMCH     DLAMCH__64
#define DLAMRG     DLAMRG__64
#define DLANGE     DLANGE__64
#define DLANST     DLANST__64
#define DLANSY     DLANSY__64
#define DLANV2     DLANV2__64
#define DLAPY2     DLAPY2__64
#define DLAQP2     DLAQP2__64
#define DLAQPS     DLAQPS__64
#define DLAQR0     DLAQR0__64
#define DLAQR1     DLAQR1__64
#define DLAQR2     DLAQR2__64
#define DLAQR3     DLAQR3__64
#define DLAQR4     DLAQR4__64
#define DLAQR5     DLAQR5__64
#define DLARF      DLARF__64
#define DLARFB     DLARFB__64
#define DLARFG     DLARFG__64
#define DLARFT     DLARFT__64
#define DLARFX     DLARFX__64
#define DLARTG     DLARTG__64
#define DLARZ      DLARZ__64
#define DLARZB     DLARZB__64
#define DLARZT     DLARZT__64
#define DLAS2      DLAS2__64
#define DLASCL     DLASCL__64
#define DLASD4     DLASD4__64
#define DLASD5     DLASD5__64
#define DLASD6     DLASD6__64
#define DLASD7     DLASD7__64
#define DLASD8     DLASD8__64
#define DLASDA     DLASDA__64
#define DLASDQ     DLASDQ__64
#define DLASDT     DLASDT__64
#define DLASET     DLASET__64
#define DLASQ1     DLASQ1__64
#define DLASQ2     DLASQ2__64
#define DLASQ3     DLASQ3__64
#define DLASQ4     DLASQ4__64
#define DLASQ5     DLASQ5__64
#define DLASQ6     DLASQ6__64
#define DLASR      DLASR__64
#define DLASRT     DLASRT__64
#define DLASSQ     DLASSQ__64
#define DLASV2     DLASV2__64
#define DLASWP     DLASWP__64
#define DLASY2     DLASY2__64
#define DLASYF     DLASYF__64
#define DLATRD     DLATRD__64
#define DLATRZ     DLATRZ__64
#define DORG2L     DORG2L__64
#define DORG2R     DORG2R__64
#define DORGBR     DORGBR__64
#define DORGL2     DORGL2__64
#define DORGLQ     DORGLQ__64
#define DORGQL     DORGQL__64
#define DORGQR     DORGQR__64
#define DORGTR     DORGTR__64
#define DORM2R     DORM2R__64
#define DORMBR     DORMBR__64
#define DORMHR     DORMHR__64
#define DORML2     DORML2__64
#define DORMLQ     DORMLQ__64
#define DORMQR     DORMQR__64
#define DORMR3     DORMR3__64
#define DORMRZ     DORMRZ__64
#define DPBTF2     DPBTF2__64
#define DPBTRF     DPBTRF__64
#define DPBTRS     DPBTRS__64
#define DPOTF2     DPOTF2__64
#define DPOTRF     DPOTRF__64
#define DPOTRF2    DPOTRF2__64
#define DPOTRS     DPOTRS__64
#define DPTTRF     DPTTRF__64
#define DPTTRS     DPTTRS__64
#define DPTTS2     DPTTS2__64
#define DRSCL      DRSCL__64
#define DSTEQR     DSTEQR__64
#define DSTERF     DSTERF__64
#define DSYEV      DSYEV__64
#define DSYGS2     DSYGS2__64
#define DSYGST     DSYGST__64
#define DSYGV      DSYGV__64
#define DSYTD2     DSYTD2__64
#define DSYTF2     DSYTF2__64
#define DSYTRD     DSYTRD__64
#define DSYTRF     DSYTRF__64
#define DSYTRS     DSYTRS__64
#define DTREXC     DTREXC__64
#define DTRTRS     DTRTRS__64
#define DTZRZF     DTZRZF__64
#define ILADLC     ILADLC__64
#define ILADLR     ILADLR__64
#elif NO_SYMBOL_INTEGER_64
#else
#define DBDSQR     DBDSQR_64
#define DCOMBS     DCOMBS_64
#define DCOMBSSQ   DCOMBSSQ_64
#define DGEBD2     DGEBD2_64
#define DGEBRD     DGEBRD_64
#define DGEHD2     DGEHD2_64
#define DGEHRD     DGEHRD_64
#define DGELQ2     DGELQ2_64
#define DGELQF     DGELQF_64
#define DGELS      DGELS_64
#define DGELSD     DGELSD_64
#define DGELSS     DGELSS_64
#define DGELSY     DGELSY_64
#define DGEQP3     DGEQP3_64
#define DGEQR2     DGEQR2_64
#define DGEQRF     DGEQRF_64
#define DGESV      DGESV_64
#define DGESVD     DGESVD_64
#define DGETF2     DGETF2_64
#define DGETRF     DGETRF_64
#define DGETRF2    DGETRF2_64
#define DGETRS     DGETRS_64
#define DHSEQR     DHSEQR_64
#define DISNAN     DISNAN_64
#define DLABAD     DLABAD_64
#define DLABRD     DLABRD_64
#define DLACPY     DLACPY_64
#define DLAE2      DLAE2_64
#define DLAED6     DLAED6_64
#define DLAEV2     DLAEV2_64
#define DLAEXC     DLAEXC_64
#define DLAHQR     DLAHQR_64
#define DLAHR2     DLAHR2_64
#define DLAIC1     DLAIC1_64
#define DLAISN     DLAISN_64
#define DLAISNAN   DLAISNAN_64
#define DLALS0     DLALS0_64
#define DLALSA     DLALSA_64
#define DLALSD     DLALSD_64
#define DLAMC3     DLAMC3_64
#define DLAMCH     DLAMCH_64
#define DLAMRG     DLAMRG_64
#define DLANGE     DLANGE_64
#define DLANST     DLANST_64
#define DLANSY     DLANSY_64
#define DLANV2     DLANV2_64
#define DLAPY2     DLAPY2_64
#define DLAQP2     DLAQP2_64
#define DLAQPS     DLAQPS_64
#define DLAQR0     DLAQR0_64
#define DLAQR1     DLAQR1_64
#define DLAQR2     DLAQR2_64
#define DLAQR3     DLAQR3_64
#define DLAQR4     DLAQR4_64
#define DLAQR5     DLAQR5_64
#define DLARF      DLARF_64
#define DLARFB     DLARFB_64
#define DLARFG     DLARFG_64
#define DLARFT     DLARFT_64
#define DLARFX     DLARFX_64
#define DLARTG     DLARTG_64
#define DLARZ      DLARZ_64
#define DLARZB     DLARZB_64
#define DLARZT     DLARZT_64
#define DLAS2      DLAS2_64
#define DLASCL     DLASCL_64
#define DLASD4     DLASD4_64
#define DLASD5     DLASD5_64
#define DLASD6     DLASD6_64
#define DLASD7     DLASD7_64
#define DLASD8     DLASD8_64
#define DLASDA     DLASDA_64
#define DLASDQ     DLASDQ_64
#define DLASDT     DLASDT_64
#define DLASET     DLASET_64
#define DLASQ1     DLASQ1_64
#define DLASQ2     DLASQ2_64
#define DLASQ3     DLASQ3_64
#define DLASQ4     DLASQ4_64
#define DLASQ5     DLASQ5_64
#define DLASQ6     DLASQ6_64
#define DLASR      DLASR_64
#define DLASRT     DLASRT_64
#define DLASSQ     DLASSQ_64
#define DLASV2     DLASV2_64
#define DLASWP     DLASWP_64
#define DLASY2     DLASY2_64
#define DLASYF     DLASYF_64
#define DLATRD     DLATRD_64
#define DLATRZ     DLATRZ_64
#define DORG2L     DORG2L_64
#define DORG2R     DORG2R_64
#define DORGBR     DORGBR_64
#define DORGL2     DORGL2_64
#define DORGLQ     DORGLQ_64
#define DORGQL     DORGQL_64
#define DORGQR     DORGQR_64
#define DORGTR     DORGTR_64
#define DORM2R     DORM2R_64
#define DORMBR     DORMBR_64
#define DORMHR     DORMHR_64
#define DORML2     DORML2_64
#define DORMLQ     DORMLQ_64
#define DORMQR     DORMQR_64
#define DORMR3     DORMR3_64
#define DORMRZ     DORMRZ_64
#define DPBTF2     DPBTF2_64
#define DPBTRF     DPBTRF_64
#define DPBTRS     DPBTRS_64
#define DPOTF2     DPOTF2_64
#define DPOTRF     DPOTRF_64
#define DPOTRF2    DPOTRF2_64
#define DPOTRS     DPOTRS_64
#define DPTTRF     DPTTRF_64
#define DPTTRS     DPTTRS_64
#define DPTTS2     DPTTS2_64
#define DRSCL      DRSCL_64
#define DSTEQR     DSTEQR_64
#define DSTERF     DSTERF_64
#define DSYEV      DSYEV_64
#define DSYGS2     DSYGS2_64
#define DSYGST     DSYGST_64
#define DSYGV      DSYGV_64
#define DSYTD2     DSYTD2_64
#define DSYTF2     DSYTF2_64
#define DSYTRD     DSYTRD_64
#define DSYTRF     DSYTRF_64
#define DSYTRS     DSYTRS_64
#define DTREXC     DTREXC_64
#define DTRTRS     DTRTRS_64
#define DTZRZF     DTZRZF_64
#define ILADLC     ILADLC_64
#define ILADLR     ILADLR_64
#endif
#endif

#else
#ifdef GALAHAD_LAPACK
#define DBDSQR     GALAHAD_DBDSQR
#define DCOMBS     GALAHAD_DCOMBS
#define DCOMBSSQ   GALAHAD_DCOMBSSQ
#define DGEBD2     GALAHAD_DGEBD2
#define DGEBRD     GALAHAD_DGEBRD
#define DGEHD2     GALAHAD_DGEHD2
#define DGEHRD     GALAHAD_DGEHRD
#define DGELQ2     GALAHAD_DGELQ2
#define DGELQF     GALAHAD_DGELQF
#define DGELS      GALAHAD_DGELS
#define DGELSD     GALAHAD_DGELSD
#define DGELSS     GALAHAD_DGELSS
#define DGELSY     GALAHAD_DGELSY
#define DGEQP3     GALAHAD_DGEQP3
#define DGEQR2     GALAHAD_DGEQR2
#define DGEQRF     GALAHAD_DGEQRF
#define DGESV      GALAHAD_DGESV
#define DGESVD     GALAHAD_DGESVD
#define DGETF2     GALAHAD_DGETF2
#define DGETRF     GALAHAD_DGETRF
#define DGETRF2    GALAHAD_DGETRF2
#define DGETRS     GALAHAD_DGETRS
#define DHSEQR     GALAHAD_DHSEQR
#define DISNAN     GALAHAD_DISNAN
#define DLABAD     GALAHAD_DLABAD
#define DLABRD     GALAHAD_DLABRD
#define DLACPY     GALAHAD_DLACPY
#define DLAE2      GALAHAD_DLAE2
#define DLAED6     GALAHAD_DLAED6
#define DLAEV2     GALAHAD_DLAEV2
#define DLAEXC     GALAHAD_DLAEXC
#define DLAHQR     GALAHAD_DLAHQR
#define DLAHR2     GALAHAD_DLAHR2
#define DLAIC1     GALAHAD_DLAIC1
#define DLAISN     GALAHAD_DLAISN
#define DLAISNAN   GALAHAD_DLAISNAN
#define DLALS0     GALAHAD_DLALS0
#define DLALSA     GALAHAD_DLALSA
#define DLALSD     GALAHAD_DLALSD
#define DLAMC3     GALAHAD_DLAMC3
#define DLAMCH     GALAHAD_DLAMCH
#define DLAMRG     GALAHAD_DLAMRG
#define DLANGE     GALAHAD_DLANGE
#define DLANST     GALAHAD_DLANST
#define DLANSY     GALAHAD_DLANSY
#define DLANV2     GALAHAD_DLANV2
#define DLAPY2     GALAHAD_DLAPY2
#define DLAQP2     GALAHAD_DLAQP2
#define DLAQPS     GALAHAD_DLAQPS
#define DLAQR0     GALAHAD_DLAQR0
#define DLAQR1     GALAHAD_DLAQR1
#define DLAQR2     GALAHAD_DLAQR2
#define DLAQR3     GALAHAD_DLAQR3
#define DLAQR4     GALAHAD_DLAQR4
#define DLAQR5     GALAHAD_DLAQR5
#define DLARF      GALAHAD_DLARF
#define DLARFB     GALAHAD_DLARFB
#define DLARFG     GALAHAD_DLARFG
#define DLARFT     GALAHAD_DLARFT
#define DLARFX     GALAHAD_DLARFX
#define DLARTG     GALAHAD_DLARTG
#define DLARZ      GALAHAD_DLARZ
#define DLARZB     GALAHAD_DLARZB
#define DLARZT     GALAHAD_DLARZT
#define DLAS2      GALAHAD_DLAS2
#define DLASCL     GALAHAD_DLASCL
#define DLASD4     GALAHAD_DLASD4
#define DLASD5     GALAHAD_DLASD5
#define DLASD6     GALAHAD_DLASD6
#define DLASD7     GALAHAD_DLASD7
#define DLASD8     GALAHAD_DLASD8
#define DLASDA     GALAHAD_DLASDA
#define DLASDQ     GALAHAD_DLASDQ
#define DLASDT     GALAHAD_DLASDT
#define DLASET     GALAHAD_DLASET
#define DLASQ1     GALAHAD_DLASQ1
#define DLASQ2     GALAHAD_DLASQ2
#define DLASQ3     GALAHAD_DLASQ3
#define DLASQ4     GALAHAD_DLASQ4
#define DLASQ5     GALAHAD_DLASQ5
#define DLASQ6     GALAHAD_DLASQ6
#define DLASR      GALAHAD_DLASR
#define DLASRT     GALAHAD_DLASRT
#define DLASSQ     GALAHAD_DLASSQ
#define DLASV2     GALAHAD_DLASV2
#define DLASWP     GALAHAD_DLASWP
#define DLASY2     GALAHAD_DLASY2
#define DLASYF     GALAHAD_DLASYF
#define DLATRD     GALAHAD_DLATRD
#define DLATRZ     GALAHAD_DLATRZ
#define DORG2L     GALAHAD_DORG2L
#define DORG2R     GALAHAD_DORG2R
#define DORGBR     GALAHAD_DORGBR
#define DORGL2     GALAHAD_DORGL2
#define DORGLQ     GALAHAD_DORGLQ
#define DORGQL     GALAHAD_DORGQL
#define DORGQR     GALAHAD_DORGQR
#define DORGTR     GALAHAD_DORGTR
#define DORM2R     GALAHAD_DORM2R
#define DORMBR     GALAHAD_DORMBR
#define DORMHR     GALAHAD_DORMHR
#define DORML2     GALAHAD_DORML2
#define DORMLQ     GALAHAD_DORMLQ
#define DORMQR     GALAHAD_DORMQR
#define DORMR3     GALAHAD_DORMR3
#define DORMRZ     GALAHAD_DORMRZ
#define DPBTF2     GALAHAD_DPBTF2
#define DPBTRF     GALAHAD_DPBTRF
#define DPBTRS     GALAHAD_DPBTRS
#define DPOTF2     GALAHAD_DPOTF2
#define DPOTRF     GALAHAD_DPOTRF
#define DPOTRF2    GALAHAD_DPOTRF2
#define DPOTRS     GALAHAD_DPOTRS
#define DPTTRF     GALAHAD_DPTTRF
#define DPTTRS     GALAHAD_DPTTRS
#define DPTTS2     GALAHAD_DPTTS2
#define DRSCL      GALAHAD_DRSCL
#define DSTEQR     GALAHAD_DSTEQR
#define DSTERF     GALAHAD_DSTERF
#define DSYEV      GALAHAD_DSYEV
#define DSYGS2     GALAHAD_DSYGS2
#define DSYGST     GALAHAD_DSYGST
#define DSYGV      GALAHAD_DSYGV
#define DSYTD2     GALAHAD_DSYTD2
#define DSYTF2     GALAHAD_DSYTF2
#define DSYTRD     GALAHAD_DSYTRD
#define DSYTRF     GALAHAD_DSYTRF
#define DSYTRS     GALAHAD_DSYTRS
#define DTREXC     GALAHAD_DTREXC
#define DTRTRS     GALAHAD_DTRTRS
#define DTZRZF     GALAHAD_DTZRZF
#define ILADLC     GALAHAD_ILADLC
#define ILADLR     GALAHAD_ILADLR
#else
#endif
#endif

#endif

