#ifdef INTEGER_64
#define GALAHAD_SYMBOLS galahad_symbols_64
#define SPRAL_KINDS spral_kinds_64
#define spral_kinds spral_kinds_64
#define spral_ssids_lapack_iface spral_ssids_lapack_iface_64
#define spral_ssids_blas_iface spral_ssids_blas_iface_64
#define spral_core_analyse spral_core_analyse_64
#define spral_hw_topology spral_hw_topology_64
#define spral_ssids_profile spral_ssids_profile_64
#define spral_metis_wrapper spral_metis_wrapper_64
#define spral_pgm spral_pgm_64
#endif

#ifdef REAL_32
#ifdef INTEGER_64
#define GALAHAD_KINDS_single galahad_kinds_single_64
#define GALAHAD_NODEND_precision GALAHAD_NODEND_single_64
#define SPRAL_SSIDS_single spral_ssids_single_64
#define SPRAL_SSIDS_precision spral_ssids_single_64
#define SPRAL_SSIDS_precision_ciface spral_ssids_single_ciface_64
#else
#define GALAHAD_NODEND_precision GALAHAD_NODEND_single
#define SPRAL_SSIDS_precision spral_ssids_single
#define SPRAL_SSIDS_precision_ciface spral_ssids_single_ciface
#endif
#elif REAL_128
#ifdef INTEGER_64
#define GALAHAD_KINDS_quadruple galahad_kinds_quadruple_64
#define GALAHAD_NODEND_precision GALAHAD_NODEND_quadruple_64
#define SPRAL_SSIDS_quadruple spral_ssids_quadruple_64
#define SPRAL_SSIDS_precision spral_ssids_quadruple_64
#define SPRAL_SSIDS_precision_ciface spral_ssids_quadruple_ciface_64
#else
#define GALAHAD_NODEND_precision GALAHAD_NODEND_quadruple
#define SPRAL_SSIDS_precision spral_ssids_quadruple
#define SPRAL_SSIDS_precision_ciface spral_ssids_quadruple_ciface
#endif
#else
#ifdef INTEGER_64
#define GALAHAD_KINDS_double galahad_kinds_double_64
#define GALAHAD_NODEND_precision GALAHAD_NODEND_double_64
#define SPRAL_SSIDS_double spral_ssids_double_64
#define SPRAL_SSIDS_precision spral_ssids_double_64
#define SPRAL_SSIDS_precision_ciface spral_ssids_double_ciface_64
#else
#define GALAHAD_NODEND_precision GALAHAD_NODEND_double
#define SPRAL_SSIDS_precision spral_ssids_double
#define SPRAL_SSIDS_precision_ciface spral_ssids_double_ciface
#endif
#endif

#ifdef REAL_32
#ifdef INTEGER_64
#define SPRAL_KINDS_precision spral_kinds_single_64
#define spral_kinds_precision spral_kinds_single_64
#define spral_ssids_precision spral_ssids_single_64
#define spral_scaling_precision spral_scaling_single_64
#define spral_ssids_contrib_fsub_precision spral_ssids_contrib_fsub_single_64
#define spral_ssids_fkeep_precision spral_ssids_fkeep_single_64
#define spral_ssids_anal_precision spral_ssids_anal_single_64
#define spral_ssids_gpu_cpu_solve_precision spral_ssids_gpu_cpu_solve_single_64
#define spral_ssids_gpu_subtree_precision spral_ssids_gpu_subtree_single_64
#define spral_ssids_cpu_subtree_precision spral_ssids_cpu_subtree_single_64
#define spral_ssids_cpu_iface_precision spral_ssids_cpu_iface_single_64
#define spral_ssids_akeep_precision spral_ssids_akeep_single_64
#define spral_ssids_subtree_precision spral_ssids_subtree_single_64
#define spral_ssids_contrib_precision spral_ssids_contrib_single_64
#define spral_ssids_inform_precision spral_ssids_inform_single_64
#define spral_ssids_types_precision spral_ssids_types_single_64
#define spral_match_order_precision spral_match_order_single_64
#define spral_cuda_precision spral_cuda_single_64
#define spral_ral_boeing_precision spral_ral_boeing_single_64
#define spral_random_precision spral_random_single_64
#define spral_matrix_util_precision spral_matrix_util_single_64
#else
#define SPRAL_KINDS_precision spral_kinds_single
#define spral_kinds_precision spral_kinds_single
#define spral_ssids_precision spral_ssids_single
#define spral_scaling_precision spral_scaling_single
#define spral_ssids_contrib_fsub_precision spral_ssids_contrib_fsub_single
#define spral_ssids_fkeep_precision spral_ssids_fkeep_single
#define spral_ssids_anal_precision spral_ssids_anal_single
#define spral_ssids_gpu_cpu_solve_precision spral_ssids_gpu_cpu_solve_single
#define spral_ssids_gpu_subtree_precision spral_ssids_gpu_subtree_single
#define spral_ssids_cpu_subtree_precision spral_ssids_cpu_subtree_single
#define spral_ssids_cpu_iface_precision spral_ssids_cpu_iface_single
#define spral_ssids_akeep_precision spral_ssids_akeep_single
#define spral_ssids_subtree_precision spral_ssids_subtree_single
#define spral_ssids_contrib_precision spral_ssids_contrib_single
#define spral_ssids_inform_precision spral_ssids_inform_single
#define spral_ssids_types_precision spral_ssids_types_single
#define spral_match_order_precision spral_match_order_single
#define spral_cuda_precision spral_cuda_single
#define spral_ral_boeing_precision spral_ral_boeing_single
#define spral_random_precision spral_random_single
#define spral_matrix_util_precision spral_matrix_util_single
#endif
#elif REAL_128
#ifdef INTEGER_64
#define SPRAL_KINDS_precision spral_kinds_quadruple_64
#define spral_kinds_precision spral_kinds_quadruple_64
#define spral_ssids_precision spral_ssids_quadruple_64
#define spral_scaling_precision spral_scaling_quadruple_64
#define spral_ssids_contrib_fsub_precision spral_ssids_contrib_fsub_quadruple_64
#define spral_ssids_fkeep_precision spral_ssids_fkeep_quadruple_64
#define spral_ssids_anal_precision spral_ssids_anal_quadruple_64
#define spral_ssids_gpu_cpu_solve_precision spral_ssids_gpu_cpu_solve_quadruple_64
#define spral_ssids_gpu_subtree_precision spral_ssids_gpu_subtree_quadruple_64
#define spral_ssids_cpu_subtree_precision spral_ssids_cpu_subtree_quadruple_64
#define spral_ssids_cpu_iface_precision spral_ssids_cpu_iface_quadruple_64
#define spral_ssids_akeep_precision spral_ssids_akeep_quadruple_64
#define spral_ssids_subtree_precision spral_ssids_subtree_quadruple_64
#define spral_ssids_contrib_precision spral_ssids_contrib_quadruple_64
#define spral_ssids_inform_precision spral_ssids_inform_quadruple_64
#define spral_ssids_types_precision spral_ssids_types_quadruple_64
#define spral_match_order_precision spral_match_order_quadruple_64
#define spral_cuda_precision spral_cuda_quadruple_64
#define spral_ral_boeing_precision spral_ral_boeing_quadruple_64
#define spral_random_precision spral_random_quadruple_64
#define spral_matrix_util_precision spral_matrix_util_quadruple_64
#else
#define SPRAL_KINDS_precision spral_kinds_quadruple
#define spral_kinds_precision spral_kinds_quadruple
#define spral_ssids_precision spral_ssids_quadruple
#define spral_scaling_precision spral_scaling_quadruple
#define spral_ssids_contrib_fsub_precision spral_ssids_contrib_fsub_quadruple
#define spral_ssids_fkeep_precision spral_ssids_fkeep_quadruple
#define spral_ssids_anal_precision spral_ssids_anal_quadruple
#define spral_ssids_gpu_cpu_solve_precision spral_ssids_gpu_cpu_solve_quadruple
#define spral_ssids_gpu_subtree_precision spral_ssids_gpu_subtree_quadruple
#define spral_ssids_cpu_subtree_precision spral_ssids_cpu_subtree_quadruple
#define spral_ssids_cpu_iface_precision spral_ssids_cpu_iface_quadruple
#define spral_ssids_akeep_precision spral_ssids_akeep_quadruple
#define spral_ssids_subtree_precision spral_ssids_subtree_quadruple
#define spral_ssids_contrib_precision spral_ssids_contrib_quadruple
#define spral_ssids_inform_precision spral_ssids_inform_quadruple
#define spral_ssids_types_precision spral_ssids_types_quadruple
#define spral_match_order_precision spral_match_order_quadruple
#define spral_cuda_precision spral_cuda_quadruple
#define spral_ral_boeing_precision spral_ral_boeing_quadruple
#define spral_random_precision spral_random_quadruple
#define spral_matrix_util_precision spral_matrix_util_quadruple
#endif
#else
#ifdef INTEGER_64
#define SPRAL_KINDS_precision spral_kinds_double_64
#define spral_kinds_precision spral_kinds_double_64
#define spral_ssids_precision spral_ssids_double_64
#define spral_scaling_precision spral_scaling_double_64
#define spral_ssids_contrib_fsub_precision spral_ssids_contrib_fsub_double_64
#define spral_ssids_fkeep_precision spral_ssids_fkeep_double_64
#define spral_ssids_anal_precision spral_ssids_anal_double_64
#define spral_ssids_gpu_cpu_solve_precision spral_ssids_gpu_cpu_solve_double_64
#define spral_ssids_gpu_subtree_precision spral_ssids_gpu_subtree_double_64
#define spral_ssids_cpu_subtree_precision spral_ssids_cpu_subtree_double_64
#define spral_ssids_cpu_iface_precision spral_ssids_cpu_iface_double_64
#define spral_ssids_akeep_precision spral_ssids_akeep_double_64
#define spral_ssids_subtree_precision spral_ssids_subtree_double_64
#define spral_ssids_contrib_precision spral_ssids_contrib_double_64
#define spral_ssids_inform_precision spral_ssids_inform_double_64
#define spral_ssids_types_precision spral_ssids_types_double_64
#define spral_match_order_precision spral_match_order_double_64
#define spral_cuda_precision spral_cuda_double_64
#define spral_ral_boeing_precision spral_ral_boeing_double_64
#define spral_random_precision spral_random_double_64
#define spral_matrix_util_precision spral_matrix_util_double_64
#else
#define SPRAL_KINDS_precision spral_kinds_double
#define spral_kinds_precision spral_kinds_double
#define spral_ssids_precision spral_ssids_double
#define spral_scaling_precision spral_scaling_double
#define spral_ssids_contrib_fsub_precision spral_ssids_contrib_fsub_double
#define spral_ssids_fkeep_precision spral_ssids_fkeep_double
#define spral_ssids_anal_precision spral_ssids_anal_double
#define spral_ssids_gpu_cpu_solve_precision spral_ssids_gpu_cpu_solve_double
#define spral_ssids_gpu_subtree_precision spral_ssids_gpu_subtree_double
#define spral_ssids_cpu_subtree_precision spral_ssids_cpu_subtree_double
#define spral_ssids_cpu_iface_precision spral_ssids_cpu_iface_double
#define spral_ssids_akeep_precision spral_ssids_akeep_double
#define spral_ssids_subtree_precision spral_ssids_subtree_double
#define spral_ssids_contrib_precision spral_ssids_contrib_double
#define spral_ssids_inform_precision spral_ssids_inform_double
#define spral_ssids_types_precision spral_ssids_types_double
#define spral_match_order_precision spral_match_order_double
#define spral_cuda_precision spral_cuda_double
#define spral_ral_boeing_precision spral_ral_boeing_double
#define spral_random_precision spral_random_double
#define spral_matrix_util_precision spral_matrix_util_double
#endif
#endif

#ifdef REAL_32
#define add_delays_precision add_delays_single
#define analyse_precision analyse_single
#define analyse_precision_ptr32 analyse_single_ptr32
#define apply_conversion_map_ptr32_precision apply_conversion_map_ptr32_single
#define apply_conversion_map_ptr64_precision apply_conversion_map_ptr64_single
#define assemble_precision assemble_single
#define block_ldlt_precision block_ldlt_single
#define block_llt_precision block_llt_single
#define clean_cscl_oop_ptr32_precision clean_cscl_oop_ptr32_single
#define clean_cscl_oop_ptr64_precision clean_cscl_oop_ptr64_single
#define convert_coord_to_cscl_ptr32_precision convert_coord_to_cscl_ptr32_single
#define convert_coord_to_cscl_ptr64_precision convert_coord_to_cscl_ptr64_single
#define copy_ic_precision copy_ic_single
#define copy_mc_precision copy_mc_single
#define cscl_verify_precision cscl_verify_single
#define cublasgemm cublasSgemm
#define cuda_collect_stats_precision cuda_collect_stats_single
#define cuda_dsyrk_precision cuda_dsyrk_single
#define cudaMemcpy_h2d_precision cudaMemcpy_h2d_single
#define cuda_multidsyrk_low_col_precision cuda_multidsyrk_low_col_single
#define cuda_multidsyrk_precision cuda_multidsyrk_single
#define factor_alloc_precision factor_alloc_single
#define free_both_precision free_both_single
#define load_nodes_precision load_nodes_single
#define load_nodes_sc_precision load_nodes_sc_single
#define max_abs_precision max_abs_single
#define multiblock_ldlt_precision multiblock_ldlt_single
#define multiblock_ldlt_setup_precision multiblock_ldlt_setup_single
#define multiblock_llt_precision multiblock_llt_single
#define multiblock_llt_setup_precision multiblock_llt_setup_single
#define multicopy_precision multicopy_single
#define multisymm_precision multisymm_single
#define print_matrix_int_precision print_matrix_int_single
#define print_matrix_long_precision print_matrix_long_single
#define rb_read_precision_int32 rb_read_single_int32
#define rb_read_precision_int64 rb_read_single_int64
#define rb_write_precision_int32 rb_write_single_int32
#define rb_write_precision_int64 rb_write_single_int64
#define reorder_cols2_precision reorder_cols2_single
#define reorder_rows2_precision reorder_rows2_single
#define reorder_rows_precision reorder_rows_single
#define run_bwd_solve_kernels_precision run_bwd_solve_kernels_single
#define run_d_solve_kernel_precision run_d_solve_kernel_single
#define run_fwd_solve_kernels_precision run_fwd_solve_kernels_single
#define run_slv_contrib_fwd_precision run_slv_contrib_fwd_single
#define simd_precision_type simd_single_type
#define simd_precision_type_val simd_single_type_val
#define spral_cublasgemm spral_cublasSgemm
#define spral_ssids_add_delays_precision spral_ssids_add_delays_single
#define spral_ssids_assemble_precision spral_ssids_assemble_single
#define spral_ssids_block_ldlt_precision spral_ssids_block_ldlt_single
#define spral_ssids_block_llt_precision spral_ssids_block_llt_single
#define spral_ssids_contrib_free_precision spral_ssids_contrib_free_sgl
#define spral_ssids_contrib_get_data_precision spral_ssids_contrib_get_data_single
#define spral_ssids_copy_ic_precision spral_ssids_copy_ic_single
#define spral_ssids_copy_mc_precision spral_ssids_copy_mc_single
#define spral_ssids_cuda_collect_stats_precision spral_ssids_cuda_collect_stats_single
#define spral_ssids_dsyrk_precision spral_ssids_dsyrk_single
#define spral_ssids_gpu_alloc_precision spral_ssids_gpu_alloc_single
#define spral_ssids_gpu_denfact_precision spral_ssids_gpu_denfact_single
#define spral_ssids_gpu_factor_precision spral_ssids_gpu_factor_single
#define spral_ssids_gpu_ifaces_precision spral_ssids_gpu_ifaces_single
#define spral_ssids_gpu_smalloc_precision spral_ssids_gpu_smalloc_single
#define spral_ssids_gpu_solve_precision spral_ssids_gpu_solve_single
#define spral_ssids_gpu_types_precision spral_ssids_gpu_types_single
#define spral_ssids_load_nodes_precision spral_ssids_load_nodes_single
#define spral_ssids_load_nodes_sc_precision spral_ssids_load_nodes_sc_single
#define spral_ssids_max_abs_precision spral_ssids_max_abs_single
#define spral_ssids_multiblock_ldlt_precision spral_ssids_multiblock_ldlt_single
#define spral_ssids_multiblock_ldlt_setup_precision spral_ssids_multiblock_ldlt_setup_single
#define spral_ssids_multiblock_llt_precision spral_ssids_multiblock_llt_single
#define spral_ssids_multiblock_llt_setup_precision spral_ssids_multiblock_llt_setup_single
#define spral_ssids_multicopy_precision spral_ssids_multicopy_single
#define spral_ssids_multidsyrk_low_col_precision spral_ssids_multidsyrk_low_col_single
#define spral_ssids_multidsyrk_precision spral_ssids_multidsyrk_single
#define spral_ssids_multireorder_precision spral_ssids_multireorder_single
#define spral_ssids_multisymm_precision spral_ssids_multisymm_single
#define spral_ssids_reorder_cols2_precision spral_ssids_reorder_cols2_single
#define spral_ssids_reorder_rows2_precision spral_ssids_reorder_rows2_single
#define spral_ssids_reorder_rows_precision spral_ssids_reorder_rows_single
#define spral_ssids_run_bwd_solve_kernels_precision spral_ssids_run_bwd_solve_kernels_single
#define spral_ssids_run_d_solve_kernel_precision spral_ssids_run_d_solve_kernel_single
#define spral_ssids_run_fwd_solve_kernels_precision spral_ssids_run_fwd_solve_kernels_single
#define spral_ssids_run_slv_contrib_fwd_precision spral_ssids_run_slv_contrib_fwd_single
#define spral_ssids_square_ldlt_precision spral_ssids_square_ldlt_single
#define spral_ssids_swap_ni2D_ic_precision spral_ssids_swap_ni2D_ic_single
#define spral_ssids_swap_ni2D_ir_precision spral_ssids_swap_ni2D_ir_single
#define spral_ssids_swap_ni2Dm_precision spral_ssids_swap_ni2Dm_single
#define square_ldlt_precision square_ldlt_single
#define ssids_alter_precision ssids_alter_single
#define ssids_analyse_coord_precision ssids_analyse_coord_single
#define ssids_enquire_indef_precision ssids_enquire_indef_single
#define ssids_enquire_posdef_precision ssids_enquire_posdef_single
#define ssids_factor_ptr32_precision ssids_factor_ptr32_single
#define ssids_factor_ptr64_precision ssids_factor_ptr64_single
#define ssids_solve_mult_precision ssids_solve_mult_single
#define ssids_solve_one_precision ssids_solve_one_single
#define swap_ni2D_ic_precision swap_ni2D_ic_single
#define swap_ni2D_ir_precision swap_ni2D_ir_single
#define swap_ni2Dm_precision swap_ni2Dm_single
#elif REAL_128
#define add_delays_precision add_delays_quadruple
#define analyse_precision analyse_quadruple
#define analyse_precision_ptr32 analyse_quadruple_ptr32
#define apply_conversion_map_ptr32_precision apply_conversion_map_ptr32_quadruple
#define apply_conversion_map_ptr64_precision apply_conversion_map_ptr64_quadruple
#define assemble_precision assemble_quadruple
#define block_ldlt_precision block_ldlt_quadruple
#define block_llt_precision block_llt_quadruple
#define clean_cscl_oop_ptr32_precision clean_cscl_oop_ptr32_quadruple
#define clean_cscl_oop_ptr64_precision clean_cscl_oop_ptr64_quadruple
#define convert_coord_to_cscl_ptr32_precision convert_coord_to_cscl_ptr32_quadruple
#define convert_coord_to_cscl_ptr64_precision convert_coord_to_cscl_ptr64_quadruple
#define copy_ic_precision copy_ic_quadruple
#define copy_mc_precision copy_mc_quadruple
#define cscl_verify_precision cscl_verify_quadruple
#define cublasgemm cublasSgemm
#define cuda_collect_stats_precision cuda_collect_stats_quadruple
#define cuda_dsyrk_precision cuda_dsyrk_quadruple
#define cudaMemcpy_h2d_precision cudaMemcpy_h2d_quadruple
#define cuda_multidsyrk_low_col_precision cuda_multidsyrk_low_col_quadruple
#define cuda_multidsyrk_precision cuda_multidsyrk_quadruple
#define factor_alloc_precision factor_alloc_quadruple
#define free_both_precision free_both_quadruple
#define load_nodes_precision load_nodes_quadruple
#define load_nodes_sc_precision load_nodes_sc_quadruple
#define max_abs_precision max_abs_quadruple
#define multiblock_ldlt_precision multiblock_ldlt_quadruple
#define multiblock_ldlt_setup_precision multiblock_ldlt_setup_quadruple
#define multiblock_llt_precision multiblock_llt_quadruple
#define multiblock_llt_setup_precision multiblock_llt_setup_quadruple
#define multicopy_precision multicopy_quadruple
#define multisymm_precision multisymm_quadruple
#define print_matrix_int_precision print_matrix_int_quadruple
#define print_matrix_long_precision print_matrix_long_quadruple
#define rb_read_precision_int32 rb_read_quadruple_int32
#define rb_read_precision_int64 rb_read_quadruple_int64
#define rb_write_precision_int32 rb_write_quadruple_int32
#define rb_write_precision_int64 rb_write_quadruple_int64
#define reorder_cols2_precision reorder_cols2_quadruple
#define reorder_rows2_precision reorder_rows2_quadruple
#define reorder_rows_precision reorder_rows_quadruple
#define run_bwd_solve_kernels_precision run_bwd_solve_kernels_quadruple
#define run_d_solve_kernel_precision run_d_solve_kernel_quadruple
#define run_fwd_solve_kernels_precision run_fwd_solve_kernels_quadruple
#define run_slv_contrib_fwd_precision run_slv_contrib_fwd_quadruple
#define simd_precision_type simd_quadruple_type
#define simd_precision_type_val simd_quadruple_type_val
#define spral_cublasgemm spral_cublasSgemm
#define spral_ssids_add_delays_precision spral_ssids_add_delays_quadruple
#define spral_ssids_assemble_precision spral_ssids_assemble_quadruple
#define spral_ssids_block_ldlt_precision spral_ssids_block_ldlt_quadruple
#define spral_ssids_block_llt_precision spral_ssids_block_llt_quadruple
#define spral_ssids_contrib_free_precision spral_ssids_contrib_free_qul
#define spral_ssids_contrib_get_data_precision spral_ssids_contrib_get_data_quadruple
#define spral_ssids_copy_ic_precision spral_ssids_copy_ic_quadruple
#define spral_ssids_copy_mc_precision spral_ssids_copy_mc_quadruple
#define spral_ssids_cuda_collect_stats_precision spral_ssids_cuda_collect_stats_quadruple
#define spral_ssids_dsyrk_precision spral_ssids_dsyrk_quadruple
#define spral_ssids_gpu_alloc_precision spral_ssids_gpu_alloc_quadruple
#define spral_ssids_gpu_denfact_precision spral_ssids_gpu_denfact_quadruple
#define spral_ssids_gpu_factor_precision spral_ssids_gpu_factor_quadruple
#define spral_ssids_gpu_ifaces_precision spral_ssids_gpu_ifaces_quadruple
#define spral_ssids_gpu_smalloc_precision spral_ssids_gpu_smalloc_quadruple
#define spral_ssids_gpu_solve_precision spral_ssids_gpu_solve_quadruple
#define spral_ssids_gpu_types_precision spral_ssids_gpu_types_quadruple
#define spral_ssids_load_nodes_precision spral_ssids_load_nodes_quadruple
#define spral_ssids_load_nodes_sc_precision spral_ssids_load_nodes_sc_quadruple
#define spral_ssids_max_abs_precision spral_ssids_max_abs_quadruple
#define spral_ssids_multiblock_ldlt_precision spral_ssids_multiblock_ldlt_quadruple
#define spral_ssids_multiblock_ldlt_setup_precision spral_ssids_multiblock_ldlt_setup_quadruple
#define spral_ssids_multiblock_llt_precision spral_ssids_multiblock_llt_quadruple
#define spral_ssids_multiblock_llt_setup_precision spral_ssids_multiblock_llt_setup_quadruple
#define spral_ssids_multicopy_precision spral_ssids_multicopy_quadruple
#define spral_ssids_multidsyrk_low_col_precision spral_ssids_multidsyrk_low_col_quadruple
#define spral_ssids_multidsyrk_precision spral_ssids_multidsyrk_quadruple
#define spral_ssids_multireorder_precision spral_ssids_multireorder_quadruple
#define spral_ssids_multisymm_precision spral_ssids_multisymm_quadruple
#define spral_ssids_reorder_cols2_precision spral_ssids_reorder_cols2_quadruple
#define spral_ssids_reorder_rows2_precision spral_ssids_reorder_rows2_quadruple
#define spral_ssids_reorder_rows_precision spral_ssids_reorder_rows_quadruple
#define spral_ssids_run_bwd_solve_kernels_precision spral_ssids_run_bwd_solve_kernels_quadruple
#define spral_ssids_run_d_solve_kernel_precision spral_ssids_run_d_solve_kernel_quadruple
#define spral_ssids_run_fwd_solve_kernels_precision spral_ssids_run_fwd_solve_kernels_quadruple
#define spral_ssids_run_slv_contrib_fwd_precision spral_ssids_run_slv_contrib_fwd_quadruple
#define spral_ssids_square_ldlt_precision spral_ssids_square_ldlt_quadruple
#define spral_ssids_swap_ni2D_ic_precision spral_ssids_swap_ni2D_ic_quadruple
#define spral_ssids_swap_ni2D_ir_precision spral_ssids_swap_ni2D_ir_quadruple
#define spral_ssids_swap_ni2Dm_precision spral_ssids_swap_ni2Dm_quadruple
#define square_ldlt_precision square_ldlt_quadruple
#define ssids_alter_precision ssids_alter_quadruple
#define ssids_analyse_coord_precision ssids_analyse_coord_quadruple
#define ssids_enquire_indef_precision ssids_enquire_indef_quadruple
#define ssids_enquire_posdef_precision ssids_enquire_posdef_quadruple
#define ssids_factor_ptr32_precision ssids_factor_ptr32_quadruple
#define ssids_factor_ptr64_precision ssids_factor_ptr64_quadruple
#define ssids_solve_mult_precision ssids_solve_mult_quadruple
#define ssids_solve_one_precision ssids_solve_one_quadruple
#define swap_ni2D_ic_precision swap_ni2D_ic_quadruple
#define swap_ni2D_ir_precision swap_ni2D_ir_quadruple
#define swap_ni2Dm_precision swap_ni2Dm_quadruple
#else
#define add_delays_precision add_delays_double
#define analyse_precision analyse_double
#define analyse_precision_ptr32 analyse_double_ptr32
#define apply_conversion_map_ptr32_precision apply_conversion_map_ptr32_double
#define apply_conversion_map_ptr64_precision apply_conversion_map_ptr64_double
#define assemble_precision assemble_double
#define block_ldlt_precision block_ldlt_double
#define block_llt_precision block_llt_double
#define clean_cscl_oop_ptr32_precision clean_cscl_oop_ptr32_double
#define clean_cscl_oop_ptr64_precision clean_cscl_oop_ptr64_double
#define convert_coord_to_cscl_ptr32_precision convert_coord_to_cscl_ptr32_double
#define convert_coord_to_cscl_ptr64_precision convert_coord_to_cscl_ptr64_double
#define copy_ic_precision copy_ic_double
#define copy_mc_precision copy_mc_double
#define cscl_verify_precision cscl_verify_double
#define cublasgemm cublasDgemm
#define cuda_collect_stats_precision cuda_collect_stats_double
#define cuda_dsyrk_precision cuda_dsyrk_double
#define cudaMemcpy_h2d_precision cudaMemcpy_h2d_double
#define cuda_multidsyrk_low_col_precision cuda_multidsyrk_low_col_double
#define cuda_multidsyrk_precision cuda_multidsyrk_double
#define factor_alloc_precision factor_alloc_double
#define free_both_precision free_both_double
#define load_nodes_precision load_nodes_double
#define load_nodes_sc_precision load_nodes_sc_double
#define max_abs_precision max_abs_double
#define multiblock_ldlt_precision multiblock_ldlt_double
#define multiblock_ldlt_setup_precision multiblock_ldlt_setup_double
#define multiblock_llt_precision multiblock_llt_double
#define multiblock_llt_setup_precision multiblock_llt_setup_double
#define multicopy_precision multicopy_double
#define multisymm_precision multisymm_double
#define print_matrix_int_precision print_matrix_int_double
#define print_matrix_long_precision print_matrix_long_double
#define rb_read_precision_int32 rb_read_double_int32
#define rb_read_precision_int64 rb_read_double_int64
#define rb_write_precision_int32 rb_write_double_int32
#define rb_write_precision_int64 rb_write_double_int64
#define reorder_cols2_precision reorder_cols2_double
#define reorder_rows2_precision reorder_rows2_double
#define reorder_rows_precision reorder_rows_double
#define run_bwd_solve_kernels_precision run_bwd_solve_kernels_double
#define run_d_solve_kernel_precision run_d_solve_kernel_double
#define run_fwd_solve_kernels_precision run_fwd_solve_kernels_double
#define run_slv_contrib_fwd_precision run_slv_contrib_fwd_double
#define simd_precision_type simd_double_type
#define simd_precision_type_val simd_double_type_val
#define spral_cublasgemm spral_cublasDgemm
#define spral_ssids_add_delays_precision spral_ssids_add_delays_double
#define spral_ssids_assemble_precision spral_ssids_assemble_double
#define spral_ssids_block_ldlt_precision spral_ssids_block_ldlt_double
#define spral_ssids_block_llt_precision spral_ssids_block_llt_double
#define spral_ssids_contrib_free_precision spral_ssids_contrib_free_dbl
#define spral_ssids_contrib_get_data_precision spral_ssids_contrib_get_data_double
#define spral_ssids_copy_ic_precision spral_ssids_copy_ic_double
#define spral_ssids_copy_mc_precision spral_ssids_copy_mc_double
#define spral_ssids_cuda_collect_stats_precision spral_ssids_cuda_collect_stats_double
#define spral_ssids_dsyrk_precision spral_ssids_dsyrk_double
#define spral_ssids_gpu_alloc_precision spral_ssids_gpu_alloc_double
#define spral_ssids_gpu_denfact_precision spral_ssids_gpu_denfact_double
#define spral_ssids_gpu_factor_precision spral_ssids_gpu_factor_double
#define spral_ssids_gpu_ifaces_precision spral_ssids_gpu_ifaces_double
#define spral_ssids_gpu_smalloc_precision spral_ssids_gpu_smalloc_double
#define spral_ssids_gpu_solve_precision spral_ssids_gpu_solve_double
#define spral_ssids_gpu_types_precision spral_ssids_gpu_types_double
#define spral_ssids_load_nodes_precision spral_ssids_load_nodes_double
#define spral_ssids_load_nodes_sc_precision spral_ssids_load_nodes_sc_double
#define spral_ssids_max_abs_precision spral_ssids_max_abs_double
#define spral_ssids_multiblock_ldlt_precision spral_ssids_multiblock_ldlt_double
#define spral_ssids_multiblock_ldlt_setup_precision spral_ssids_multiblock_ldlt_setup_double
#define spral_ssids_multiblock_llt_precision spral_ssids_multiblock_llt_double
#define spral_ssids_multiblock_llt_setup_precision spral_ssids_multiblock_llt_setup_double
#define spral_ssids_multicopy_precision spral_ssids_multicopy_double
#define spral_ssids_multidsyrk_low_col_precision spral_ssids_multidsyrk_low_col_double
#define spral_ssids_multidsyrk_precision spral_ssids_multidsyrk_double
#define spral_ssids_multireorder_precision spral_ssids_multireorder_double
#define spral_ssids_multisymm_precision spral_ssids_multisymm_double
#define spral_ssids_reorder_cols2_precision spral_ssids_reorder_cols2_double
#define spral_ssids_reorder_rows2_precision spral_ssids_reorder_rows2_double
#define spral_ssids_reorder_rows_precision spral_ssids_reorder_rows_double
#define spral_ssids_run_bwd_solve_kernels_precision spral_ssids_run_bwd_solve_kernels_double
#define spral_ssids_run_d_solve_kernel_precision spral_ssids_run_d_solve_kernel_double
#define spral_ssids_run_fwd_solve_kernels_precision spral_ssids_run_fwd_solve_kernels_double
#define spral_ssids_run_slv_contrib_fwd_precision spral_ssids_run_slv_contrib_fwd_double
#define spral_ssids_square_ldlt_precision spral_ssids_square_ldlt_double
#define spral_ssids_swap_ni2D_ic_precision spral_ssids_swap_ni2D_ic_double
#define spral_ssids_swap_ni2D_ir_precision spral_ssids_swap_ni2D_ir_double
#define spral_ssids_swap_ni2Dm_precision spral_ssids_swap_ni2Dm_double
#define square_ldlt_precision square_ldlt_double
#define ssids_alter_precision ssids_alter_double
#define ssids_analyse_coord_precision ssids_analyse_coord_double
#define ssids_enquire_indef_precision ssids_enquire_indef_double
#define ssids_enquire_posdef_precision ssids_enquire_posdef_double
#define ssids_factor_ptr32_precision ssids_factor_ptr32_double
#define ssids_factor_ptr64_precision ssids_factor_ptr64_double
#define ssids_solve_mult_precision ssids_solve_mult_double
#define ssids_solve_one_precision ssids_solve_one_double
#define swap_ni2D_ic_precision swap_ni2D_ic_double
#define swap_ni2D_ir_precision swap_ni2D_ir_double
#define swap_ni2Dm_precision swap_ni2Dm_double
#endif
