! THIS VERSION: GALAHAD 5.1 - 2024-11-23 AT 13:00 GMT.

#include "galahad_modules.h"

!-*-*-*-  G A L A H A D  -  D U M M Y   P A R D I S O  R O U T I N E S  -*-*-*-

  SUBROUTINE PARDISO_S( PT, MAXFCT, MNUM, MTYPE, PHASE, N, A, IA, JA,          &
                        PERM, NRHS, IPARM, MSGLVL, B, X, ERROR )
  USE MKL_PARDISO_PRIVATE
  USE GALAHAD_KINDS, ONLY: sp_, ip_
  USE GALAHAD_SYMBOLS
  TYPE (MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: MAXFCT
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: MNUM
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: MTYPE
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: PHASE
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: N
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: IA(*)
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: JA(*)
  INTEGER ( KIND = ip_ ), INTENT(INOUT) :: PERM(*)
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: NRHS
  INTEGER ( KIND = ip_ ), INTENT(INOUT) :: IPARM(*)
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: MSGLVL
  INTEGER ( KIND = ip_ ), INTENT(OUT)   :: ERROR

  REAL ( KIND = sp_ ), INTENT(IN)    :: A(*)
  REAL ( KIND = sp_ ), INTENT(INOUT) :: B(*)
  REAL ( KIND = sp_ ), INTENT(OUT)   :: X(*)
  ERROR = GALAHAD_unavailable_option
  END SUBROUTINE PARDISO_S

  SUBROUTINE PARDISO_D( PT, MAXFCT, MNUM, MTYPE, PHASE, N, A, IA, JA,          &
                        PERM, NRHS, IPARM, MSGLVL, B, X, ERROR )
  USE MKL_PARDISO_PRIVATE
  USE GALAHAD_KINDS, ONLY: dp_, ip_
  USE GALAHAD_SYMBOLS
  TYPE (MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: MAXFCT
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: MNUM
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: MTYPE
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: PHASE
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: N
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: IA(*)
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: JA(*)
  INTEGER ( KIND = ip_ ), INTENT(INOUT) :: PERM(*)
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: NRHS
  INTEGER ( KIND = ip_ ), INTENT(INOUT) :: IPARM(*)
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: MSGLVL
  INTEGER ( KIND = ip_ ), INTENT(OUT)   :: ERROR

  REAL ( KIND = dp_ ), INTENT(IN)    :: A(*)
  REAL ( KIND = dp_ ), INTENT(INOUT) :: B(*)
  REAL ( KIND = dp_ ), INTENT(OUT)   :: X(*)
  ERROR = GALAHAD_unavailable_option
  END SUBROUTINE PARDISO_D

#ifdef REAL_128
  SUBROUTINE PARDISO_Q( PT, MAXFCT, MNUM, MTYPE, PHASE, N, A, IA, JA,          &
                        PERM, NRHS, IPARM, MSGLVL, B, X, ERROR )
  USE MKL_PARDISO_PRIVATE
  USE GALAHAD_KINDS, ONLY: r16_, ip_
  USE GALAHAD_SYMBOLS
  TYPE (MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: MAXFCT
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: MNUM
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: MTYPE
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: PHASE
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: N
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: IA(*)
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: JA(*)
  INTEGER ( KIND = ip_ ), INTENT(INOUT) :: PERM(*)
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: NRHS
  INTEGER ( KIND = ip_ ), INTENT(INOUT) :: IPARM(*)
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: MSGLVL
  INTEGER ( KIND = ip_ ), INTENT(OUT)   :: ERROR

  REAL ( KIND = r16_ ), INTENT(IN)    :: A(*)
  REAL ( KIND = r16_ ), INTENT(INOUT) :: B(*)
  REAL ( KIND = r16_ ), INTENT(OUT)   :: X(*)
  ERROR = GALAHAD_unavailable_option
  END SUBROUTINE PARDISO_Q
#endif

  SUBROUTINE PARDISO_SC( PT, MAXFCT, MNUM, MTYPE, PHASE, N, A, IA, JA,         &
                         PERM, NRHS, IPARM, MSGLVL, B, X, ERROR )
  USE MKL_PARDISO_PRIVATE
  USE GALAHAD_KINDS, ONLY: sp_, ip_
  USE GALAHAD_SYMBOLS
  TYPE (MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: MAXFCT
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: MNUM
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: MTYPE
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: PHASE
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: N
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: IA(*)
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: JA(*)
  INTEGER ( KIND = ip_ ), INTENT(INOUT) :: PERM(*)
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: NRHS
  INTEGER ( KIND = ip_ ), INTENT(INOUT) :: IPARM(*)
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: MSGLVL
  INTEGER ( KIND = ip_ ), INTENT(OUT)   :: ERROR

  COMPLEX ( KIND = sp_ ), INTENT(IN)    :: A(*)
  COMPLEX ( KIND = sp_ ), INTENT(INOUT) :: B(*)
  COMPLEX ( KIND = sp_ ), INTENT(OUT)   :: X(*)
  ERROR = GALAHAD_unavailable_option
  END SUBROUTINE PARDISO_SC

  SUBROUTINE PARDISO_DC( PT, MAXFCT, MNUM, MTYPE, PHASE, N, A, IA, JA,         &
                         PERM, NRHS, IPARM, MSGLVL, B, X, ERROR )
  USE MKL_PARDISO_PRIVATE
  USE GALAHAD_KINDS, ONLY: dp_, ip_
  USE GALAHAD_SYMBOLS
  TYPE (MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: MAXFCT
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: MNUM
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: MTYPE
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: PHASE
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: N
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: IA(*)
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: JA(*)
  INTEGER ( KIND = ip_ ), INTENT(INOUT) :: PERM(*)
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: NRHS
  INTEGER ( KIND = ip_ ), INTENT(INOUT) :: IPARM(*)
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: MSGLVL
  INTEGER ( KIND = ip_ ), INTENT(OUT)   :: ERROR
  COMPLEX ( KIND = dp_ ), INTENT(IN)    :: A(*)
  COMPLEX ( KIND = dp_ ), INTENT(INOUT) :: B(*)
  COMPLEX ( KIND = dp_ ), INTENT(OUT)   :: X(*)
  ERROR = GALAHAD_unavailable_option
  END SUBROUTINE PARDISO_DC

#ifdef REAL_128
  SUBROUTINE PARDISO_QC( PT, MAXFCT, MNUM, MTYPE, PHASE, N, A, IA, JA,         &
                         PERM, NRHS, IPARM, MSGLVL, B, X, ERROR )
  USE MKL_PARDISO_PRIVATE
  USE GALAHAD_KINDS, ONLY: r16_, ip_
  USE GALAHAD_SYMBOLS
  TYPE (MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: MAXFCT
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: MNUM
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: MTYPE
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: PHASE
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: N
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: IA(*)
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: JA(*)
  INTEGER ( KIND = ip_ ), INTENT(INOUT) :: PERM(*)
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: NRHS
  INTEGER ( KIND = ip_ ), INTENT(INOUT) :: IPARM(*)
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: MSGLVL
  INTEGER ( KIND = ip_ ), INTENT(OUT)   :: ERROR
  COMPLEX ( KIND = r16_ ), INTENT(IN)    :: A(*)
  COMPLEX ( KIND = r16_ ), INTENT(INOUT) :: B(*)
  COMPLEX ( KIND = r16_ ), INTENT(OUT)   :: X(*)
  ERROR = GALAHAD_unavailable_option
  END SUBROUTINE PARDISO_QC
#endif

  SUBROUTINE PARDISO_S_2D( PT, MAXFCT, MNUM, MTYPE, PHASE, N, A, IA, JA,       &
                           PERM, NRHS, IPARM, MSGLVL, B, X, ERROR )
  USE MKL_PARDISO_PRIVATE
  USE GALAHAD_KINDS, ONLY: sp_, ip_
  USE GALAHAD_SYMBOLS
  TYPE (MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: MAXFCT
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: MNUM
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: MTYPE
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: PHASE
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: N
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: IA(*)
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: JA(*)
  INTEGER ( KIND = ip_ ), INTENT(INOUT) :: PERM(*)
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: NRHS
  INTEGER ( KIND = ip_ ), INTENT(INOUT) :: IPARM(*)
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: MSGLVL
  INTEGER ( KIND = ip_ ), INTENT(OUT)   :: ERROR
  REAL ( KIND = sp_ ), INTENT(IN)    :: A(*)
  REAL ( KIND = sp_ ), INTENT(INOUT) :: B(N,*)
  REAL ( KIND = sp_ ), INTENT(OUT)   :: X(N,*)
  ERROR = GALAHAD_unavailable_option
  END SUBROUTINE PARDISO_S_2D

  SUBROUTINE PARDISO_D_2D( PT, MAXFCT, MNUM, MTYPE, PHASE, N, A, IA, JA,       &
                           PERM, NRHS, IPARM, MSGLVL, B, X, ERROR )
  USE MKL_PARDISO_PRIVATE
  USE GALAHAD_KINDS, ONLY: dp_, ip_
  USE GALAHAD_SYMBOLS
  TYPE (MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: MAXFCT
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: MNUM
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: MTYPE
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: PHASE
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: N
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: IA(*)
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: JA(*)
  INTEGER ( KIND = ip_ ), INTENT(INOUT) :: PERM(*)
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: NRHS
  INTEGER ( KIND = ip_ ), INTENT(INOUT) :: IPARM(*)
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: MSGLVL
  INTEGER ( KIND = ip_ ), INTENT(OUT)   :: ERROR
  REAL ( KIND = dp_ ), INTENT(IN)    :: A(*)
  REAL ( KIND = dp_ ), INTENT(INOUT) :: B(N,*)
  REAL ( KIND = dp_ ), INTENT(OUT)   :: X(N,*)
  ERROR = GALAHAD_unavailable_option
  END SUBROUTINE PARDISO_D_2D

#ifdef REAL_128
  SUBROUTINE PARDISO_Q_2D( PT, MAXFCT, MNUM, MTYPE, PHASE, N, A, IA, JA,       &
                           PERM, NRHS, IPARM, MSGLVL, B, X, ERROR )
  USE MKL_PARDISO_PRIVATE
  USE GALAHAD_KINDS, ONLY: r16_, ip_
  USE GALAHAD_SYMBOLS
  TYPE (MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: MAXFCT
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: MNUM
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: MTYPE
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: PHASE
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: N
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: IA(*)
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: JA(*)
  INTEGER ( KIND = ip_ ), INTENT(INOUT) :: PERM(*)
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: NRHS
  INTEGER ( KIND = ip_ ), INTENT(INOUT) :: IPARM(*)
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: MSGLVL
  INTEGER ( KIND = ip_ ), INTENT(OUT)   :: ERROR
  REAL ( KIND = r16_ ), INTENT(IN)    :: A(*)
  REAL ( KIND = r16_ ), INTENT(INOUT) :: B(N,*)
  REAL ( KIND = r16_ ), INTENT(OUT)   :: X(N,*)
  ERROR = GALAHAD_unavailable_option
  END SUBROUTINE PARDISO_Q_2D
#endif

  SUBROUTINE PARDISO_SC_2D( PT, MAXFCT, MNUM, MTYPE, PHASE, N, A, IA,          &
                            JA, PERM, NRHS, IPARM, MSGLVL, B, X, ERROR )
  USE MKL_PARDISO_PRIVATE
  USE GALAHAD_KINDS, ONLY: sp_, ip_
  USE GALAHAD_SYMBOLS
  TYPE (MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: MAXFCT
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: MNUM
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: MTYPE
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: PHASE
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: N
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: IA(*)
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: JA(*)
  INTEGER ( KIND = ip_ ), INTENT(INOUT) :: PERM(*)
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: NRHS
  INTEGER ( KIND = ip_ ), INTENT(INOUT) :: IPARM(*)
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: MSGLVL
  INTEGER ( KIND = ip_ ), INTENT(OUT)   :: ERROR
  COMPLEX ( KIND = sp_ ), INTENT(IN)    :: A(*)
  COMPLEX ( KIND = sp_ ), INTENT(INOUT) :: B(N,*)
  COMPLEX ( KIND = sp_ ), INTENT(OUT)   :: X(N,*)
  ERROR = GALAHAD_unavailable_option
  END SUBROUTINE PARDISO_SC_2D

  SUBROUTINE PARDISO_DC_2D( PT, MAXFCT, MNUM, MTYPE, PHASE, N, A, IA,          &
                            JA, PERM, NRHS, IPARM, MSGLVL, B, X, ERROR )
  USE MKL_PARDISO_PRIVATE
  USE GALAHAD_KINDS, ONLY: dp_, ip_
  USE GALAHAD_SYMBOLS
  TYPE (MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: MAXFCT
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: MNUM
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: MTYPE
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: PHASE
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: N
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: IA(*)
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: JA(*)
  INTEGER ( KIND = ip_ ), INTENT(INOUT) :: PERM(*)
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: NRHS
  INTEGER ( KIND = ip_ ), INTENT(INOUT) :: IPARM(*)
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: MSGLVL
  INTEGER ( KIND = ip_ ), INTENT(OUT)   :: ERROR
  COMPLEX ( KIND = dp_ ), INTENT(IN)    :: A(*)
  COMPLEX ( KIND = dp_ ), INTENT(INOUT) :: B(N,*)
  COMPLEX ( KIND = dp_ ), INTENT(OUT)   :: X(N,*)
  ERROR = GALAHAD_unavailable_option
  END SUBROUTINE PARDISO_DC_2D

#ifdef REAL_128
  SUBROUTINE PARDISO_QC_2D( PT, MAXFCT, MNUM, MTYPE, PHASE, N, A, IA,          &
                            JA, PERM, NRHS, IPARM, MSGLVL, B, X, ERROR )
  USE MKL_PARDISO_PRIVATE
  USE GALAHAD_KINDS, ONLY: r16_, ip_
  USE GALAHAD_SYMBOLS
  TYPE (MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: MAXFCT
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: MNUM
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: MTYPE
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: PHASE
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: N
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: IA(*)
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: JA(*)
  INTEGER ( KIND = ip_ ), INTENT(INOUT) :: PERM(*)
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: NRHS
  INTEGER ( KIND = ip_ ), INTENT(INOUT) :: IPARM(*)
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: MSGLVL
  INTEGER ( KIND = ip_ ), INTENT(OUT)   :: ERROR
  COMPLEX ( KIND = r16_ ), INTENT(IN)    :: A(*)
  COMPLEX ( KIND = r16_ ), INTENT(INOUT) :: B(N,*)
  COMPLEX ( KIND = r16_ ), INTENT(OUT)   :: X(N,*)
  ERROR = GALAHAD_unavailable_option
  END SUBROUTINE PARDISO_QC_2D
#endif

  SUBROUTINE PARDISO_S_64( PT, MAXFCT, MNUM, MTYPE, PHASE, N, A, IA,           &
                           JA, PERM, NRHS, IPARM, MSGLVL, B, X, ERROR )
  USE MKL_PARDISO_PRIVATE
  USE GALAHAD_KINDS, ONLY: sp_, ip_, long_
  USE GALAHAD_SYMBOLS
  TYPE (MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
  INTEGER ( KIND = long_ ), INTENT(IN)    :: MAXFCT
  INTEGER ( KIND = long_ ), INTENT(IN)    :: MNUM
  INTEGER ( KIND = long_ ), INTENT(IN)    :: MTYPE
  INTEGER ( KIND = long_ ), INTENT(IN)    :: PHASE
  INTEGER ( KIND = long_ ), INTENT(IN)    :: N
  INTEGER ( KIND = long_ ), INTENT(IN)    :: IA(*)
  INTEGER ( KIND = long_ ), INTENT(IN)    :: JA(*)
  INTEGER ( KIND = long_ ), INTENT(INOUT) :: PERM(*)
  INTEGER ( KIND = long_ ), INTENT(IN)    :: NRHS
  INTEGER ( KIND = long_ ), INTENT(INOUT) :: IPARM(*)
  INTEGER ( KIND = long_ ), INTENT(IN)    :: MSGLVL
  INTEGER ( KIND = long_ ), INTENT(OUT)   :: ERROR
  REAL ( KIND = sp_ ), INTENT(IN)    :: A(*)
  REAL ( KIND = sp_ ), INTENT(INOUT) :: B(*)
  REAL ( KIND = sp_ ), INTENT(OUT)   :: X(*)
  ERROR = INT( GALAHAD_unavailable_option, KIND =  long_ )
  END SUBROUTINE PARDISO_S_64

  SUBROUTINE PARDISO_D_64( PT, MAXFCT, MNUM, MTYPE, PHASE, N, A, IA,           &
                           JA, PERM, NRHS, IPARM, MSGLVL, B, X, ERROR )
  USE MKL_PARDISO_PRIVATE
  USE GALAHAD_KINDS, ONLY: dp_, ip_, long_
  USE GALAHAD_SYMBOLS
  TYPE (MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
  INTEGER ( KIND = long_ ), INTENT(IN)    :: MAXFCT
  INTEGER ( KIND = long_ ), INTENT(IN)    :: MNUM
  INTEGER ( KIND = long_ ), INTENT(IN)    :: MTYPE
  INTEGER ( KIND = long_ ), INTENT(IN)    :: PHASE
  INTEGER ( KIND = long_ ), INTENT(IN)    :: N
  INTEGER ( KIND = long_ ), INTENT(IN)    :: IA(*)
  INTEGER ( KIND = long_ ), INTENT(IN)    :: JA(*)
  INTEGER ( KIND = long_ ), INTENT(INOUT) :: PERM(*)
  INTEGER ( KIND = long_ ), INTENT(IN)    :: NRHS
  INTEGER ( KIND = long_ ), INTENT(INOUT) :: IPARM(*)
  INTEGER ( KIND = long_ ), INTENT(IN)    :: MSGLVL
  INTEGER ( KIND = long_ ), INTENT(OUT)   :: ERROR
  REAL ( KIND = dp_ ), INTENT(IN)    :: A(*)
  REAL ( KIND = dp_ ), INTENT(INOUT) :: B(*)
  REAL ( KIND = dp_ ), INTENT(OUT)   :: X(*)
  ERROR = INT( GALAHAD_unavailable_option, KIND = long_ )
  END SUBROUTINE PARDISO_D_64

#ifdef REAL_128
  SUBROUTINE PARDISO_Q_64( PT, MAXFCT, MNUM, MTYPE, PHASE, N, A, IA,           &
                           JA, PERM, NRHS, IPARM, MSGLVL, B, X, ERROR )
  USE MKL_PARDISO_PRIVATE
  USE GALAHAD_KINDS, ONLY: r16_, ip_, long_
  USE GALAHAD_SYMBOLS
  TYPE (MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
  INTEGER ( KIND = long_ ), INTENT(IN)    :: MAXFCT
  INTEGER ( KIND = long_ ), INTENT(IN)    :: MNUM
  INTEGER ( KIND = long_ ), INTENT(IN)    :: MTYPE
  INTEGER ( KIND = long_ ), INTENT(IN)    :: PHASE
  INTEGER ( KIND = long_ ), INTENT(IN)    :: N
  INTEGER ( KIND = long_ ), INTENT(IN)    :: IA(*)
  INTEGER ( KIND = long_ ), INTENT(IN)    :: JA(*)
  INTEGER ( KIND = long_ ), INTENT(INOUT) :: PERM(*)
  INTEGER ( KIND = long_ ), INTENT(IN)    :: NRHS
  INTEGER ( KIND = long_ ), INTENT(INOUT) :: IPARM(*)
  INTEGER ( KIND = long_ ), INTENT(IN)    :: MSGLVL
  INTEGER ( KIND = long_ ), INTENT(OUT)   :: ERROR
  REAL ( KIND = r16_ ), INTENT(IN)    :: A(*)
  REAL ( KIND = r16_ ), INTENT(INOUT) :: B(*)
  REAL ( KIND = r16_ ), INTENT(OUT)   :: X(*)
  ERROR = INT( GALAHAD_unavailable_option, KIND = long_ )
  END SUBROUTINE PARDISO_Q_64
#endif

  SUBROUTINE PARDISO_SC_64( PT, MAXFCT, MNUM, MTYPE, PHASE, N, A, IA,          &
                            JA, PERM, NRHS, IPARM, MSGLVL, B, X, ERROR )
  USE MKL_PARDISO_PRIVATE
  USE GALAHAD_KINDS, ONLY: sp_, ip_, long_
  USE GALAHAD_SYMBOLS
  TYPE (MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
  INTEGER ( KIND = long_ ), INTENT(IN)    :: MAXFCT
  INTEGER ( KIND = long_ ), INTENT(IN)    :: MNUM
  INTEGER ( KIND = long_ ), INTENT(IN)    :: MTYPE
  INTEGER ( KIND = long_ ), INTENT(IN)    :: PHASE
  INTEGER ( KIND = long_ ), INTENT(IN)    :: N
  INTEGER ( KIND = long_ ), INTENT(IN)    :: IA(*)
  INTEGER ( KIND = long_ ), INTENT(IN)    :: JA(*)
  INTEGER ( KIND = long_ ), INTENT(INOUT) :: PERM(*)
  INTEGER ( KIND = long_ ), INTENT(IN)    :: NRHS
  INTEGER ( KIND = long_ ), INTENT(INOUT) :: IPARM(*)
  INTEGER ( KIND = long_ ), INTENT(IN)    :: MSGLVL
  INTEGER ( KIND = long_ ), INTENT(OUT)   :: ERROR
  COMPLEX ( KIND = sp_ ), INTENT(IN)    :: A(*)
  COMPLEX ( KIND = sp_ ), INTENT(INOUT) :: B(*)
  COMPLEX ( KIND = sp_ ), INTENT(OUT)   :: X(*)
  ERROR = INT( GALAHAD_unavailable_option, KIND = long_ )
  END SUBROUTINE PARDISO_SC_64

  SUBROUTINE PARDISO_DC_64( PT, MAXFCT, MNUM, MTYPE, PHASE, N, A, IA,          &
                            JA, PERM, NRHS, IPARM, MSGLVL, B, X, ERROR )
  USE MKL_PARDISO_PRIVATE
  USE GALAHAD_KINDS, ONLY: dp_, ip_, long_
  USE GALAHAD_SYMBOLS
  TYPE (MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
  INTEGER ( KIND = long_ ), INTENT(IN)    :: MAXFCT
  INTEGER ( KIND = long_ ), INTENT(IN)    :: MNUM
  INTEGER ( KIND = long_ ), INTENT(IN)    :: MTYPE
  INTEGER ( KIND = long_ ), INTENT(IN)    :: PHASE
  INTEGER ( KIND = long_ ), INTENT(IN)    :: N
  INTEGER ( KIND = long_ ), INTENT(IN)    :: IA(*)
  INTEGER ( KIND = long_ ), INTENT(IN)    :: JA(*)
  INTEGER ( KIND = long_ ), INTENT(INOUT) :: PERM(*)
  INTEGER ( KIND = long_ ), INTENT(IN)    :: NRHS
  INTEGER ( KIND = long_ ), INTENT(INOUT) :: IPARM(*)
  INTEGER ( KIND = long_ ), INTENT(IN)    :: MSGLVL
  INTEGER ( KIND = long_ ), INTENT(OUT)   :: ERROR
  COMPLEX ( KIND = dp_ ), INTENT(IN)    :: A(*)
  COMPLEX ( KIND = dp_ ), INTENT(INOUT) :: B(*)
  COMPLEX ( KIND = dp_ ), INTENT(OUT)   :: X(*)
  ERROR = INT( GALAHAD_unavailable_option, KIND = long_ )
  END SUBROUTINE PARDISO_DC_64

#ifdef REAL_128
  SUBROUTINE PARDISO_QC_64( PT, MAXFCT, MNUM, MTYPE, PHASE, N, A, IA,          &
                            JA, PERM, NRHS, IPARM, MSGLVL, B, X, ERROR )
  USE MKL_PARDISO_PRIVATE
  USE GALAHAD_KINDS, ONLY: r16_, ip_, long_
  USE GALAHAD_SYMBOLS
  TYPE (MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
  INTEGER ( KIND = long_ ), INTENT(IN)    :: MAXFCT
  INTEGER ( KIND = long_ ), INTENT(IN)    :: MNUM
  INTEGER ( KIND = long_ ), INTENT(IN)    :: MTYPE
  INTEGER ( KIND = long_ ), INTENT(IN)    :: PHASE
  INTEGER ( KIND = long_ ), INTENT(IN)    :: N
  INTEGER ( KIND = long_ ), INTENT(IN)    :: IA(*)
  INTEGER ( KIND = long_ ), INTENT(IN)    :: JA(*)
  INTEGER ( KIND = long_ ), INTENT(INOUT) :: PERM(*)
  INTEGER ( KIND = long_ ), INTENT(IN)    :: NRHS
  INTEGER ( KIND = long_ ), INTENT(INOUT) :: IPARM(*)
  INTEGER ( KIND = long_ ), INTENT(IN)    :: MSGLVL
  INTEGER ( KIND = long_ ), INTENT(OUT)   :: ERROR
  COMPLEX ( KIND = r16_ ), INTENT(IN)    :: A(*)
  COMPLEX ( KIND = r16_ ), INTENT(INOUT) :: B(*)
  COMPLEX ( KIND = r16_ ), INTENT(OUT)   :: X(*)
  ERROR = INT( GALAHAD_unavailable_option, KIND = long_ )
  END SUBROUTINE PARDISO_QC_64
#endif

  SUBROUTINE PARDISO_S_64_2D( PT, MAXFCT, MNUM, MTYPE, PHASE, N, A, IA,        &
                              JA, PERM, NRHS, IPARM, MSGLVL, B, X, ERROR )
  USE MKL_PARDISO_PRIVATE
  USE GALAHAD_KINDS, ONLY: sp_, ip_, long_
  USE GALAHAD_SYMBOLS
  TYPE (MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
  INTEGER ( KIND = long_ ), INTENT(IN)    :: MAXFCT
  INTEGER ( KIND = long_ ), INTENT(IN)    :: MNUM
  INTEGER ( KIND = long_ ), INTENT(IN)    :: MTYPE
  INTEGER ( KIND = long_ ), INTENT(IN)    :: PHASE
  INTEGER ( KIND = long_ ), INTENT(IN)    :: N
  INTEGER ( KIND = long_ ), INTENT(IN)    :: IA(*)
  INTEGER ( KIND = long_ ), INTENT(IN)    :: JA(*)
  INTEGER ( KIND = long_ ), INTENT(INOUT) :: PERM(*)
  INTEGER ( KIND = long_ ), INTENT(IN)    :: NRHS
  INTEGER ( KIND = long_ ), INTENT(INOUT) :: IPARM(*)
  INTEGER ( KIND = long_ ), INTENT(IN)    :: MSGLVL
  INTEGER ( KIND = long_ ), INTENT(OUT)   :: ERROR
  REAL ( KIND = sp_ ), INTENT(IN)    :: A(*)
  REAL ( KIND = sp_ ), INTENT(INOUT) :: B(N,*)
  REAL ( KIND = sp_ ), INTENT(OUT)   :: X(N,*)
  ERROR = INT( GALAHAD_unavailable_option, KIND = long_ )
  END SUBROUTINE PARDISO_S_64_2D

  SUBROUTINE PARDISO_D_64_2D( PT, MAXFCT, MNUM, MTYPE, PHASE, N, A, IA,        &
                              JA, PERM, NRHS, IPARM, MSGLVL, B, X, ERROR )
  USE MKL_PARDISO_PRIVATE
  USE GALAHAD_KINDS, ONLY: dp_, ip_, long_
  USE GALAHAD_SYMBOLS
  TYPE (MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
  INTEGER ( KIND = long_ ), INTENT(IN)    :: MAXFCT
  INTEGER ( KIND = long_ ), INTENT(IN)    :: MNUM
  INTEGER ( KIND = long_ ), INTENT(IN)    :: MTYPE
  INTEGER ( KIND = long_ ), INTENT(IN)    :: PHASE
  INTEGER ( KIND = long_ ), INTENT(IN)    :: N
  INTEGER ( KIND = long_ ), INTENT(IN)    :: IA(*)
  INTEGER ( KIND = long_ ), INTENT(IN)    :: JA(*)
  INTEGER ( KIND = long_ ), INTENT(INOUT) :: PERM(*)
  INTEGER ( KIND = long_ ), INTENT(IN)    :: NRHS
  INTEGER ( KIND = long_ ), INTENT(INOUT) :: IPARM(*)
  INTEGER ( KIND = long_ ), INTENT(IN)    :: MSGLVL
  INTEGER ( KIND = long_ ), INTENT(OUT)   :: ERROR
  REAL ( KIND = dp_ ), INTENT(IN)    :: A(*)
  REAL ( KIND = dp_ ), INTENT(INOUT) :: B(N,*)
  REAL ( KIND = dp_ ), INTENT(OUT)   :: X(N,*)
  ERROR = INT( GALAHAD_unavailable_option, KIND = long_ )
  END SUBROUTINE PARDISO_D_64_2D

#ifdef REAL_128
  SUBROUTINE PARDISO_Q_64_2D( PT, MAXFCT, MNUM, MTYPE, PHASE, N, A, IA,        &
                              JA, PERM, NRHS, IPARM, MSGLVL, B, X, ERROR )
  USE MKL_PARDISO_PRIVATE
  USE GALAHAD_KINDS, ONLY: r16_, ip_, long_
  USE GALAHAD_SYMBOLS
  TYPE (MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
  INTEGER ( KIND = long_ ), INTENT(IN)    :: MAXFCT
  INTEGER ( KIND = long_ ), INTENT(IN)    :: MNUM
  INTEGER ( KIND = long_ ), INTENT(IN)    :: MTYPE
  INTEGER ( KIND = long_ ), INTENT(IN)    :: PHASE
  INTEGER ( KIND = long_ ), INTENT(IN)    :: N
  INTEGER ( KIND = long_ ), INTENT(IN)    :: IA(*)
  INTEGER ( KIND = long_ ), INTENT(IN)    :: JA(*)
  INTEGER ( KIND = long_ ), INTENT(INOUT) :: PERM(*)
  INTEGER ( KIND = long_ ), INTENT(IN)    :: NRHS
  INTEGER ( KIND = long_ ), INTENT(INOUT) :: IPARM(*)
  INTEGER ( KIND = long_ ), INTENT(IN)    :: MSGLVL
  INTEGER ( KIND = long_ ), INTENT(OUT)   :: ERROR
  REAL ( KIND = r16_ ), INTENT(IN)    :: A(*)
  REAL ( KIND = r16_ ), INTENT(INOUT) :: B(N,*)
  REAL ( KIND = r16_ ), INTENT(OUT)   :: X(N,*)
  ERROR = INT( GALAHAD_unavailable_option, KIND = long_ )
  END SUBROUTINE PARDISO_Q_64_2D
#endif

  SUBROUTINE PARDISO_SC_64_2D( PT, MAXFCT, MNUM, MTYPE, PHASE, N, A, IA,       &
                               JA, PERM, NRHS, IPARM, MSGLVL, B, X, ERROR)
  USE MKL_PARDISO_PRIVATE
  USE GALAHAD_KINDS, ONLY: sp_, ip_, long_
  USE GALAHAD_SYMBOLS
  TYPE (MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
  INTEGER ( KIND = long_ ), INTENT(IN)    :: MAXFCT
  INTEGER ( KIND = long_ ), INTENT(IN)    :: MNUM
  INTEGER ( KIND = long_ ), INTENT(IN)    :: MTYPE
  INTEGER ( KIND = long_ ), INTENT(IN)    :: PHASE
  INTEGER ( KIND = long_ ), INTENT(IN)    :: N
  INTEGER ( KIND = long_ ), INTENT(IN)    :: IA(*)
  INTEGER ( KIND = long_ ), INTENT(IN)    :: JA(*)
  INTEGER ( KIND = long_ ), INTENT(INOUT) :: PERM(*)
  INTEGER ( KIND = long_ ), INTENT(IN)    :: NRHS
  INTEGER ( KIND = long_ ), INTENT(INOUT) :: IPARM(*)
  INTEGER ( KIND = long_ ), INTENT(IN)    :: MSGLVL
  INTEGER ( KIND = long_ ), INTENT(OUT)   :: ERROR
  COMPLEX ( KIND = sp_ ), INTENT(IN)    :: A(*)
  COMPLEX ( KIND = sp_ ), INTENT(INOUT) :: B(N,*)
  COMPLEX ( KIND = sp_ ), INTENT(OUT)   :: X(N,*)
  ERROR = INT( GALAHAD_unavailable_option, KIND = long_ )
  END SUBROUTINE PARDISO_SC_64_2D

  SUBROUTINE PARDISO_DC_64_2D( PT, MAXFCT, MNUM, MTYPE, PHASE, N, A, IA,       &
                               JA, PERM, NRHS, IPARM, MSGLVL, B, X, ERROR)
  USE MKL_PARDISO_PRIVATE
  USE GALAHAD_KINDS, ONLY: dp_, ip_, long_
  USE GALAHAD_SYMBOLS
  TYPE (MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
  INTEGER ( KIND = long_ ), INTENT(IN)    :: MAXFCT
  INTEGER ( KIND = long_ ), INTENT(IN)    :: MNUM
  INTEGER ( KIND = long_ ), INTENT(IN)    :: MTYPE
  INTEGER ( KIND = long_ ), INTENT(IN)    :: PHASE
  INTEGER ( KIND = long_ ), INTENT(IN)    :: N
  INTEGER ( KIND = long_ ), INTENT(IN)    :: IA(*)
  INTEGER ( KIND = long_ ), INTENT(IN)    :: JA(*)
  INTEGER ( KIND = long_ ), INTENT(INOUT) :: PERM(*)
  INTEGER ( KIND = long_ ), INTENT(IN)    :: NRHS
  INTEGER ( KIND = long_ ), INTENT(INOUT) :: IPARM(*)
  INTEGER ( KIND = long_ ), INTENT(IN)    :: MSGLVL
  INTEGER ( KIND = long_ ), INTENT(OUT)   :: ERROR
  COMPLEX ( KIND = dp_ ), INTENT(IN)    :: A(*)
  COMPLEX ( KIND = dp_ ), INTENT(INOUT) :: B(N,*)
  COMPLEX ( KIND = dp_ ), INTENT(OUT)   :: X(N,*)
  ERROR = INT( GALAHAD_unavailable_option, KIND = long_ )
  END SUBROUTINE PARDISO_DC_64_2D

#ifdef REAL_128
  SUBROUTINE PARDISO_QC_64_2D( PT, MAXFCT, MNUM, MTYPE, PHASE, N, A, IA,       &
                               JA, PERM, NRHS, IPARM, MSGLVL, B, X, ERROR)
  USE MKL_PARDISO_PRIVATE
  USE GALAHAD_KINDS, ONLY: r16_, ip_, long_
  USE GALAHAD_SYMBOLS
  TYPE (MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
  INTEGER ( KIND = long_ ), INTENT(IN)    :: MAXFCT
  INTEGER ( KIND = long_ ), INTENT(IN)    :: MNUM
  INTEGER ( KIND = long_ ), INTENT(IN)    :: MTYPE
  INTEGER ( KIND = long_ ), INTENT(IN)    :: PHASE
  INTEGER ( KIND = long_ ), INTENT(IN)    :: N
  INTEGER ( KIND = long_ ), INTENT(IN)    :: IA(*)
  INTEGER ( KIND = long_ ), INTENT(IN)    :: JA(*)
  INTEGER ( KIND = long_ ), INTENT(INOUT) :: PERM(*)
  INTEGER ( KIND = long_ ), INTENT(IN)    :: NRHS
  INTEGER ( KIND = long_ ), INTENT(INOUT) :: IPARM(*)
  INTEGER ( KIND = long_ ), INTENT(IN)    :: MSGLVL
  INTEGER ( KIND = long_ ), INTENT(OUT)   :: ERROR
  COMPLEX ( KIND = r16_ ), INTENT(IN)    :: A(*)
  COMPLEX ( KIND = r16_ ), INTENT(INOUT) :: B(N,*)
  COMPLEX ( KIND = r16_ ), INTENT(OUT)   :: X(N,*)
  ERROR = INT( GALAHAD_unavailable_option, KIND = long_ )
  END SUBROUTINE PARDISO_QC_64_2D
#endif

  SUBROUTINE PARDISO_GETDIAG_D(PT,DIAG_FACT,DIAG_A,MNUM,ERROR)
  USE MKL_PARDISO_PRIVATE
  USE GALAHAD_KINDS, ONLY: dp_, ip_
  USE GALAHAD_SYMBOLS
  TYPE (MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
  REAL ( KIND = dp_ ), INTENT(INOUT) :: DIAG_FACT(*), DIAG_A(*)
  INTEGER ( KIND = ip_ ), INTENT(IN)            :: MNUM
  INTEGER ( KIND = ip_ ), INTENT(INOUT)         :: ERROR
  ERROR = GALAHAD_unavailable_option
  END

  SUBROUTINE PARDISO_GETDIAG_Z(PT,DIAG_FACT,DIAG_A,MNUM,ERROR)
  USE MKL_PARDISO_PRIVATE
  USE GALAHAD_KINDS, ONLY: c8_, ip_
  USE GALAHAD_SYMBOLS
  TYPE (MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
  COMPLEX( KIND = c8_ ), INTENT(INOUT)   :: DIAG_FACT(*), DIAG_A(*)
  INTEGER ( KIND = ip_ ), INTENT(IN) :: MNUM
  INTEGER ( KIND = ip_ ), INTENT(INOUT):: ERROR
  ERROR = GALAHAD_unavailable_option
  END

  SUBROUTINE PARDISO_EXPORT_S(PT,VALUES,IA,JA,STEP,IPARM,ERROR)
  USE MKL_PARDISO_PRIVATE
  USE GALAHAD_KINDS, ONLY: sp_, ip_
  USE GALAHAD_SYMBOLS
  TYPE (MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
  REAL ( KIND = sp_ ), INTENT(INOUT) :: VALUES(*)
  INTEGER ( KIND = ip_ ), INTENT(INOUT) :: IA(*), JA(*)
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: STEP
  INTEGER ( KIND = ip_ ), INTENT(INOUT) :: IPARM(*)
  INTEGER ( KIND = ip_ ), INTENT(OUT)   :: ERROR
  ERROR = GALAHAD_unavailable_option
  END

  SUBROUTINE PARDISO_EXPORT_D(PT,VALUES,IA,JA,STEP,IPARM,ERROR)
  USE MKL_PARDISO_PRIVATE
  USE GALAHAD_KINDS, ONLY: dp_, ip_
  USE GALAHAD_SYMBOLS
  TYPE (MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
  REAL ( KIND = dp_ ), INTENT(INOUT) :: VALUES(*)
  INTEGER ( KIND = ip_ ), INTENT(INOUT) :: IA(*), JA(*)
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: STEP
  INTEGER ( KIND = ip_ ), INTENT(INOUT) :: IPARM(*)
  INTEGER ( KIND = ip_ ), INTENT(OUT)   :: ERROR
  ERROR = GALAHAD_unavailable_option
  END

#ifdef REAL_128
  SUBROUTINE PARDISO_EXPORT_Q(PT,VALUES,IA,JA,STEP,IPARM,ERROR)
  USE MKL_PARDISO_PRIVATE
  USE GALAHAD_KINDS, ONLY: r16_, ip_
  USE GALAHAD_SYMBOLS
  TYPE (MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
  REAL ( KIND = r16_ ), INTENT(INOUT) :: VALUES(*)
  INTEGER ( KIND = ip_ ), INTENT(INOUT) :: IA(*), JA(*)
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: STEP
  INTEGER ( KIND = ip_ ), INTENT(INOUT) :: IPARM(*)
  INTEGER ( KIND = ip_ ), INTENT(OUT)   :: ERROR
  ERROR = GALAHAD_unavailable_option
  END
#endif

  SUBROUTINE PARDISO_EXPORT_C(PT,VALUES,IA,JA,STEP,IPARM,ERROR)
  USE MKL_PARDISO_PRIVATE
  USE GALAHAD_KINDS, ONLY: c4_, ip_
  USE GALAHAD_SYMBOLS
  TYPE (MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
  COMPLEX( KIND = c4_ ), INTENT(INOUT) :: VALUES(*)
  INTEGER ( KIND = ip_ ), INTENT(INOUT) :: IA(*), JA(*)
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: STEP
  INTEGER ( KIND = ip_ ), INTENT(INOUT) :: IPARM(*)
  INTEGER ( KIND = ip_ ), INTENT(OUT)   :: ERROR
  ERROR = GALAHAD_unavailable_option
  END

  SUBROUTINE PARDISO_EXPORT_Z(PT,VALUES,IA,JA,STEP,IPARM,ERROR)
  USE MKL_PARDISO_PRIVATE
  USE GALAHAD_KINDS, ONLY: c8_, ip_
  USE GALAHAD_SYMBOLS
  TYPE (MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
  COMPLEX( KIND = c8_ ), INTENT(INOUT) :: VALUES(*)
  INTEGER ( KIND = ip_ ), INTENT(INOUT) :: IA(*), JA(*)
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: STEP
  INTEGER ( KIND = ip_ ), INTENT(INOUT) :: IPARM(*)
  INTEGER ( KIND = ip_ ), INTENT(OUT)   :: ERROR
  ERROR = GALAHAD_unavailable_option
  END

#ifdef REAL_128
  SUBROUTINE PARDISO_EXPORT_X(PT,VALUES,IA,JA,STEP,IPARM,ERROR)
  USE MKL_PARDISO_PRIVATE
  USE GALAHAD_KINDS, ONLY: c16_, ip_
  USE GALAHAD_SYMBOLS
  TYPE (MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
  COMPLEX( KIND = c16_ ), INTENT(INOUT) :: VALUES(*)
  INTEGER ( KIND = ip_ ), INTENT(INOUT) :: IA(*), JA(*)
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: STEP
  INTEGER ( KIND = ip_ ), INTENT(INOUT) :: IPARM(*)
  INTEGER ( KIND = ip_ ), INTENT(OUT)   :: ERROR
  ERROR = GALAHAD_unavailable_option
  END
#endif

  SUBROUTINE PARDISO_HANDLE_STORE( PT, STORE_NAME, ERROR )
  USE MKL_PARDISO_PRIVATE
  USE GALAHAD_KINDS, ONLY: ip_
  USE GALAHAD_SYMBOLS
  TYPE (MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
  CHARACTER, INTENT(IN)  :: STORE_NAME(*)
  INTEGER ( KIND = ip_ ),   INTENT(OUT) :: ERROR
  ERROR = GALAHAD_unavailable_option
  END SUBROUTINE PARDISO_HANDLE_STORE

  SUBROUTINE PARDISO_HANDLE_STORE_64( PT, STORE_NAME, ERROR )
  USE MKL_PARDISO_PRIVATE
  USE GALAHAD_KINDS, ONLY: ip_, long_
  USE GALAHAD_SYMBOLS
  TYPE (MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
  CHARACTER, INTENT(IN)  :: STORE_NAME(*)
  INTEGER ( KIND = long_ ), INTENT(OUT) :: ERROR
  ERROR = GALAHAD_unavailable_option
  END SUBROUTINE PARDISO_HANDLE_STORE_64

  SUBROUTINE PARDISO_HANDLE_RESTORE( PT, STORE_NAME, ERROR )
  USE MKL_PARDISO_PRIVATE
  USE GALAHAD_KINDS, ONLY: ip_
  USE GALAHAD_SYMBOLS
  TYPE (MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
  CHARACTER, INTENT(IN)  :: STORE_NAME(*)
  INTEGER ( KIND = ip_ ), INTENT(OUT) :: ERROR
  ERROR = GALAHAD_unavailable_option
  END SUBROUTINE PARDISO_HANDLE_RESTORE

  SUBROUTINE PARDISO_HANDLE_RESTORE_64( PT, STORE_NAME, ERROR )
  USE MKL_PARDISO_PRIVATE
  USE GALAHAD_KINDS, ONLY: ip_, long_
  USE GALAHAD_SYMBOLS
  TYPE (MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
  CHARACTER, INTENT(IN)  :: STORE_NAME(*)
  INTEGER ( KIND = long_ ), INTENT(OUT) :: ERROR
  ERROR = GALAHAD_unavailable_option
  END SUBROUTINE PARDISO_HANDLE_RESTORE_64

  SUBROUTINE PARDISO_HANDLE_DELETE( STORE_NAME, ERROR )
  USE MKL_PARDISO_PRIVATE
  USE GALAHAD_KINDS, ONLY: ip_
  USE GALAHAD_SYMBOLS
  CHARACTER, INTENT(IN)  :: STORE_NAME(*)
  INTEGER ( KIND = ip_ ), INTENT(OUT) :: ERROR
  ERROR = GALAHAD_unavailable_option
  END SUBROUTINE PARDISO_HANDLE_DELETE

  SUBROUTINE PARDISO_HANDLE_DELETE_64( STORE_NAME, ERROR )
  USE MKL_PARDISO_PRIVATE
  USE GALAHAD_KINDS, ONLY: long_
  USE GALAHAD_SYMBOLS
  CHARACTER, INTENT(IN)  :: STORE_NAME(*)
  INTEGER ( KIND = long_ ), INTENT(OUT) :: ERROR
  ERROR = GALAHAD_unavailable_option
  END SUBROUTINE PARDISO_HANDLE_DELETE_64

  FUNCTION PARDISO_GETENV(PT, OptName, StrVal)
  USE MKL_PARDISO_PRIVATE
  USE GALAHAD_KINDS, ONLY: ip_
  USE GALAHAD_SYMBOLS
  INTEGER ( KIND = ip_ ) :: PARDISO_GETENV
  TYPE (MKL_PARDISO_HANDLE), INTENT(IN)  :: PT(*)
  INTEGER ( KIND = ip_ ), INTENT(IN)  :: OptName
  CHARACTER, INTENT(OUT) :: StrVal(*)
  PARDISO_GETENV = GALAHAD_unavailable_option
  END FUNCTION PARDISO_GETENV

  FUNCTION PARDISO_GETENV_F(PT, OptName, StrVal)
  USE MKL_PARDISO_PRIVATE
  USE GALAHAD_KINDS, ONLY: ip_
  USE GALAHAD_SYMBOLS
  INTEGER ( KIND = ip_ ) :: PARDISO_GETENV_F
  TYPE (MKL_PARDISO_HANDLE), INTENT(IN)  :: PT(*)
  INTEGER ( KIND = ip_ ), INTENT(IN)  :: OptName
  CHARACTER (*), INTENT(OUT) :: StrVal
  PARDISO_GETENV_F = GALAHAD_unavailable_option
  END FUNCTION PARDISO_GETENV_F

  FUNCTION PARDISO_SETENV(PT, OptName, StrVal)
  USE MKL_PARDISO_PRIVATE
  USE GALAHAD_KINDS, ONLY: ip_
  USE GALAHAD_SYMBOLS
  INTEGER ( KIND = ip_ ) :: PARDISO_SETENV
  TYPE (MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: OptName
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: StrVal(*)
  PARDISO_SETENV = GALAHAD_unavailable_option
  END FUNCTION PARDISO_SETENV

  FUNCTION PARDISO_SETENV_F(PT, OptName, StrVal)
  USE MKL_PARDISO_PRIVATE
  USE GALAHAD_KINDS, ONLY: ip_
  USE GALAHAD_SYMBOLS
  INTEGER ( KIND = ip_ ) :: PARDISO_SETENV_F
  TYPE (MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
  INTEGER ( KIND = ip_ ), INTENT(IN)    :: OptName
  CHARACTER (*), INTENT(IN)    :: StrVal
  PARDISO_SETENV_F = GALAHAD_unavailable_option
  END FUNCTION PARDISO_SETENV_F

  FUNCTION MKL_PARDISO_PIVOT( AII, BII, EPS)
  USE GALAHAD_KINDS, ONLY: ip_, dp_
  USE GALAHAD_SYMBOLS
  REAL ( KIND = dp_ ) :: AII, BII, EPS
  INTEGER ( KIND = ip_ ) :: MKL_PARDISO_PIVOT
  MKL_PARDISO_PIVOT = GALAHAD_unavailable_option
  END
