/*!
\file
 *
 * This file contains aliases for GKlib 5.1 procedures
 *
 * Nick Gould, STFC-RAL, 2025-03-19
 *
 */


#ifndef _LIBMETIS_GK_RENAME_H_
#define _LIBMETIS_GK_RENAME_H_

/* 64-bit integer procedures */

#ifdef INTEGER_64

#define errexit errexit_51_64
#define getpathname getpathname_51_64
#define gk_AllocMatrix gk_AllocMatrix_51_64
#define gk_cAllocMatrix gk_cAllocMatrix_51_64
#define gk_ccopy gk_ccopy_51_64
#define gk_cFreeMatrix gk_cFreeMatrix_51_64
#define gk_ckvAllocMatrix gk_ckvAllocMatrix_51_64
#define gk_ckvcopy gk_ckvcopy_51_64
#define gk_ckvFreeMatrix gk_ckvFreeMatrix_51_64
#define gk_ckvmalloc gk_ckvmalloc_51_64
#define gk_ckvrealloc gk_ckvrealloc_51_64
#define gk_ckvset gk_ckvset_51_64
#define gk_ckvSetMatrix gk_ckvSetMatrix_51_64
#define gk_ckvsmalloc gk_ckvsmalloc_51_64
#define gk_cmalloc gk_cmalloc_51_64
#define gk_CPUSeconds gk_CPUSeconds_51_64
#define gk_crand gk_crand_51_64
#define gk_crandArrayPermute gk_crandArrayPermute_51_64
#define gk_crandArrayPermuteFine gk_crandArrayPermuteFine_51_64
#define gk_crandInRange gk_crandInRange_51_64
#define gk_crealloc gk_crealloc_51_64
#define gk_cset gk_cset_51_64
#define gk_cSetMatrix gk_cSetMatrix_51_64
#define gk_csmalloc gk_csmalloc_51_64
#define gk_csrand gk_csrand_51_64
#define gk_cur_jbufs gk_cur_jbufs_51_64
#define gk_dAllocMatrix gk_dAllocMatrix_51_64
#define gk_dcopy gk_dcopy_51_64
#define gk_dexists gk_dexists_51_64
#define gk_dFreeMatrix gk_dFreeMatrix_51_64
#define gk_dkvAllocMatrix gk_dkvAllocMatrix_51_64
#define gk_dkvcopy gk_dkvcopy_51_64
#define gk_dkvFreeMatrix gk_dkvFreeMatrix_51_64
#define gk_dkvmalloc gk_dkvmalloc_51_64
#define gk_dkvrealloc gk_dkvrealloc_51_64
#define gk_dkvset gk_dkvset_51_64
#define gk_dkvSetMatrix gk_dkvSetMatrix_51_64
#define gk_dkvsmalloc gk_dkvsmalloc_51_64
#define gk_dmalloc gk_dmalloc_51_64
#define gk_drand gk_drand_51_64
#define gk_drandArrayPermute gk_drandArrayPermute_51_64
#define gk_drandArrayPermuteFine gk_drandArrayPermuteFine_51_64
#define gk_drandInRange gk_drandInRange_51_64
#define gk_dreadfilebin gk_dreadfilebin_51_64
#define gk_drealloc gk_drealloc_51_64
#define gk_dset gk_dset_51_64
#define gk_dSetMatrix gk_dSetMatrix_51_64
#define gk_dsmalloc gk_dsmalloc_51_64
#define gk_dsrand gk_dsrand_51_64
#define gk_errexit gk_errexit_51_64
#define gk_fAllocMatrix gk_fAllocMatrix_51_64
#define gk_fclose gk_fclose_51_64
#define gk_fcopy gk_fcopy_51_64
#define gk_fexists gk_fexists_51_64
#define gk_fFreeMatrix gk_fFreeMatrix_51_64
#define gk_fkvAllocMatrix gk_fkvAllocMatrix_51_64
#define gk_fkvcopy gk_fkvcopy_51_64
#define gk_fkvFreeMatrix gk_fkvFreeMatrix_51_64
#define gk_fkvmalloc gk_fkvmalloc_51_64
#define gk_fkvrealloc gk_fkvrealloc_51_64
#define gk_fkvset gk_fkvset_51_64
#define gk_fkvSetMatrix gk_fkvSetMatrix_51_64
#define gk_fkvsmalloc gk_fkvsmalloc_51_64
#define gk_fmalloc gk_fmalloc_51_64
#define gk_fopen gk_fopen_51_64
#define gk_frand gk_frand_51_64
#define gk_frandArrayPermute gk_frandArrayPermute_51_64
#define gk_frandArrayPermuteFine gk_frandArrayPermuteFine_51_64
#define gk_frandInRange gk_frandInRange_51_64
#define gk_freadfilebin gk_freadfilebin_51_64
#define gk_frealloc gk_frealloc_51_64
#define gk_free gk_free_51_64
#define gk_FreeMatrix gk_FreeMatrix_51_64
#define gk_fset gk_fset_51_64
#define gk_fSetMatrix gk_fSetMatrix_51_64
#define gk_fsmalloc gk_fsmalloc_51_64
#define gk_fsrand gk_fsrand_51_64
#define gk_fwritefilebin gk_fwritefilebin_51_64
#define gk_getbasename gk_getbasename_51_64
#define gk_GetCurMemoryUsed gk_GetCurMemoryUsed_51_64
#define gk_getextname gk_getextname_51_64
#define gk_getfilename gk_getfilename_51_64
#define gk_getfilestats gk_getfilestats_51_64
#define gk_getfsize gk_getfsize_51_64
#define gk_getline gk_getline_51_64
#define gk_GetMaxMemoryUsed gk_GetMaxMemoryUsed_51_64
#define gk_GetStringID gk_GetStringID_51_64
#define gk_gkmcoreAdd gk_gkmcoreAdd_51_64
#define gk_gkmcoreCreate gk_gkmcoreCreate_51_64
#define gk_gkmcoreDel gk_gkmcoreDel_51_64
#define gk_gkmcoreDestroy gk_gkmcoreDestroy_51_64
#define gk_gkmcorePop gk_gkmcorePop_51_64
#define gk_gkmcorePush gk_gkmcorePush_51_64
#define gk_i32AllocMatrix gk_i32AllocMatrix_51_64
#define gk_i32copy gk_i32copy_51_64
#define gk_i32FreeMatrix gk_i32FreeMatrix_51_64
#define gk_i32kvAllocMatrix gk_i32kvAllocMatrix_51_64
#define gk_i32kvcopy gk_i32kvcopy_51_64
#define gk_i32kvFreeMatrix gk_i32kvFreeMatrix_51_64
#define gk_i32kvmalloc gk_i32kvmalloc_51_64
#define gk_i32kvrealloc gk_i32kvrealloc_51_64
#define gk_i32kvset gk_i32kvset_51_64
#define gk_i32kvSetMatrix gk_i32kvSetMatrix_51_64
#define gk_i32kvsmalloc gk_i32kvsmalloc_51_64
#define gk_i32malloc gk_i32malloc_51_64
#define gk_i32readfile gk_i32readfile_51_64
#define gk_i32readfilebin gk_i32readfilebin_51_64
#define gk_i32realloc gk_i32realloc_51_64
#define gk_i32set gk_i32set_51_64
#define gk_i32SetMatrix gk_i32SetMatrix_51_64
#define gk_i32smalloc gk_i32smalloc_51_64
#define gk_i64AllocMatrix gk_i64AllocMatrix_51_64
#define gk_i64copy gk_i64copy_51_64
#define gk_i64FreeMatrix gk_i64FreeMatrix_51_64
#define gk_i64kvAllocMatrix gk_i64kvAllocMatrix_51_64
#define gk_i64kvcopy gk_i64kvcopy_51_64
#define gk_i64kvFreeMatrix gk_i64kvFreeMatrix_51_64
#define gk_i64kvmalloc gk_i64kvmalloc_51_64
#define gk_i64kvrealloc gk_i64kvrealloc_51_64
#define gk_i64kvset gk_i64kvset_51_64
#define gk_i64kvSetMatrix gk_i64kvSetMatrix_51_64
#define gk_i64kvsmalloc gk_i64kvsmalloc_51_64
#define gk_i64malloc gk_i64malloc_51_64
#define gk_i64readfile gk_i64readfile_51_64
#define gk_i64readfilebin gk_i64readfilebin_51_64
#define gk_i64realloc gk_i64realloc_51_64
#define gk_i64set gk_i64set_51_64
#define gk_i64SetMatrix gk_i64SetMatrix_51_64
#define gk_i64smalloc gk_i64smalloc_51_64
#define gk_iAllocMatrix gk_iAllocMatrix_51_64
#define gk_icopy gk_icopy_51_64
#define gk_idxAllocMatrix gk_idxAllocMatrix_51_64
#define gk_idxcopy gk_idxcopy_51_64
#define gk_idxFreeMatrix gk_idxFreeMatrix_51_64
#define gk_idxkvAllocMatrix gk_idxkvAllocMatrix_51_64
#define gk_idxkvcopy gk_idxkvcopy_51_64
#define gk_idxkvFreeMatrix gk_idxkvFreeMatrix_51_64
#define gk_idxkvmalloc gk_idxkvmalloc_51_64
#define gk_idxkvrealloc gk_idxkvrealloc_51_64
#define gk_idxkvset gk_idxkvset_51_64
#define gk_idxkvSetMatrix gk_idxkvSetMatrix_51_64
#define gk_idxkvsmalloc gk_idxkvsmalloc_51_64
#define gk_idxmalloc gk_idxmalloc_51_64
#define gk_idxrand gk_idxrand_51_64
#define gk_idxrandArrayPermute gk_idxrandArrayPermute_51_64
#define gk_idxrandArrayPermuteFine gk_idxrandArrayPermuteFine_51_64
#define gk_idxrandInRange gk_idxrandInRange_51_64
#define gk_idxrealloc gk_idxrealloc_51_64
#define gk_idxset gk_idxset_51_64
#define gk_idxSetMatrix gk_idxSetMatrix_51_64
#define gk_idxsmalloc gk_idxsmalloc_51_64
#define gk_idxsrand gk_idxsrand_51_64
#define gk_iFreeMatrix gk_iFreeMatrix_51_64
#define gk_ikvAllocMatrix gk_ikvAllocMatrix_51_64
#define gk_ikvcopy gk_ikvcopy_51_64
#define gk_ikvFreeMatrix gk_ikvFreeMatrix_51_64
#define gk_ikvmalloc gk_ikvmalloc_51_64
#define gk_ikvrealloc gk_ikvrealloc_51_64
#define gk_ikvset gk_ikvset_51_64
#define gk_ikvSetMatrix gk_ikvSetMatrix_51_64
#define gk_ikvsmalloc gk_ikvsmalloc_51_64
#define gk_imalloc gk_imalloc_51_64
#define gk_irand gk_irand_51_64
#define gk_irandArrayPermute gk_irandArrayPermute_51_64
#define gk_irandArrayPermuteFine gk_irandArrayPermuteFine_51_64
#define gk_irandInRange gk_irandInRange_51_64
#define gk_irealloc gk_irealloc_51_64
#define gk_iset gk_iset_51_64
#define gk_iSetMatrix gk_iSetMatrix_51_64
#define gk_ismalloc gk_ismalloc_51_64
#define gk_isrand gk_isrand_51_64
#define gk_jbuf gk_jbuf_51_64
#define gk_jbufs gk_jbufs_51_64
#define gk_malloc gk_malloc_51_64
#define gk_malloc_cleanup gk_malloc_cleanup_51_64
#define gk_malloc_init gk_malloc_init_51_64
#define gk_mcoreAdd gk_mcoreAdd_51_64
#define gk_mcoreCreate gk_mcoreCreate_51_64
#define gk_mcoreDel gk_mcoreDel_51_64
#define gk_mcoreDestroy gk_mcoreDestroy_51_64
#define gk_mcoreMalloc gk_mcoreMalloc_51_64
#define gk_mcorePop gk_mcorePop_51_64
#define gk_mcorePush gk_mcorePush_51_64
#define gk_mkpath gk_mkpath_51_64
#define gk_NonLocalExit_Handler gk_NonLocalExit_Handler_51_64
#define gk_randinit gk_randinit_51_64
#define gk_randint32 gk_randint32_51_64
#define gk_randint64 gk_randint64_51_64
#define gk_readfile gk_readfile_51_64
#define gk_realloc gk_realloc_51_64
#define gk_rmpath gk_rmpath_51_64
#define gk_set_exit_on_error gk_set_exit_on_error_51_64
#define gk_SetSignalHandlers gk_SetSignalHandlers_51_64
#define gk_sigthrow gk_sigthrow_51_64
#define gk_sigtrap gk_sigtrap_51_64
#define gk_siguntrap gk_siguntrap_51_64
#define gk_skvAllocMatrix gk_skvAllocMatrix_51_64
#define gk_skvcopy gk_skvcopy_51_64
#define gk_skvFreeMatrix gk_skvFreeMatrix_51_64
#define gk_skvmalloc gk_skvmalloc_51_64
#define gk_skvrealloc gk_skvrealloc_51_64
#define gk_skvset gk_skvset_51_64
#define gk_skvSetMatrix gk_skvSetMatrix_51_64
#define gk_skvsmalloc gk_skvsmalloc_51_64
#define gk_str2time gk_str2time_51_64
#define gk_strcasecmp gk_strcasecmp_51_64
#define gk_strchr_replace gk_strchr_replace_51_64
#define gk_strdup gk_strdup_51_64
#define gk_strerror gk_strerror_51_64
#define gk_strhprune gk_strhprune_51_64
#define gk_strrcmp gk_strrcmp_51_64
#define gk_strstr_replace gk_strstr_replace_51_64
#define gk_strtolower gk_strtolower_51_64
#define gk_strtoupper gk_strtoupper_51_64
#define gk_strtprune gk_strtprune_51_64
#define gk_time2str gk_time2str_51_64
#define gk_UnsetSignalHandlers gk_UnsetSignalHandlers_51_64
#define gk_WClockSeconds gk_WClockSeconds_51_64
#define gk_zAllocMatrix gk_zAllocMatrix_51_64
#define gk_zcopy gk_zcopy_51_64
#define gk_zFreeMatrix gk_zFreeMatrix_51_64
#define gk_zkvAllocMatrix gk_zkvAllocMatrix_51_64
#define gk_zkvcopy gk_zkvcopy_51_64
#define gk_zkvFreeMatrix gk_zkvFreeMatrix_51_64
#define gk_zkvmalloc gk_zkvmalloc_51_64
#define gk_zkvrealloc gk_zkvrealloc_51_64
#define gk_zkvset gk_zkvset_51_64
#define gk_zkvSetMatrix gk_zkvSetMatrix_51_64
#define gk_zkvsmalloc gk_zkvsmalloc_51_64
#define gk_zmalloc gk_zmalloc_51_64
#define gk_zrand gk_zrand_51_64
#define gk_zrandArrayPermute gk_zrandArrayPermute_51_64
#define gk_zrandArrayPermuteFine gk_zrandArrayPermuteFine_51_64
#define gk_zrandInRange gk_zrandInRange_51_64
#define gk_zrealloc gk_zrealloc_51_64
#define gk_zset gk_zset_51_64
#define gk_zSetMatrix gk_zSetMatrix_51_64
#define gk_zsmalloc gk_zsmalloc_51_64
#define gk_zsrand gk_zsrand_51_64
#define PrintBackTrace PrintBackTrace_51_64

/* 32-bit integer procedures */

#else

#define errexit errexit_51
#define getpathname getpathname_51
#define gk_AllocMatrix gk_AllocMatrix_51
#define gk_cAllocMatrix gk_cAllocMatrix_51
#define gk_ccopy gk_ccopy_51
#define gk_cFreeMatrix gk_cFreeMatrix_51
#define gk_ckvAllocMatrix gk_ckvAllocMatrix_51
#define gk_ckvcopy gk_ckvcopy_51
#define gk_ckvFreeMatrix gk_ckvFreeMatrix_51
#define gk_ckvmalloc gk_ckvmalloc_51
#define gk_ckvrealloc gk_ckvrealloc_51
#define gk_ckvset gk_ckvset_51
#define gk_ckvSetMatrix gk_ckvSetMatrix_51
#define gk_ckvsmalloc gk_ckvsmalloc_51
#define gk_cmalloc gk_cmalloc_51
#define gk_CPUSeconds gk_CPUSeconds_51
#define gk_crand gk_crand_51
#define gk_crandArrayPermute gk_crandArrayPermute_51
#define gk_crandArrayPermuteFine gk_crandArrayPermuteFine_51
#define gk_crandInRange gk_crandInRange_51
#define gk_crealloc gk_crealloc_51
#define gk_cset gk_cset_51
#define gk_cSetMatrix gk_cSetMatrix_51
#define gk_csmalloc gk_csmalloc_51
#define gk_csrand gk_csrand_51
#define gk_cur_jbufs gk_cur_jbufs_51
#define gk_dAllocMatrix gk_dAllocMatrix_51
#define gk_dcopy gk_dcopy_51
#define gk_dexists gk_dexists_51
#define gk_dFreeMatrix gk_dFreeMatrix_51
#define gk_dkvAllocMatrix gk_dkvAllocMatrix_51
#define gk_dkvcopy gk_dkvcopy_51
#define gk_dkvFreeMatrix gk_dkvFreeMatrix_51
#define gk_dkvmalloc gk_dkvmalloc_51
#define gk_dkvrealloc gk_dkvrealloc_51
#define gk_dkvset gk_dkvset_51
#define gk_dkvSetMatrix gk_dkvSetMatrix_51
#define gk_dkvsmalloc gk_dkvsmalloc_51
#define gk_dmalloc gk_dmalloc_51
#define gk_drand gk_drand_51
#define gk_drandArrayPermute gk_drandArrayPermute_51
#define gk_drandArrayPermuteFine gk_drandArrayPermuteFine_51
#define gk_drandInRange gk_drandInRange_51
#define gk_dreadfilebin gk_dreadfilebin_51
#define gk_drealloc gk_drealloc_51
#define gk_dset gk_dset_51
#define gk_dSetMatrix gk_dSetMatrix_51
#define gk_dsmalloc gk_dsmalloc_51
#define gk_dsrand gk_dsrand_51
#define gk_errexit gk_errexit_51
#define gk_fAllocMatrix gk_fAllocMatrix_51
#define gk_fclose gk_fclose_51
#define gk_fcopy gk_fcopy_51
#define gk_fexists gk_fexists_51
#define gk_fFreeMatrix gk_fFreeMatrix_51
#define gk_fkvAllocMatrix gk_fkvAllocMatrix_51
#define gk_fkvcopy gk_fkvcopy_51
#define gk_fkvFreeMatrix gk_fkvFreeMatrix_51
#define gk_fkvmalloc gk_fkvmalloc_51
#define gk_fkvrealloc gk_fkvrealloc_51
#define gk_fkvset gk_fkvset_51
#define gk_fkvSetMatrix gk_fkvSetMatrix_51
#define gk_fkvsmalloc gk_fkvsmalloc_51
#define gk_fmalloc gk_fmalloc_51
#define gk_fopen gk_fopen_51
#define gk_frand gk_frand_51
#define gk_frandArrayPermute gk_frandArrayPermute_51
#define gk_frandArrayPermuteFine gk_frandArrayPermuteFine_51
#define gk_frandInRange gk_frandInRange_51
#define gk_freadfilebin gk_freadfilebin_51
#define gk_frealloc gk_frealloc_51
#define gk_free gk_free_51
#define gk_FreeMatrix gk_FreeMatrix_51
#define gk_fset gk_fset_51
#define gk_fSetMatrix gk_fSetMatrix_51
#define gk_fsmalloc gk_fsmalloc_51
#define gk_fsrand gk_fsrand_51
#define gk_fwritefilebin gk_fwritefilebin_51
#define gk_getbasename gk_getbasename_51
#define gk_GetCurMemoryUsed gk_GetCurMemoryUsed_51
#define gk_getextname gk_getextname_51
#define gk_getfilename gk_getfilename_51
#define gk_getfilestats gk_getfilestats_51
#define gk_getfsize gk_getfsize_51
#define gk_getline gk_getline_51
#define gk_GetMaxMemoryUsed gk_GetMaxMemoryUsed_51
#define gk_GetStringID gk_GetStringID_51
#define gk_gkmcoreAdd gk_gkmcoreAdd_51
#define gk_gkmcoreCreate gk_gkmcoreCreate_51
#define gk_gkmcoreDel gk_gkmcoreDel_51
#define gk_gkmcoreDestroy gk_gkmcoreDestroy_51
#define gk_gkmcorePop gk_gkmcorePop_51
#define gk_gkmcorePush gk_gkmcorePush_51
#define gk_i32AllocMatrix gk_i32AllocMatrix_51
#define gk_i32copy gk_i32copy_51
#define gk_i32FreeMatrix gk_i32FreeMatrix_51
#define gk_i32kvAllocMatrix gk_i32kvAllocMatrix_51
#define gk_i32kvcopy gk_i32kvcopy_51
#define gk_i32kvFreeMatrix gk_i32kvFreeMatrix_51
#define gk_i32kvmalloc gk_i32kvmalloc_51
#define gk_i32kvrealloc gk_i32kvrealloc_51
#define gk_i32kvset gk_i32kvset_51
#define gk_i32kvSetMatrix gk_i32kvSetMatrix_51
#define gk_i32kvsmalloc gk_i32kvsmalloc_51
#define gk_i32malloc gk_i32malloc_51
#define gk_i32readfile gk_i32readfile_51
#define gk_i32readfilebin gk_i32readfilebin_51
#define gk_i32realloc gk_i32realloc_51
#define gk_i32set gk_i32set_51
#define gk_i32SetMatrix gk_i32SetMatrix_51
#define gk_i32smalloc gk_i32smalloc_51
#define gk_i64AllocMatrix gk_i64AllocMatrix_51
#define gk_i64copy gk_i64copy_51
#define gk_i64FreeMatrix gk_i64FreeMatrix_51
#define gk_i64kvAllocMatrix gk_i64kvAllocMatrix_51
#define gk_i64kvcopy gk_i64kvcopy_51
#define gk_i64kvFreeMatrix gk_i64kvFreeMatrix_51
#define gk_i64kvmalloc gk_i64kvmalloc_51
#define gk_i64kvrealloc gk_i64kvrealloc_51
#define gk_i64kvset gk_i64kvset_51
#define gk_i64kvSetMatrix gk_i64kvSetMatrix_51
#define gk_i64kvsmalloc gk_i64kvsmalloc_51
#define gk_i64malloc gk_i64malloc_51
#define gk_i64readfile gk_i64readfile_51
#define gk_i64readfilebin gk_i64readfilebin_51
#define gk_i64realloc gk_i64realloc_51
#define gk_i64set gk_i64set_51
#define gk_i64SetMatrix gk_i64SetMatrix_51
#define gk_i64smalloc gk_i64smalloc_51
#define gk_iAllocMatrix gk_iAllocMatrix_51
#define gk_icopy gk_icopy_51
#define gk_idxAllocMatrix gk_idxAllocMatrix_51
#define gk_idxcopy gk_idxcopy_51
#define gk_idxFreeMatrix gk_idxFreeMatrix_51
#define gk_idxkvAllocMatrix gk_idxkvAllocMatrix_51
#define gk_idxkvcopy gk_idxkvcopy_51
#define gk_idxkvFreeMatrix gk_idxkvFreeMatrix_51
#define gk_idxkvmalloc gk_idxkvmalloc_51
#define gk_idxkvrealloc gk_idxkvrealloc_51
#define gk_idxkvset gk_idxkvset_51
#define gk_idxkvSetMatrix gk_idxkvSetMatrix_51
#define gk_idxkvsmalloc gk_idxkvsmalloc_51
#define gk_idxmalloc gk_idxmalloc_51
#define gk_idxrand gk_idxrand_51
#define gk_idxrandArrayPermute gk_idxrandArrayPermute_51
#define gk_idxrandArrayPermuteFine gk_idxrandArrayPermuteFine_51
#define gk_idxrandInRange gk_idxrandInRange_51
#define gk_idxrealloc gk_idxrealloc_51
#define gk_idxset gk_idxset_51
#define gk_idxSetMatrix gk_idxSetMatrix_51
#define gk_idxsmalloc gk_idxsmalloc_51
#define gk_idxsrand gk_idxsrand_51
#define gk_iFreeMatrix gk_iFreeMatrix_51
#define gk_ikvAllocMatrix gk_ikvAllocMatrix_51
#define gk_ikvcopy gk_ikvcopy_51
#define gk_ikvFreeMatrix gk_ikvFreeMatrix_51
#define gk_ikvmalloc gk_ikvmalloc_51
#define gk_ikvrealloc gk_ikvrealloc_51
#define gk_ikvset gk_ikvset_51
#define gk_ikvSetMatrix gk_ikvSetMatrix_51
#define gk_ikvsmalloc gk_ikvsmalloc_51
#define gk_imalloc gk_imalloc_51
#define gk_irand gk_irand_51
#define gk_irandArrayPermute gk_irandArrayPermute_51
#define gk_irandArrayPermuteFine gk_irandArrayPermuteFine_51
#define gk_irandInRange gk_irandInRange_51
#define gk_irealloc gk_irealloc_51
#define gk_iset gk_iset_51
#define gk_iSetMatrix gk_iSetMatrix_51
#define gk_ismalloc gk_ismalloc_51
#define gk_isrand gk_isrand_51
#define gk_jbuf gk_jbuf_51
#define gk_jbufs gk_jbufs_51
#define gk_malloc gk_malloc_51
#define gk_malloc_cleanup gk_malloc_cleanup_51
#define gk_malloc_init gk_malloc_init_51
#define gk_mcoreAdd gk_mcoreAdd_51
#define gk_mcoreCreate gk_mcoreCreate_51
#define gk_mcoreDel gk_mcoreDel_51
#define gk_mcoreDestroy gk_mcoreDestroy_51
#define gk_mcoreMalloc gk_mcoreMalloc_51
#define gk_mcorePop gk_mcorePop_51
#define gk_mcorePush gk_mcorePush_51
#define gk_mkpath gk_mkpath_51
#define gk_NonLocalExit_Handler gk_NonLocalExit_Handler_51
#define gk_randinit gk_randinit_51
#define gk_randint32 gk_randint32_51
#define gk_randint64 gk_randint64_51
#define gk_readfile gk_readfile_51
#define gk_realloc gk_realloc_51
#define gk_rmpath gk_rmpath_51
#define gk_set_exit_on_error gk_set_exit_on_error_51
#define gk_SetSignalHandlers gk_SetSignalHandlers_51
#define gk_sigthrow gk_sigthrow_51
#define gk_sigtrap gk_sigtrap_51
#define gk_siguntrap gk_siguntrap_51
#define gk_skvAllocMatrix gk_skvAllocMatrix_51
#define gk_skvcopy gk_skvcopy_51
#define gk_skvFreeMatrix gk_skvFreeMatrix_51
#define gk_skvmalloc gk_skvmalloc_51
#define gk_skvrealloc gk_skvrealloc_51
#define gk_skvset gk_skvset_51
#define gk_skvSetMatrix gk_skvSetMatrix_51
#define gk_skvsmalloc gk_skvsmalloc_51
#define gk_str2time gk_str2time_51
#define gk_strcasecmp gk_strcasecmp_51
#define gk_strchr_replace gk_strchr_replace_51
#define gk_strdup gk_strdup_51
#define gk_strerror gk_strerror_51
#define gk_strhprune gk_strhprune_51
#define gk_strrcmp gk_strrcmp_51
#define gk_strstr_replace gk_strstr_replace_51
#define gk_strtolower gk_strtolower_51
#define gk_strtoupper gk_strtoupper_51
#define gk_strtprune gk_strtprune_51
#define gk_time2str gk_time2str_51
#define gk_UnsetSignalHandlers gk_UnsetSignalHandlers_51
#define gk_WClockSeconds gk_WClockSeconds_51
#define gk_zAllocMatrix gk_zAllocMatrix_51
#define gk_zcopy gk_zcopy_51
#define gk_zFreeMatrix gk_zFreeMatrix_51
#define gk_zkvAllocMatrix gk_zkvAllocMatrix_51
#define gk_zkvcopy gk_zkvcopy_51
#define gk_zkvFreeMatrix gk_zkvFreeMatrix_51
#define gk_zkvmalloc gk_zkvmalloc_51
#define gk_zkvrealloc gk_zkvrealloc_51
#define gk_zkvset gk_zkvset_51
#define gk_zkvSetMatrix gk_zkvSetMatrix_51
#define gk_zkvsmalloc gk_zkvsmalloc_51
#define gk_zmalloc gk_zmalloc_51
#define gk_zrand gk_zrand_51
#define gk_zrandArrayPermute gk_zrandArrayPermute_51
#define gk_zrandArrayPermuteFine gk_zrandArrayPermuteFine_51
#define gk_zrandInRange gk_zrandInRange_51
#define gk_zrealloc gk_zrealloc_51
#define gk_zset gk_zset_51
#define gk_zSetMatrix gk_zSetMatrix_51
#define gk_zsmalloc gk_zsmalloc_51
#define gk_zsrand gk_zsrand_51
#define PrintBackTrace PrintBackTrace_51

#endif

#endif


