/*!
\file

 *
 * This file contains aliases for GKlib 5.2 procedures
 *
 * Nick Gould, STFC-RAL, 2025-03-19
 *
 */


#ifndef _LIBMETIS_GK_RENAME_H_
#define _LIBMETIS_GK_RENAME_H_

/* 64-bit integer procedures */

#ifdef INTEGER_64

#define errexit errexit_52_64
#define getpathname getpathname_52_64
#define gk_AllocMatrix gk_AllocMatrix_52_64
#define gk_cAllocMatrix gk_cAllocMatrix_52_64
#define gk_ccopy gk_ccopy_52_64
#define gk_cFreeMatrix gk_cFreeMatrix_52_64
#define gk_ckvAllocMatrix gk_ckvAllocMatrix_52_64
#define gk_ckvcopy gk_ckvcopy_52_64
#define gk_ckvFreeMatrix gk_ckvFreeMatrix_52_64
#define gk_ckvmalloc gk_ckvmalloc_52_64
#define gk_ckvrealloc gk_ckvrealloc_52_64
#define gk_ckvset gk_ckvset_52_64
#define gk_ckvSetMatrix gk_ckvSetMatrix_52_64
#define gk_ckvsmalloc gk_ckvsmalloc_52_64
#define gk_cmalloc gk_cmalloc_52_64
#define gk_CPUSeconds gk_CPUSeconds_52_64
#define gk_crand gk_crand_52_64
#define gk_crandArrayPermute gk_crandArrayPermute_52_64
#define gk_crandArrayPermuteFine gk_crandArrayPermuteFine_52_64
#define gk_crandInRange gk_crandInRange_52_64
#define gk_creadfilebin gk_creadfilebin_52_64
#define gk_crealloc gk_crealloc_52_64
#define gk_cset gk_cset_52_64
#define gk_cSetMatrix gk_cSetMatrix_52_64
#define gk_csmalloc gk_csmalloc_52_64
#define gk_csrand gk_csrand_52_64
#define gk_cur_jbufs gk_cur_jbufs_52_64
#define gk_cwritefilebin gk_cwritefilebin_52_64
#define gk_dAllocMatrix gk_dAllocMatrix_52_64
#define gk_dcopy gk_dcopy_52_64
#define gk_dexists gk_dexists_52_64
#define gk_dFreeMatrix gk_dFreeMatrix_52_64
#define gk_dkvAllocMatrix gk_dkvAllocMatrix_52_64
#define gk_dkvcopy gk_dkvcopy_52_64
#define gk_dkvFreeMatrix gk_dkvFreeMatrix_52_64
#define gk_dkvmalloc gk_dkvmalloc_52_64
#define gk_dkvrealloc gk_dkvrealloc_52_64
#define gk_dkvset gk_dkvset_52_64
#define gk_dkvSetMatrix gk_dkvSetMatrix_52_64
#define gk_dkvsmalloc gk_dkvsmalloc_52_64
#define gk_dmalloc gk_dmalloc_52_64
#define gk_drand gk_drand_52_64
#define gk_drandArrayPermute gk_drandArrayPermute_52_64
#define gk_drandArrayPermuteFine gk_drandArrayPermuteFine_52_64
#define gk_drandInRange gk_drandInRange_52_64
#define gk_dreadfilebin gk_dreadfilebin_52_64
#define gk_drealloc gk_drealloc_52_64
#define gk_dset gk_dset_52_64
#define gk_dSetMatrix gk_dSetMatrix_52_64
#define gk_dsmalloc gk_dsmalloc_52_64
#define gk_dsrand gk_dsrand_52_64
#define gk_dwritefilebin gk_dwritefilebin_52_64
#define gk_errexit gk_errexit_52_64
#define gk_fAllocMatrix gk_fAllocMatrix_52_64
#define gk_fclose gk_fclose_52_64
#define gk_fcopy gk_fcopy_52_64
#define gk_fexists gk_fexists_52_64
#define gk_fFreeMatrix gk_fFreeMatrix_52_64
#define gk_fkvAllocMatrix gk_fkvAllocMatrix_52_64
#define gk_fkvcopy gk_fkvcopy_52_64
#define gk_fkvFreeMatrix gk_fkvFreeMatrix_52_64
#define gk_fkvmalloc gk_fkvmalloc_52_64
#define gk_fkvrealloc gk_fkvrealloc_52_64
#define gk_fkvset gk_fkvset_52_64
#define gk_fkvSetMatrix gk_fkvSetMatrix_52_64
#define gk_fkvsmalloc gk_fkvsmalloc_52_64
#define gk_fmalloc gk_fmalloc_52_64
#define gkfooo gkfooo_52_64
#define gk_fopen gk_fopen_52_64
#define gk_frand gk_frand_52_64
#define gk_frandArrayPermute gk_frandArrayPermute_52_64
#define gk_frandArrayPermuteFine gk_frandArrayPermuteFine_52_64
#define gk_frandInRange gk_frandInRange_52_64
#define gk_freadfilebin gk_freadfilebin_52_64
#define gk_frealloc gk_frealloc_52_64
#define gk_free gk_free_52_64
#define gk_FreeMatrix gk_FreeMatrix_52_64
#define gk_fset gk_fset_52_64
#define gk_fSetMatrix gk_fSetMatrix_52_64
#define gk_fsmalloc gk_fsmalloc_52_64
#define gk_fsrand gk_fsrand_52_64
#define gk_fwritefilebin gk_fwritefilebin_52_64
#define gk_getbasename gk_getbasename_52_64
#define gk_GetCurMemoryUsed gk_GetCurMemoryUsed_52_64
#define gk_getextname gk_getextname_52_64
#define gk_getfilename gk_getfilename_52_64
#define gk_getfilestats gk_getfilestats_52_64
#define gk_getfsize gk_getfsize_52_64
#define gk_getline gk_getline_52_64
#define gk_GetMaxMemoryUsed gk_GetMaxMemoryUsed_52_64
#define gk_GetProcVmPeak gk_GetProcVmPeak_52_64
#define gk_GetStringID gk_GetStringID_52_64
#define gk_GetVMInfo gk_GetVMInfo_52_64
#define gk_gkmcoreAdd gk_gkmcoreAdd_52_64
#define gk_gkmcoreCreate gk_gkmcoreCreate_52_64
#define gk_gkmcoreDel gk_gkmcoreDel_52_64
#define gk_gkmcoreDestroy gk_gkmcoreDestroy_52_64
#define gk_gkmcorePop gk_gkmcorePop_52_64
#define gk_gkmcorePush gk_gkmcorePush_52_64
#define gk_i16AllocMatrix gk_i16AllocMatrix_52_64
#define gk_i16copy gk_i16copy_52_64
#define gk_i16FreeMatrix gk_i16FreeMatrix_52_64
#define gk_i16kvAllocMatrix gk_i16kvAllocMatrix_52_64
#define gk_i16kvcopy gk_i16kvcopy_52_64
#define gk_i16kvFreeMatrix gk_i16kvFreeMatrix_52_64
#define gk_i16kvmalloc gk_i16kvmalloc_52_64
#define gk_i16kvrealloc gk_i16kvrealloc_52_64
#define gk_i16kvset gk_i16kvset_52_64
#define gk_i16kvSetMatrix gk_i16kvSetMatrix_52_64
#define gk_i16kvsmalloc gk_i16kvsmalloc_52_64
#define gk_i16malloc gk_i16malloc_52_64
#define gk_i16realloc gk_i16realloc_52_64
#define gk_i16set gk_i16set_52_64
#define gk_i16SetMatrix gk_i16SetMatrix_52_64
#define gk_i16smalloc gk_i16smalloc_52_64
#define gk_i32AllocMatrix gk_i32AllocMatrix_52_64
#define gk_i32copy gk_i32copy_52_64
#define gk_i32FreeMatrix gk_i32FreeMatrix_52_64
#define gk_i32kvAllocMatrix gk_i32kvAllocMatrix_52_64
#define gk_i32kvcopy gk_i32kvcopy_52_64
#define gk_i32kvFreeMatrix gk_i32kvFreeMatrix_52_64
#define gk_i32kvmalloc gk_i32kvmalloc_52_64
#define gk_i32kvrealloc gk_i32kvrealloc_52_64
#define gk_i32kvset gk_i32kvset_52_64
#define gk_i32kvSetMatrix gk_i32kvSetMatrix_52_64
#define gk_i32kvsmalloc gk_i32kvsmalloc_52_64
#define gk_i32malloc gk_i32malloc_52_64
#define gk_i32rand gk_i32rand_52_64
#define gk_i32randArrayPermute gk_i32randArrayPermute_52_64
#define gk_i32randArrayPermuteFine gk_i32randArrayPermuteFine_52_64
#define gk_i32randInRange gk_i32randInRange_52_64
#define gk_i32readfile gk_i32readfile_52_64
#define gk_i32readfilebin gk_i32readfilebin_52_64
#define gk_i32realloc gk_i32realloc_52_64
#define gk_i32set gk_i32set_52_64
#define gk_i32SetMatrix gk_i32SetMatrix_52_64
#define gk_i32smalloc gk_i32smalloc_52_64
#define gk_i32srand gk_i32srand_52_64
#define gk_i32writefilebin gk_i32writefilebin_52_64
#define gk_i64AllocMatrix gk_i64AllocMatrix_52_64
#define gk_i64copy gk_i64copy_52_64
#define gk_i64FreeMatrix gk_i64FreeMatrix_52_64
#define gk_i64kvAllocMatrix gk_i64kvAllocMatrix_52_64
#define gk_i64kvcopy gk_i64kvcopy_52_64
#define gk_i64kvFreeMatrix gk_i64kvFreeMatrix_52_64
#define gk_i64kvmalloc gk_i64kvmalloc_52_64
#define gk_i64kvrealloc gk_i64kvrealloc_52_64
#define gk_i64kvset gk_i64kvset_52_64
#define gk_i64kvSetMatrix gk_i64kvSetMatrix_52_64
#define gk_i64kvsmalloc gk_i64kvsmalloc_52_64
#define gk_i64malloc gk_i64malloc_52_64
#define gk_i64readfile gk_i64readfile_52_64
#define gk_i64readfilebin gk_i64readfilebin_52_64
#define gk_i64realloc gk_i64realloc_52_64
#define gk_i64set gk_i64set_52_64
#define gk_i64SetMatrix gk_i64SetMatrix_52_64
#define gk_i64smalloc gk_i64smalloc_52_64
#define gk_i64writefilebin gk_i64writefilebin_52_64
#define gk_i8AllocMatrix gk_i8AllocMatrix_52_64
#define gk_i8copy gk_i8copy_52_64
#define gk_i8FreeMatrix gk_i8FreeMatrix_52_64
#define gk_i8kvAllocMatrix gk_i8kvAllocMatrix_52_64
#define gk_i8kvcopy gk_i8kvcopy_52_64
#define gk_i8kvFreeMatrix gk_i8kvFreeMatrix_52_64
#define gk_i8kvmalloc gk_i8kvmalloc_52_64
#define gk_i8kvrealloc gk_i8kvrealloc_52_64
#define gk_i8kvset gk_i8kvset_52_64
#define gk_i8kvSetMatrix gk_i8kvSetMatrix_52_64
#define gk_i8kvsmalloc gk_i8kvsmalloc_52_64
#define gk_i8malloc gk_i8malloc_52_64
#define gk_i8realloc gk_i8realloc_52_64
#define gk_i8set gk_i8set_52_64
#define gk_i8SetMatrix gk_i8SetMatrix_52_64
#define gk_i8smalloc gk_i8smalloc_52_64
#define gk_iAllocMatrix gk_iAllocMatrix_52_64
#define gk_icopy gk_icopy_52_64
#define gk_idxAllocMatrix gk_idxAllocMatrix_52_64
#define gk_idxcopy gk_idxcopy_52_64
#define gk_idxFreeMatrix gk_idxFreeMatrix_52_64
#define gk_idxkvAllocMatrix gk_idxkvAllocMatrix_52_64
#define gk_idxkvcopy gk_idxkvcopy_52_64
#define gk_idxkvFreeMatrix gk_idxkvFreeMatrix_52_64
#define gk_idxkvmalloc gk_idxkvmalloc_52_64
#define gk_idxkvrealloc gk_idxkvrealloc_52_64
#define gk_idxkvset gk_idxkvset_52_64
#define gk_idxkvSetMatrix gk_idxkvSetMatrix_52_64
#define gk_idxkvsmalloc gk_idxkvsmalloc_52_64
#define gk_idxmalloc gk_idxmalloc_52_64
#define gk_idxrand gk_idxrand_52_64
#define gk_idxrandArrayPermute gk_idxrandArrayPermute_52_64
#define gk_idxrandArrayPermuteFine gk_idxrandArrayPermuteFine_52_64
#define gk_idxrandInRange gk_idxrandInRange_52_64
#define gk_idxrealloc gk_idxrealloc_52_64
#define gk_idxset gk_idxset_52_64
#define gk_idxSetMatrix gk_idxSetMatrix_52_64
#define gk_idxsmalloc gk_idxsmalloc_52_64
#define gk_idxsrand gk_idxsrand_52_64
#define gk_iFreeMatrix gk_iFreeMatrix_52_64
#define gk_ikvAllocMatrix gk_ikvAllocMatrix_52_64
#define gk_ikvcopy gk_ikvcopy_52_64
#define gk_ikvFreeMatrix gk_ikvFreeMatrix_52_64
#define gk_ikvmalloc gk_ikvmalloc_52_64
#define gk_ikvrealloc gk_ikvrealloc_52_64
#define gk_ikvset gk_ikvset_52_64
#define gk_ikvSetMatrix gk_ikvSetMatrix_52_64
#define gk_ikvsmalloc gk_ikvsmalloc_52_64
#define gk_imalloc gk_imalloc_52_64
#define gk_irand gk_irand_52_64
#define gk_irandArrayPermute gk_irandArrayPermute_52_64
#define gk_irandArrayPermuteFine gk_irandArrayPermuteFine_52_64
#define gk_irandInRange gk_irandInRange_52_64
#define gk_irealloc gk_irealloc_52_64
#define gk_iset gk_iset_52_64
#define gk_iSetMatrix gk_iSetMatrix_52_64
#define gk_ismalloc gk_ismalloc_52_64
#define gk_isrand gk_isrand_52_64
#define gk_jbuf gk_jbuf_52_64
#define gk_jbufs gk_jbufs_52_64
#define gk_malloc gk_malloc_52_64
#define gk_malloc_cleanup gk_malloc_cleanup_52_64
#define gk_malloc_init gk_malloc_init_52_64
#define gk_mcoreAdd gk_mcoreAdd_52_64
#define gk_mcoreCreate gk_mcoreCreate_52_64
#define gk_mcoreDel gk_mcoreDel_52_64
#define gk_mcoreDestroy gk_mcoreDestroy_52_64
#define gk_mcoreMalloc gk_mcoreMalloc_52_64
#define gk_mcorePop gk_mcorePop_52_64
#define gk_mcorePush gk_mcorePush_52_64
#define gk_mkpath gk_mkpath_52_64
#define gk_NonLocalExit_Handler gk_NonLocalExit_Handler_52_64
#define gk_randinit gk_randinit_52_64
#define gk_randint32 gk_randint32_52_64
#define gk_randint64 gk_randint64_52_64
#define gk_readfile gk_readfile_52_64
#define gk_realloc gk_realloc_52_64
#define gk_rmpath gk_rmpath_52_64
#define gk_set_exit_on_error gk_set_exit_on_error_52_64
#define gk_SetSignalHandlers gk_SetSignalHandlers_52_64
#define gk_sigthrow gk_sigthrow_52_64
#define gk_sigtrap gk_sigtrap_52_64
#define gk_siguntrap gk_siguntrap_52_64
#define gk_skvAllocMatrix gk_skvAllocMatrix_52_64
#define gk_skvcopy gk_skvcopy_52_64
#define gk_skvFreeMatrix gk_skvFreeMatrix_52_64
#define gk_skvmalloc gk_skvmalloc_52_64
#define gk_skvrealloc gk_skvrealloc_52_64
#define gk_skvset gk_skvset_52_64
#define gk_skvSetMatrix gk_skvSetMatrix_52_64
#define gk_skvsmalloc gk_skvsmalloc_52_64
#define gk_str2time gk_str2time_52_64
#define gk_strcasecmp gk_strcasecmp_52_64
#define gk_strchr_replace gk_strchr_replace_52_64
#define gk_strdup gk_strdup_52_64
#define gk_strerror gk_strerror_52_64
#define gk_strhprune gk_strhprune_52_64
#define gk_strrcmp gk_strrcmp_52_64
#define gk_strstr_replace gk_strstr_replace_52_64
#define gk_strtolower gk_strtolower_52_64
#define gk_strtoupper gk_strtoupper_52_64
#define gk_strtprune gk_strtprune_52_64
#define gk_time2str gk_time2str_52_64
#define gk_ui16AllocMatrix gk_ui16AllocMatrix_52_64
#define gk_ui16copy gk_ui16copy_52_64
#define gk_ui16FreeMatrix gk_ui16FreeMatrix_52_64
#define gk_ui16malloc gk_ui16malloc_52_64
#define gk_ui16realloc gk_ui16realloc_52_64
#define gk_ui16set gk_ui16set_52_64
#define gk_ui16SetMatrix gk_ui16SetMatrix_52_64
#define gk_ui16smalloc gk_ui16smalloc_52_64
#define gk_ui32AllocMatrix gk_ui32AllocMatrix_52_64
#define gk_ui32copy gk_ui32copy_52_64
#define gk_ui32FreeMatrix gk_ui32FreeMatrix_52_64
#define gk_ui32malloc gk_ui32malloc_52_64
#define gk_ui32realloc gk_ui32realloc_52_64
#define gk_ui32set gk_ui32set_52_64
#define gk_ui32SetMatrix gk_ui32SetMatrix_52_64
#define gk_ui32smalloc gk_ui32smalloc_52_64
#define gk_ui64AllocMatrix gk_ui64AllocMatrix_52_64
#define gk_ui64copy gk_ui64copy_52_64
#define gk_ui64FreeMatrix gk_ui64FreeMatrix_52_64
#define gk_ui64malloc gk_ui64malloc_52_64
#define gk_ui64realloc gk_ui64realloc_52_64
#define gk_ui64set gk_ui64set_52_64
#define gk_ui64SetMatrix gk_ui64SetMatrix_52_64
#define gk_ui64smalloc gk_ui64smalloc_52_64
#define gk_ui8AllocMatrix gk_ui8AllocMatrix_52_64
#define gk_ui8copy gk_ui8copy_52_64
#define gk_ui8FreeMatrix gk_ui8FreeMatrix_52_64
#define gk_ui8malloc gk_ui8malloc_52_64
#define gk_ui8realloc gk_ui8realloc_52_64
#define gk_ui8set gk_ui8set_52_64
#define gk_ui8SetMatrix gk_ui8SetMatrix_52_64
#define gk_ui8smalloc gk_ui8smalloc_52_64
#define gk_UnsetSignalHandlers gk_UnsetSignalHandlers_52_64
#define gk_WClockSeconds gk_WClockSeconds_52_64
#define gk_zAllocMatrix gk_zAllocMatrix_52_64
#define gk_zcopy gk_zcopy_52_64
#define gk_zFreeMatrix gk_zFreeMatrix_52_64
#define gk_zkvAllocMatrix gk_zkvAllocMatrix_52_64
#define gk_zkvcopy gk_zkvcopy_52_64
#define gk_zkvFreeMatrix gk_zkvFreeMatrix_52_64
#define gk_zkvmalloc gk_zkvmalloc_52_64
#define gk_zkvrealloc gk_zkvrealloc_52_64
#define gk_zkvset gk_zkvset_52_64
#define gk_zkvSetMatrix gk_zkvSetMatrix_52_64
#define gk_zkvsmalloc gk_zkvsmalloc_52_64
#define gk_zmalloc gk_zmalloc_52_64
#define gk_zrand gk_zrand_52_64
#define gk_zrandArrayPermute gk_zrandArrayPermute_52_64
#define gk_zrandArrayPermuteFine gk_zrandArrayPermuteFine_52_64
#define gk_zrandInRange gk_zrandInRange_52_64
#define gk_zreadfile gk_zreadfile_52_64
#define gk_zreadfilebin gk_zreadfilebin_52_64
#define gk_zrealloc gk_zrealloc_52_64
#define gk_zset gk_zset_52_64
#define gk_zSetMatrix gk_zSetMatrix_52_64
#define gk_zsmalloc gk_zsmalloc_52_64
#define gk_zsrand gk_zsrand_52_64
#define gk_zuAllocMatrix gk_zuAllocMatrix_52_64
#define gk_zucopy gk_zucopy_52_64
#define gk_zuFreeMatrix gk_zuFreeMatrix_52_64
#define gk_zukvAllocMatrix gk_zukvAllocMatrix_52_64
#define gk_zukvcopy gk_zukvcopy_52_64
#define gk_zukvFreeMatrix gk_zukvFreeMatrix_52_64
#define gk_zukvmalloc gk_zukvmalloc_52_64
#define gk_zukvrealloc gk_zukvrealloc_52_64
#define gk_zukvset gk_zukvset_52_64
#define gk_zukvSetMatrix gk_zukvSetMatrix_52_64
#define gk_zukvsmalloc gk_zukvsmalloc_52_64
#define gk_zumalloc gk_zumalloc_52_64
#define gk_zurand gk_zurand_52_64
#define gk_zurandArrayPermute gk_zurandArrayPermute_52_64
#define gk_zurandArrayPermuteFine gk_zurandArrayPermuteFine_52_64
#define gk_zurandInRange gk_zurandInRange_52_64
#define gk_zurealloc gk_zurealloc_52_64
#define gk_zuset gk_zuset_52_64
#define gk_zuSetMatrix gk_zuSetMatrix_52_64
#define gk_zusmalloc gk_zusmalloc_52_64
#define gk_zusrand gk_zusrand_52_64
#define gk_zwritefilebin gk_zwritefilebin_52_64
#define PrintBackTrace PrintBackTrace_52_64

/* 32-bit integer procedures */

#else

#define errexit errexit_52
#define getpathname getpathname_52
#define gk_AllocMatrix gk_AllocMatrix_52
#define gk_cAllocMatrix gk_cAllocMatrix_52
#define gk_ccopy gk_ccopy_52
#define gk_cFreeMatrix gk_cFreeMatrix_52
#define gk_ckvAllocMatrix gk_ckvAllocMatrix_52
#define gk_ckvcopy gk_ckvcopy_52
#define gk_ckvFreeMatrix gk_ckvFreeMatrix_52
#define gk_ckvmalloc gk_ckvmalloc_52
#define gk_ckvrealloc gk_ckvrealloc_52
#define gk_ckvset gk_ckvset_52
#define gk_ckvSetMatrix gk_ckvSetMatrix_52
#define gk_ckvsmalloc gk_ckvsmalloc_52
#define gk_cmalloc gk_cmalloc_52
#define gk_CPUSeconds gk_CPUSeconds_52
#define gk_crand gk_crand_52
#define gk_crandArrayPermute gk_crandArrayPermute_52
#define gk_crandArrayPermuteFine gk_crandArrayPermuteFine_52
#define gk_crandInRange gk_crandInRange_52
#define gk_creadfilebin gk_creadfilebin_52
#define gk_crealloc gk_crealloc_52
#define gk_cset gk_cset_52
#define gk_cSetMatrix gk_cSetMatrix_52
#define gk_csmalloc gk_csmalloc_52
#define gk_csrand gk_csrand_52
#define gk_cur_jbufs gk_cur_jbufs_52
#define gk_cwritefilebin gk_cwritefilebin_52
#define gk_dAllocMatrix gk_dAllocMatrix_52
#define gk_dcopy gk_dcopy_52
#define gk_dexists gk_dexists_52
#define gk_dFreeMatrix gk_dFreeMatrix_52
#define gk_dkvAllocMatrix gk_dkvAllocMatrix_52
#define gk_dkvcopy gk_dkvcopy_52
#define gk_dkvFreeMatrix gk_dkvFreeMatrix_52
#define gk_dkvmalloc gk_dkvmalloc_52
#define gk_dkvrealloc gk_dkvrealloc_52
#define gk_dkvset gk_dkvset_52
#define gk_dkvSetMatrix gk_dkvSetMatrix_52
#define gk_dkvsmalloc gk_dkvsmalloc_52
#define gk_dmalloc gk_dmalloc_52
#define gk_drand gk_drand_52
#define gk_drandArrayPermute gk_drandArrayPermute_52
#define gk_drandArrayPermuteFine gk_drandArrayPermuteFine_52
#define gk_drandInRange gk_drandInRange_52
#define gk_dreadfilebin gk_dreadfilebin_52
#define gk_drealloc gk_drealloc_52
#define gk_dset gk_dset_52
#define gk_dSetMatrix gk_dSetMatrix_52
#define gk_dsmalloc gk_dsmalloc_52
#define gk_dsrand gk_dsrand_52
#define gk_dwritefilebin gk_dwritefilebin_52
#define gk_errexit gk_errexit_52
#define gk_fAllocMatrix gk_fAllocMatrix_52
#define gk_fclose gk_fclose_52
#define gk_fcopy gk_fcopy_52
#define gk_fexists gk_fexists_52
#define gk_fFreeMatrix gk_fFreeMatrix_52
#define gk_fkvAllocMatrix gk_fkvAllocMatrix_52
#define gk_fkvcopy gk_fkvcopy_52
#define gk_fkvFreeMatrix gk_fkvFreeMatrix_52
#define gk_fkvmalloc gk_fkvmalloc_52
#define gk_fkvrealloc gk_fkvrealloc_52
#define gk_fkvset gk_fkvset_52
#define gk_fkvSetMatrix gk_fkvSetMatrix_52
#define gk_fkvsmalloc gk_fkvsmalloc_52
#define gk_fmalloc gk_fmalloc_52
#define gkfooo gkfooo_52
#define gk_fopen gk_fopen_52
#define gk_frand gk_frand_52
#define gk_frandArrayPermute gk_frandArrayPermute_52
#define gk_frandArrayPermuteFine gk_frandArrayPermuteFine_52
#define gk_frandInRange gk_frandInRange_52
#define gk_freadfilebin gk_freadfilebin_52
#define gk_frealloc gk_frealloc_52
#define gk_free gk_free_52
#define gk_FreeMatrix gk_FreeMatrix_52
#define gk_fset gk_fset_52
#define gk_fSetMatrix gk_fSetMatrix_52
#define gk_fsmalloc gk_fsmalloc_52
#define gk_fsrand gk_fsrand_52
#define gk_fwritefilebin gk_fwritefilebin_52
#define gk_getbasename gk_getbasename_52
#define gk_GetCurMemoryUsed gk_GetCurMemoryUsed_52
#define gk_getextname gk_getextname_52
#define gk_getfilename gk_getfilename_52
#define gk_getfilestats gk_getfilestats_52
#define gk_getfsize gk_getfsize_52
#define gk_getline gk_getline_52
#define gk_GetMaxMemoryUsed gk_GetMaxMemoryUsed_52
#define gk_GetProcVmPeak gk_GetProcVmPeak_52
#define gk_GetStringID gk_GetStringID_52
#define gk_GetVMInfo gk_GetVMInfo_52
#define gk_gkmcoreAdd gk_gkmcoreAdd_52
#define gk_gkmcoreCreate gk_gkmcoreCreate_52
#define gk_gkmcoreDel gk_gkmcoreDel_52
#define gk_gkmcoreDestroy gk_gkmcoreDestroy_52
#define gk_gkmcorePop gk_gkmcorePop_52
#define gk_gkmcorePush gk_gkmcorePush_52
#define gk_i16AllocMatrix gk_i16AllocMatrix_52
#define gk_i16copy gk_i16copy_52
#define gk_i16FreeMatrix gk_i16FreeMatrix_52
#define gk_i16kvAllocMatrix gk_i16kvAllocMatrix_52
#define gk_i16kvcopy gk_i16kvcopy_52
#define gk_i16kvFreeMatrix gk_i16kvFreeMatrix_52
#define gk_i16kvmalloc gk_i16kvmalloc_52
#define gk_i16kvrealloc gk_i16kvrealloc_52
#define gk_i16kvset gk_i16kvset_52
#define gk_i16kvSetMatrix gk_i16kvSetMatrix_52
#define gk_i16kvsmalloc gk_i16kvsmalloc_52
#define gk_i16malloc gk_i16malloc_52
#define gk_i16realloc gk_i16realloc_52
#define gk_i16set gk_i16set_52
#define gk_i16SetMatrix gk_i16SetMatrix_52
#define gk_i16smalloc gk_i16smalloc_52
#define gk_i32AllocMatrix gk_i32AllocMatrix_52
#define gk_i32copy gk_i32copy_52
#define gk_i32FreeMatrix gk_i32FreeMatrix_52
#define gk_i32kvAllocMatrix gk_i32kvAllocMatrix_52
#define gk_i32kvcopy gk_i32kvcopy_52
#define gk_i32kvFreeMatrix gk_i32kvFreeMatrix_52
#define gk_i32kvmalloc gk_i32kvmalloc_52
#define gk_i32kvrealloc gk_i32kvrealloc_52
#define gk_i32kvset gk_i32kvset_52
#define gk_i32kvSetMatrix gk_i32kvSetMatrix_52
#define gk_i32kvsmalloc gk_i32kvsmalloc_52
#define gk_i32malloc gk_i32malloc_52
#define gk_i32rand gk_i32rand_52
#define gk_i32randArrayPermute gk_i32randArrayPermute_52
#define gk_i32randArrayPermuteFine gk_i32randArrayPermuteFine_52
#define gk_i32randInRange gk_i32randInRange_52
#define gk_i32readfile gk_i32readfile_52
#define gk_i32readfilebin gk_i32readfilebin_52
#define gk_i32realloc gk_i32realloc_52
#define gk_i32set gk_i32set_52
#define gk_i32SetMatrix gk_i32SetMatrix_52
#define gk_i32smalloc gk_i32smalloc_52
#define gk_i32srand gk_i32srand_52
#define gk_i32writefilebin gk_i32writefilebin_52
#define gk_i64AllocMatrix gk_i64AllocMatrix_52
#define gk_i64copy gk_i64copy_52
#define gk_i64FreeMatrix gk_i64FreeMatrix_52
#define gk_i64kvAllocMatrix gk_i64kvAllocMatrix_52
#define gk_i64kvcopy gk_i64kvcopy_52
#define gk_i64kvFreeMatrix gk_i64kvFreeMatrix_52
#define gk_i64kvmalloc gk_i64kvmalloc_52
#define gk_i64kvrealloc gk_i64kvrealloc_52
#define gk_i64kvset gk_i64kvset_52
#define gk_i64kvSetMatrix gk_i64kvSetMatrix_52
#define gk_i64kvsmalloc gk_i64kvsmalloc_52
#define gk_i64malloc gk_i64malloc_52
#define gk_i64readfile gk_i64readfile_52
#define gk_i64readfilebin gk_i64readfilebin_52
#define gk_i64realloc gk_i64realloc_52
#define gk_i64set gk_i64set_52
#define gk_i64SetMatrix gk_i64SetMatrix_52
#define gk_i64smalloc gk_i64smalloc_52
#define gk_i64writefilebin gk_i64writefilebin_52
#define gk_i8AllocMatrix gk_i8AllocMatrix_52
#define gk_i8copy gk_i8copy_52
#define gk_i8FreeMatrix gk_i8FreeMatrix_52
#define gk_i8kvAllocMatrix gk_i8kvAllocMatrix_52
#define gk_i8kvcopy gk_i8kvcopy_52
#define gk_i8kvFreeMatrix gk_i8kvFreeMatrix_52
#define gk_i8kvmalloc gk_i8kvmalloc_52
#define gk_i8kvrealloc gk_i8kvrealloc_52
#define gk_i8kvset gk_i8kvset_52
#define gk_i8kvSetMatrix gk_i8kvSetMatrix_52
#define gk_i8kvsmalloc gk_i8kvsmalloc_52
#define gk_i8malloc gk_i8malloc_52
#define gk_i8realloc gk_i8realloc_52
#define gk_i8set gk_i8set_52
#define gk_i8SetMatrix gk_i8SetMatrix_52
#define gk_i8smalloc gk_i8smalloc_52
#define gk_iAllocMatrix gk_iAllocMatrix_52
#define gk_icopy gk_icopy_52
#define gk_idxAllocMatrix gk_idxAllocMatrix_52
#define gk_idxcopy gk_idxcopy_52
#define gk_idxFreeMatrix gk_idxFreeMatrix_52
#define gk_idxkvAllocMatrix gk_idxkvAllocMatrix_52
#define gk_idxkvcopy gk_idxkvcopy_52
#define gk_idxkvFreeMatrix gk_idxkvFreeMatrix_52
#define gk_idxkvmalloc gk_idxkvmalloc_52
#define gk_idxkvrealloc gk_idxkvrealloc_52
#define gk_idxkvset gk_idxkvset_52
#define gk_idxkvSetMatrix gk_idxkvSetMatrix_52
#define gk_idxkvsmalloc gk_idxkvsmalloc_52
#define gk_idxmalloc gk_idxmalloc_52
#define gk_idxrand gk_idxrand_52
#define gk_idxrandArrayPermute gk_idxrandArrayPermute_52
#define gk_idxrandArrayPermuteFine gk_idxrandArrayPermuteFine_52
#define gk_idxrandInRange gk_idxrandInRange_52
#define gk_idxrealloc gk_idxrealloc_52
#define gk_idxset gk_idxset_52
#define gk_idxSetMatrix gk_idxSetMatrix_52
#define gk_idxsmalloc gk_idxsmalloc_52
#define gk_idxsrand gk_idxsrand_52
#define gk_iFreeMatrix gk_iFreeMatrix_52
#define gk_ikvAllocMatrix gk_ikvAllocMatrix_52
#define gk_ikvcopy gk_ikvcopy_52
#define gk_ikvFreeMatrix gk_ikvFreeMatrix_52
#define gk_ikvmalloc gk_ikvmalloc_52
#define gk_ikvrealloc gk_ikvrealloc_52
#define gk_ikvset gk_ikvset_52
#define gk_ikvSetMatrix gk_ikvSetMatrix_52
#define gk_ikvsmalloc gk_ikvsmalloc_52
#define gk_imalloc gk_imalloc_52
#define gk_irand gk_irand_52
#define gk_irandArrayPermute gk_irandArrayPermute_52
#define gk_irandArrayPermuteFine gk_irandArrayPermuteFine_52
#define gk_irandInRange gk_irandInRange_52
#define gk_irealloc gk_irealloc_52
#define gk_iset gk_iset_52
#define gk_iSetMatrix gk_iSetMatrix_52
#define gk_ismalloc gk_ismalloc_52
#define gk_isrand gk_isrand_52
#define gk_jbuf gk_jbuf_52
#define gk_jbufs gk_jbufs_52
#define gk_malloc gk_malloc_52
#define gk_malloc_cleanup gk_malloc_cleanup_52
#define gk_malloc_init gk_malloc_init_52
#define gk_mcoreAdd gk_mcoreAdd_52
#define gk_mcoreCreate gk_mcoreCreate_52
#define gk_mcoreDel gk_mcoreDel_52
#define gk_mcoreDestroy gk_mcoreDestroy_52
#define gk_mcoreMalloc gk_mcoreMalloc_52
#define gk_mcorePop gk_mcorePop_52
#define gk_mcorePush gk_mcorePush_52
#define gk_mkpath gk_mkpath_52
#define gk_NonLocalExit_Handler gk_NonLocalExit_Handler_52
#define gk_randinit gk_randinit_52
#define gk_randint32 gk_randint32_52
#define gk_randint64 gk_randint64_52
#define gk_readfile gk_readfile_52
#define gk_realloc gk_realloc_52
#define gk_rmpath gk_rmpath_52
#define gk_set_exit_on_error gk_set_exit_on_error_52
#define gk_SetSignalHandlers gk_SetSignalHandlers_52
#define gk_sigthrow gk_sigthrow_52
#define gk_sigtrap gk_sigtrap_52
#define gk_siguntrap gk_siguntrap_52
#define gk_skvAllocMatrix gk_skvAllocMatrix_52
#define gk_skvcopy gk_skvcopy_52
#define gk_skvFreeMatrix gk_skvFreeMatrix_52
#define gk_skvmalloc gk_skvmalloc_52
#define gk_skvrealloc gk_skvrealloc_52
#define gk_skvset gk_skvset_52
#define gk_skvSetMatrix gk_skvSetMatrix_52
#define gk_skvsmalloc gk_skvsmalloc_52
#define gk_str2time gk_str2time_52
#define gk_strcasecmp gk_strcasecmp_52
#define gk_strchr_replace gk_strchr_replace_52
#define gk_strdup gk_strdup_52
#define gk_strerror gk_strerror_52
#define gk_strhprune gk_strhprune_52
#define gk_strrcmp gk_strrcmp_52
#define gk_strstr_replace gk_strstr_replace_52
#define gk_strtolower gk_strtolower_52
#define gk_strtoupper gk_strtoupper_52
#define gk_strtprune gk_strtprune_52
#define gk_time2str gk_time2str_52
#define gk_ui16AllocMatrix gk_ui16AllocMatrix_52
#define gk_ui16copy gk_ui16copy_52
#define gk_ui16FreeMatrix gk_ui16FreeMatrix_52
#define gk_ui16malloc gk_ui16malloc_52
#define gk_ui16realloc gk_ui16realloc_52
#define gk_ui16set gk_ui16set_52
#define gk_ui16SetMatrix gk_ui16SetMatrix_52
#define gk_ui16smalloc gk_ui16smalloc_52
#define gk_ui32AllocMatrix gk_ui32AllocMatrix_52
#define gk_ui32copy gk_ui32copy_52
#define gk_ui32FreeMatrix gk_ui32FreeMatrix_52
#define gk_ui32malloc gk_ui32malloc_52
#define gk_ui32realloc gk_ui32realloc_52
#define gk_ui32set gk_ui32set_52
#define gk_ui32SetMatrix gk_ui32SetMatrix_52
#define gk_ui32smalloc gk_ui32smalloc_52
#define gk_ui64AllocMatrix gk_ui64AllocMatrix_52
#define gk_ui64copy gk_ui64copy_52
#define gk_ui64FreeMatrix gk_ui64FreeMatrix_52
#define gk_ui64malloc gk_ui64malloc_52
#define gk_ui64realloc gk_ui64realloc_52
#define gk_ui64set gk_ui64set_52
#define gk_ui64SetMatrix gk_ui64SetMatrix_52
#define gk_ui64smalloc gk_ui64smalloc_52
#define gk_ui8AllocMatrix gk_ui8AllocMatrix_52
#define gk_ui8copy gk_ui8copy_52
#define gk_ui8FreeMatrix gk_ui8FreeMatrix_52
#define gk_ui8malloc gk_ui8malloc_52
#define gk_ui8realloc gk_ui8realloc_52
#define gk_ui8set gk_ui8set_52
#define gk_ui8SetMatrix gk_ui8SetMatrix_52
#define gk_ui8smalloc gk_ui8smalloc_52
#define gk_UnsetSignalHandlers gk_UnsetSignalHandlers_52
#define gk_WClockSeconds gk_WClockSeconds_52
#define gk_zAllocMatrix gk_zAllocMatrix_52
#define gk_zcopy gk_zcopy_52
#define gk_zFreeMatrix gk_zFreeMatrix_52
#define gk_zkvAllocMatrix gk_zkvAllocMatrix_52
#define gk_zkvcopy gk_zkvcopy_52
#define gk_zkvFreeMatrix gk_zkvFreeMatrix_52
#define gk_zkvmalloc gk_zkvmalloc_52
#define gk_zkvrealloc gk_zkvrealloc_52
#define gk_zkvset gk_zkvset_52
#define gk_zkvSetMatrix gk_zkvSetMatrix_52
#define gk_zkvsmalloc gk_zkvsmalloc_52
#define gk_zmalloc gk_zmalloc_52
#define gk_zrand gk_zrand_52
#define gk_zrandArrayPermute gk_zrandArrayPermute_52
#define gk_zrandArrayPermuteFine gk_zrandArrayPermuteFine_52
#define gk_zrandInRange gk_zrandInRange_52
#define gk_zreadfile gk_zreadfile_52
#define gk_zreadfilebin gk_zreadfilebin_52
#define gk_zrealloc gk_zrealloc_52
#define gk_zset gk_zset_52
#define gk_zSetMatrix gk_zSetMatrix_52
#define gk_zsmalloc gk_zsmalloc_52
#define gk_zsrand gk_zsrand_52
#define gk_zuAllocMatrix gk_zuAllocMatrix_52
#define gk_zucopy gk_zucopy_52
#define gk_zuFreeMatrix gk_zuFreeMatrix_52
#define gk_zukvAllocMatrix gk_zukvAllocMatrix_52
#define gk_zukvcopy gk_zukvcopy_52
#define gk_zukvFreeMatrix gk_zukvFreeMatrix_52
#define gk_zukvmalloc gk_zukvmalloc_52
#define gk_zukvrealloc gk_zukvrealloc_52
#define gk_zukvset gk_zukvset_52
#define gk_zukvSetMatrix gk_zukvSetMatrix_52
#define gk_zukvsmalloc gk_zukvsmalloc_52
#define gk_zumalloc gk_zumalloc_52
#define gk_zurand gk_zurand_52
#define gk_zurandArrayPermute gk_zurandArrayPermute_52
#define gk_zurandArrayPermuteFine gk_zurandArrayPermuteFine_52
#define gk_zurandInRange gk_zurandInRange_52
#define gk_zurealloc gk_zurealloc_52
#define gk_zuset gk_zuset_52
#define gk_zuSetMatrix gk_zuSetMatrix_52
#define gk_zusmalloc gk_zusmalloc_52
#define gk_zusrand gk_zusrand_52
#define gk_zwritefilebin gk_zwritefilebin_52
#define PrintBackTrace PrintBackTrace_52

#endif

#endif


